#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2023 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

from ..column import ColumnAttr

class ColumnCalendar(ColumnAttr):
    """The calendar definition"""
    # Usage example: slot start in minute and duration.
    default_value = '''202305020800:120 202305021000:120 202305021400:120 202305021600:120
202305030800:120 202305031100:120 202305031500:60 202305031700:120
202305040800:120 202305041000:120                  202305041600:120
202305050800:120 202305051000:120 202305051400:120
202305080800:120 202305081000:120 202305081400:120 202305081600:60 202305081700:60'''
    name = 'calendar'
    gui_display = "GUI_a"
    action = "calendar_configure"
    check_and_set = 'set_calendar'
    display_table = 1
    css = """
#the_calendar { position: relative; font-size: 70%}
.calendar_big:hover { position: absolute; z-index: 60000; background: #FFF} /* For Safari */
#the_calendar DIV { position: absolute; box-sizing: border-box; }
#the_calendar DIV[onmousemove] { cursor: pointer }
.calendar_big .slots, .calendar_big .slotS { border: 1px solid #0A0; }
.calendar_big .slotu, .calendar_big .slotU { border: 1px solid #A00; }
.calendar_big .slotx { border: 1px solid #000; }
#the_calendar .slots, #the_calendar .slotS { background: #0F0 }
#the_calendar .slotu, #the_calendar .slotU { background: #F00; color: #FFF }
#the_calendar .slotx { background: #BBB }
#the_calendar .slotS, #the_calendar .slotU { opacity: 0.2; pointer-events: none }
#t_value[type='Calendar'] { background: #000 }
.calendar_div DIV { display: inline-block }
.calendar_div .feedback { width: 5em }
DIV.import_div.calendar_popup { top: 10% ; bottom: 5%}
"""