#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2023 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

from . import columnfill

class ColumnDispatcherConfig(columnfill.ColumnFill):
    """To add the configuration button on the interface"""
    default_value = r'''{
        "columns": ["25 Mar-08h-Foot\n25 Mar-08h-Gym\n25 Mar-10h-Foot\n25 Mar-10h-Gym",
                    "25 Mer-08h-Foot\n25 Mer-08h-Gym\n25 Mer-10h-Foot\n25 Mer-10h-Gym"],
        "choices": [ {"title": "Sort your sports by preference",
                      "values": "Foot Gym",
                      "repetition": 1},
                     {"title": "Sort your time slots by preference",
                      "values": "Mar-08h Mar-10h Mer-08h Mer-10h",
                      "repetition": 10}
                   ]
    }'''
    name = "dispatcher_config"
    action = "dispatcher_config"
    check_and_set = 'test_nothing'
