#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2022 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

from .column_abj_is import ColumnABJ_is

class ColumnGradeType(ColumnABJ_is):
    """The liste of grade types is defined in the translations"""
    name = 'grade_type'
    check_and_set = """function(value, column) {
        column.need_update = true ;
        for(var datacol in columns)
            if (columns[datacol].type == 'Ue_Grade')
                columns[datacol].need_update = true ;
        setTimeout(grade_type_in_average, 100);
        return Number(value) ;
        }"""

    css = '''
#menutop SELECT#t_column_grade_type { width: 3.5em ; font-weight: bold }
'''