/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2021 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@univ-lyon1.fr
*/

function set_groupcolumn(value, column, xcolumn_attr) {
    if (value === '' || xcolumn_attr !== false)
        return value;
    var data_col = data_col_from_col_title(value);

    if (data_col === undefined) {
        Alert('ALERT_url_import_column');
        return value;
    }
    // Compute stats
    var group_value = {};
    for (var lin_id in lines) {
        var group = lines[lin_id][data_col].value;
        if (group_value[group] === undefined)
            group_value[group] = {};
        var v = lines[lin_id][column.data_col].value;
        if (group_value[group][v] === undefined)
            group_value[group][v] = 1;
        else
            group_value[group][v]++;
    }
    // Display errors
    var errors = [];
    for (var group in group_value)
        if (Object.keys(group_value[group]).length != 1) {
            var error = _("B_print_attr_groupcolumn") + ' ' + group + ':';
            for (var v in group_value[group])
                error += ' ' + (v === '' ? _("COL_TITLE_empty") : v) + ':' + group_value[group][v];
            errors.push(error);
        }
    if (errors.length)
        alert(_('ALERT_columngroup') + '\n' + errors.join('\n'));

    return value;
}
