#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2019 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from ..column import ColumnAttr
import json

class ColumnMCQ(ColumnAttr):
    display_table = 1
    name = 'mcq'
    check_and_set = 'test_nothing'
    css = """
    #menutop #t_column_mcq { width: 4em ; }
    #menutop DIV.tabs #t_column_mcq { width: 40% ; }
    """
    default_value = [{},{}]
    def encode(self, value):
        if isinstance(value, str):
            value = value.strip()
            if value == '':
                return self.default_value
            return json.loads(value)
        else:
            return value
    formatter = "function(column, value) { return JSON.stringify(value) ; }"
    check_and_set = '''function(value, column, interactive)
    {
    if ( ! value )
        return [{},{}] ;
    if ( value.substr )
        return JSON.parse(value) ;
    return value ;
    }'''

