#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2017 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

from ..column import ColumnAttr

class ColumnNormalize(ColumnAttr):
    default_value = '10 2'
    display_table = 1
    name = 'normalize'
    check_and_set = '''
function(value, column)
{
  value = value.trim().split(/ +/);
  var average = Number(value[0]);
  var stddev = Number(value[1]);
  if ( isNaN(average) ) {
    average = 10;
    alert(value[0] + ' → ' + average);
  }
  if ( isNaN(stddev) || stddev <= 0 ) {
    stddev = 2;
    alert(value[1] + ' → ' + stddev);
  }
  column.need_update = true ;
  return average + ' ' + stddev ;
}'''
    css = """
    #menutop DIV.tabs #t_column_normalize { width: 4em ; margin-right: 4px}
    """

