#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2011 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from . import columnfill

class ColumnStats(columnfill.ColumnFill):
    name = "stats"
    action = "update_histogram"
    gui_display = "GUI_none"

    css = '''
#t_column_histogram, #t_column_stats {
  height: 1.5em ;
  display: inline-block;
  white-space: nowrap;
  vertical-align: bottom ;
}

#t_column_histogram {
  width: calc(100% - 5em - 20px);
  background: #FFF;
}

#t_column_graph {
  width: 18px;
  height: 18px;
  cursor: pointer;
  border: 2px solid #FFF;
}
.one_line:hover #t_column_graph {
  border-color: #00F;
}

DIV.import_export.column_zoomed_graph {
  left: 0px;
  top:0px;
  bottom: 0px;
  width: calc(var(--graph-size) + var(--graph-menu-width));
  padding: 0px;
  padding-right: 0.4em;
  overflow: hidden;
  white-space: pre;
  background-color: #FAFAFA;
  --graph-menu-width: 22em;
  --graph-size: calc(min(100vh, 100vw - var(--graph-menu-width)));
}

DIV.import_export.column_zoomed_graph CANVAS {
  width: var(--graph-size);
  height: var(--graph-size);
}

DIV.import_export.column_zoomed_graph > CANVAS, DIV.import_export.column_zoomed_graph > DIV {
  display: inline-block;
  vertical-align: top;
}

DIV.import_export.column_zoomed_graph > DIV {
  line-height: 1.5em;
  height: 100%;
}

DIV.import_export.column_zoomed_graph > DIV > DIV {
  position: absolute;
  overflow: auto;
  bottom: 0px;
  height: calc(100% - 4.5em);
  width: var(--graph-menu-width);
}

DIV.import_export.column_zoomed_graph > DIV > DIV > P {
  margin-top: 0.5em;
}
DIV.import_export.column_zoomed_graph TD, DIV.import_export.column_zoomed_graph TH {
  text-align: right;
}
DIV.import_export.column_zoomed_graph TABLE.colored.selector TR:hover TD {
    background: #FF0
}

#t_column_stats {
  width: 5em;
}
'''