/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2023 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@univ-lyon1.fr
*/

function table_clean_do() {
    alert_append_start();
    for (var i in filtered_lines)
        if (filtered_lines[i][5].value == 'non') {
            for (var datacol in columns) {
                if (filtered_lines[i][datacol].comment !== '')
                    comment_change(filtered_lines[i].line_id, datacol, '');
                if (filtered_lines[i][datacol].value !== '')
                    cell_set_value_real(filtered_lines[i].line_id, datacol, '');
                columns[datacol].need_update = true;
            }
        }
    alert_append_stop();
    update_columns();
    table_init();
    table_fill(false, true);
}

function table_clean() {
    var nr = 0;
    for (var i in filtered_lines)
        if (filtered_lines[i][5].value == 'non')
            nr++;
    if (nr == 0)
        Alert("MSG_table_clean_nothing");
    else if (confirm(_("CONFIRM_table_clean").replace('{}', nr)))
        table_clean_do();
}
