#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2008-2011 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from ..column import TableAttr
from .. import teacher

class TableTableTitle(TableAttr):
    name = 'table_title'

    def get_ue(self, table):
        if table:
            x = teacher.all_ues().get(table.ue_code.split('-')[-1], None)
            if x:
                return x
            x = teacher.all_ues().get(table.ue_code, None)
            if x:
                return x # pragma: no cover
        return None

    def default_value(self, table):
        ue = self.get_ue(table)
        if ue:
            return ue.intitule().title()
        return ''

    css = "#menutop DIV.tabs #t_table_attr_table_title { width: calc(100% - var(--widthleft) - var(--widthspace));}"