#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2014 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from . import tablemasters
from .. import configuration
from .. import utilities

class TableTeachers(tablemasters.TableMasters):
    name = 'teachers'
    formatter = '''
function(value)
{
if ( value instanceof Array )
   return value.join(' ') ;
table_attr.teachers = value.split(/ +/) ;
return value ;
}
'''
    
    def update(self, table, old_value, new_value, page):
        for login in new_value:
            if login not in table.mails:
                user = configuration.User(login)
                mail = user.mail
                if mail:
                    table.update_mail(login, mail)

    def default_value(self, table):
        return []

    css = "#menutop DIV.tabs #t_table_attr_teachers { width: calc(100% - var(--widthleft2) - var(--widthspace));}"
