/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2008,2010 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
*/

function toggle_bool(value) {
    return toggle_PA(test_bool, value, [yes, no]);
}

function bool_completions(value, column) {
    column.possible_values = [yes, no, ''];
    return completions_enumeration(value, column);
}

function test_bool(value, _column, silent) {
    if (value === undefined || value === '')
        return '';
    if (value.toUpperCase)
        value = value.toUpperCase();
    if (value == yes_char || value == '1' || value == yes)
        return yes;
    if (value == no_char || value == '0' || value == no)
        return no;
    if (!silent)
        alert_append(_('ALERT_invalid_value') + value + '\n' + _("TIP_cell_Bool"));
    return;
}

good_select_option = {};

function enumeration_suivi(choices) {
    var current_value = DisplayGrades.value.toString();
    if (!cell_modifiable_on_suivi())
        return html(current_value.replace(/_/g, " "));

    merged_choices = {};
    for (var i in choices) {
        i = choices[i];
        if (i.replace !== undefined) {
            merged_choices[i] = i;
            continue;
        }
        var name = i[0].replace(/_*$/, '');
        if (!merged_choices[name])
            merged_choices[name] = [name, 0];
        merged_choices[name][1] += i[1];
    }
    var value_with_space = current_value.replace(/_*$/, '');
    var code = DisplayGrades.column.the_id + '/' + DisplayGrades.ue.line_id;
    if (good_select_option[code] === undefined)
        good_select_option[code] = value_with_space;
    var v = '<select class="hidden" onmouseenter="select_open=true" onchange="'
        + student_input(DisplayGrades.column) + '" cellcode="'
        + encode_value(code)
        + '">';
    var sel, value, display, found;
    for (var i in merged_choices) {
        i = merged_choices[i];
        value = i.replace !== undefined ? i : i[0];
        if (value == value_with_space)
            found = sel = ' selected="1"';
        else
            sel = "";
        if (i.replace === undefined) {
            if (sel !== '')
                i = [i[0], i[1] - 1];
            value = i[0];
            display = i[0] + ' (' + i[1] + ' ' + _('MSG_free') + ')';
        }
        else
            display = value;
        v += '<option value="' + encode_value(value) + '"' + sel + '>'
            + html(display.replace(/_/g, ' ')) + '</option>';
    }
    if (!found)
        v += '<option value="' + encode_value(current_value) + '" selected="1">'
            + html(current_value) + ' (0 ' + _('MSG_free') + ')' + '</option>';
    v += '</select>';

    return v;
}

function bool_format_suivi() {
    return enumeration_suivi(['', yes, no]);
}
