#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2023 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

"""
The cell values are a string of +-x to indicate the slot status :
   's' : slot selected
   'u' : slot unselected
   'S' : slot selected and not unselectable
   'U' : slot unselected and not selectable
   'x' : slot undefined
The column attribute 'calendar' must not change if the column is not empty
"""

from . import text

class Calendar(text.Text):
    """Choose dates on a fixed calendar"""
    human_priority = 5
    attributes_visible = ('calendar', 'calendarexport')
    type_change = "undefined"
    formatte_suivi = 'calendar_format_suivi'
