/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2008-2013 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
*/

function test_date(value, _column) {
    if (value === '')
        return value;

    var date = value.split(/[- :_]+/, 1)[0];
    var v = date.split('/');
    if (v.length > 3) {
        alert_append(_('ALERT_date_format'));
        return;
    }

    var day, month, year;
    var today = new Date();
    if (v.length < 3)
        year = today.getFullYear();
    else {
        year = Number(v[2]);
        if (year < 100)
            if (year <= (today.getFullYear() - 2000) + 5) // 5 year in future
                year += 2000;
            else
                year += 1900;
    }
    if (year >= 2100) {
        alert_append(_('ALERT_date_invalid') + value);
        return;
    }
    if (v.length < 2)
        month = today.getMonth() + 1;
    else
        month = Number(v[1]);

    day = Number(v[0]);

    var d = new Date(year, month - 1, day);
    if (d.getDate() != day || d.getMonth() != month - 1 || d.getFullYear() != year) {
        alert_append(_('ALERT_date_invalid') + value);
        return;
    }
    day = two_digits(day);
    month = two_digits(month);

    var h = value.substr(date.length + 1);
    if (h !== '') {
        var hms = h.split(/[h:]/);
        var hour_ok = true;
        for (var i in hms)
            if (isNaN(hms[i]) || hms[i] < 0 || hms[i] >= 60) {
                hour_ok = false;
                hms[i] = 0;
            }
        if (hms[0] > 24)
            hour_ok = false;
        if (!hour_ok) {
            alert_append(_('ALERT_date_invalid') + value);
        }
        h = ' ' + two_digits(Number(hms[0])) + ':' + two_digits(Number(hms[1]) || 0)
            + (hms[2] !== undefined ? ':' + two_digits(Number(hms[2])) : '');
    }

    return day + '/' + month + '/' + year + h;
}
