#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2011 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from . import mail
from .. import referent
from .. import configuration
from .. import inscrits

class Get_Referent(mail.Mail):
    attributes_visible = ('columns',)

    def get_all_values(self, column, line_ids):
        if column.table.semester in configuration.semesters:
            # A normal student table: look in the past
            year = column.table.year
            semester = column.table.semester
        else:
            # Unknown semester: take the current one
            year, semester = configuration.year_semester # pragma: no cover

        infos = referent.referent_dict(year, semester)
        for line_id, user in self.users(column, line_ids):
            student = user.student_id
            if student in infos:
                yield line_id, infos[student]
