#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2019 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

from . import note

class MCQ(note.Note):
    human_priority = 100
    tip_cell = "TIP_cell_MCQ"
    ondoubleclick = 'toggle_mcq'
    attributes_visible = ('minmax', 'weight', 'rounding', 'repetition',
                          'url_import', "groupcolumn", 'mcq', 'MCQ_export',
                          "grade_type", "grade_session")
    formatte_suivi = "mcq_format_suivi"
    type_change = "i_am_a_new_mcq"
    hide_cell_comment = 1
    cell_test = "test_mcq"
