/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2008,2010 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
*/

function test_prst(value, _column, silent) {
    var v = value.toUpperCase();
    if (v === abi_char || v === abi_short || v === abi)
        return abi;
    if (v === abj_char || v === abj_short || v === abj)
        return abj;
    if (v === pre_char || v === pre_short || v === pre)
        return pre;
    if (allowed_grades[v])
        return v;
    if (v === '')
        return v;
    if (!silent) {
        var more = [];
        for (var i in allowed_grades)
            more.push(i + ' : ' + allowed_grades[i][1] + '\n');

        alert_append(_('ALERT_invalid_value') + ' « ' + v + ' »\n'
            + pre + " (" + pre_char + ") : " + _("MSG_T_pre") + "\n"
            + abi + " (" + abi_char + ") : " + _("MSG_T_abi") + "\n"
            + abj + " (" + abj_char + ") : " + _("MSG_T_abj") + "\n"
            + more.join("")
        )
    }
    return;
}

function prst_completions(value, column) {
    column.possible_values = [pre, abi, abj];
    for (var i in allowed_grades)
        if (allowed_grades[i][2] && myindex(column.possible_values, i) == -1)
            column.possible_values.push(i);
    column.possible_values.push('');
    return completions_enumeration(value, column);
}

function toggle_PA(test, v, values, column) {
    if (preferences.disable_dbl_click)
        return v;
    v = test(v, column);

    /* Cycle through values */
    var i = myindex(values, v);
    if (i == -1)
        i = values.length - 1;
    i = (i + 1) % values.length;

    return values[i];
}

function toggle_prst(value) {
    return toggle_PA(test_prst, value, [pre, abi, abj]);
}

function prst_format_suivi() {
    return enumeration_suivi(prst_completions('', DisplayGrades.column));
}

function qrcode_prst() {
    var more = [];
    if (filtered_lines.length != Object.keys(lines).length) {
        for (var lin_id in filtered_lines)
            more.push(filtered_lines[lin_id].line_id);
    }
    window_open(add_ticket(year + '/' + semester + '/' + ue + '/qrcode_new/'
        + the_current_cell.data_col + '/' + more.join('/')));
}
