/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2015 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@univ-lyon1.fr
*/

function safe_url(t) {
    return t.replace(RegExp('[#$%&?/\\\\: `]', 'g'), '_');
}

function upload_filename(t) {
    return safe_url(t.replace(/^[^;]*; [^ ]* */, ''));
}

function iframe_write(iframe, hook, content) {
    var iframew = iframe.contentWindow
        ? iframe.contentWindow
        : (iframe.contentDocument.document
            ? iframe.contentDocument.document
            : iframe.contentDocument);
    iframew.document.open();
    iframew.upload_file_choosed = hook;
    iframew.document.write(content);
    iframew.document.close();
}

function upload_popup(t, ue, col_id, lin_id, title) {
    add_ticket_checker(t);
    function answer(txt) {
        var length_type = txt.split('--OK--');
        if (length_type.length != 3)
            return;
        length_type = eval(length_type[1]);
        for (var i in display_data['Grades'][0]) {
            var obj_ue = display_data['Grades'][0][i];
            if (obj_ue.ue == ue)
                for (var j in obj_ue.columns)
                    if (obj_ue.columns[j].the_id == col_id) {
                        var cell = obj_ue.line[j];
                        cell[0] = length_type[0];
                        cell[1] = display_data['Login'];
                        cell[2] = (new Date()).formate('%Y%m%d%H%M%S');
                        cell[3] = length_type[1];
                        DisplayGrades.no_hover = false;
                        display_update_real();
                        return;
                    }
        }
    }
    function upload_file_choosed(t) {
        t.nextSibling.value = t.value;
        progress_submit(t.parentNode, undefined, window.url_suivi ? answer : undefined);
    }
    var width = 24; // em
    var pos = findPos(t);
    var div = document.createElement('DIV');
    div.style.position = "absolute";
    div.style.background = "#FFF";
    div.style.width = width + 'em';
    div.style.border = "4px solid #000";
    div.style.zIndex = 100000;
    div.style.opacity = 0.9;
    div.innerHTML = '<button style="float:right;margin:0px" onclick="the_body.removeChild(this.parentNode)">×</button>'
        + '<span style="font-size: 150%">' + _("MSG_upload_new") + '</span>'
        + (title ? title : '');
    the_body.appendChild(div);
    if (pos[1] - scrollTop() < window_height() / 2)
        div.style.top = (pos[1] + (the_current_cell.input ? the_current_cell.input.offsetHeight : 0)) + "px";
    else
        div.style.bottom = (window_height() - pos[1]) + "px";
    if (pos[0] + div.offsetWidth > window_width())
        div.style.right = '0px';
    else
        div.style.left = pos[0] + 'px';

    var iframe = document.createElement('IFRAME');
    iframe.style.width = (width + 0.5) + 'em';
    iframe.style.height = "15em";
    div.appendChild(iframe);
    var column;
    if (t == the_current_cell.input)
        column = the_current_cell.column;
    else
        column = DisplayGrades.column;
    iframe_write(iframe,
        upload_file_choosed,
        '<body style="width:' + (width - 1) + 'em">'
        + '<form action="' + add_ticket(year + '/' + semester
            + '/' + ue + '/upload_post/' + col_id + '/' + lin_id)
        + '" method="POST" enctype="multipart/form-data">'
        + _('MSG_upload_file')
        + '<br>'
        + '<input type="file" name="data" onchange="upload_file_choosed(this)">'
        + '<input type="text" name="filename" hidden=1><br>'
        + column.upload_max + "KB " + _("Maximum")
        + (column.type == 'Annotate' ? '<br><b>' + _("ERROR_PDF_required") + '</b>' : '')
        + '</form>');
}

function upload_double_click(value) {
    if (value === '') {
        var ok = the_current_cell.cell.changeable(the_current_cell.line,
            the_current_cell.column);
        if (ok !== true) {
            alert(ok);
            return value;
        }
        upload_popup(the_current_cell.input, ue,
            the_current_cell.column.the_id, the_current_cell.line_id,
            '→' + html(the_current_cell.column.title) + '<br>'
            + html(the_current_cell.line[1].value + ' '
                + the_current_cell.line[2].value));
        return value;
    }
    var more = "";
    if (the_current_cell.cell.history_length('V') > 1) {
        if (!confirm(_("CONFIRM_upload_last")))
            more = "~";
    }
    var filename = the_current_cell.cell.comment;
    if (filename === '') {
        var g = lines_of_the_group(the_current_cell.column,
            the_current_cell.line_id);
        for (var i in g) {
            var comment = g[i][the_current_cell.column.data_col].comment;
            if (comment !== '') {
                filename = comment;
                break;
            }
        }
    }
    var url = add_ticket(year + '/' + semester + '/' + ue
        + '/upload_get/' + the_current_cell.column.the_id
        + '/' + the_current_cell.line_id + more
        + '/' + encodeURIComponent(the_current_cell.line[1].value) + '%20'
        + encodeURIComponent(the_current_cell.line[2].value)
        + '%20' + encodeURIComponent(upload_filename(filename)));
    if (filename.startsWith('video/'))
        display_video(url, filename.split(' ')[0]);
    else
        window.open(url);
    return value;
}

function display_video(download_url, mimetype) {
    create_popup('video_popup', '',
        '<style>DIV.video_popup { position: fixed; top: 0px; left: auto; right: 0px;}</style>'
        + '<video controls style="width:50vw;max-height:100vh;"><source src="' + download_url
        + '" type="' + mimetype
        + '"></video>', '', false);
}

function upload_format_suivi() {
    var value = DisplayGrades.value;
    if (value.toString().match(/^https?:\/\//))
        return url_format_suivi();
    var empty = (value === ''
        || value == DisplayGrades.column.empty_is
        || isNaN(value)
    );
    var s = [];
    var title = upload_filename(DisplayGrades.cell.comment);
    var download_url = url
        + (ticket == 'none' ? '' : '/=' + ticket) + '/'
        + DisplayGrades.ue.year + '/' + DisplayGrades.ue.semester
        + '/' + DisplayGrades.ue.ue
        + (ticket == 'none' ? '/upload_get_public/' : '/upload_get/')
        + DisplayGrades.column.the_id
        + '/' + DisplayGrades.ue.line_id
        + '/' + DisplayGrades.ue.ue + "_" + encodeURIComponent(safe_url(DisplayGrades.column.title))
        + "_" + encodeURIComponent(title);
    if (!empty) {
        if (DisplayGrades.column.url_title)
            DisplayGrades.cell.comment = DisplayGrades.cell.comment.replace(
                /^([^ ]* [^ ]* ).*/, "$1" + DisplayGrades.column.url_title);
        if (DisplayGrades.cell.comment.indexOf('video/') == 0)
            s.push('<a href="javascript:display_video(\'' + download_url
                + "','" + DisplayGrades.cell.comment.split(' ')[0] + '\')">'
                + _('MSG_upload_get') + ' ' + title + '</a>');
        else
            s.push('<a target="_blank" href="' + download_url + '">'
                + (display_data["Login"] ? _('MSG_upload_get') + ' ' : '')
                + title + '</a> '
                + DisplayGrades.column.do_rounding(DisplayGrades.value) + "KB");
    }
    if (cell_modifiable_on_suivi()) {
        s.push(
            '<a class="clickable" style="color:blue" onclick="upload_popup(this,'
            + js2(DisplayGrades.ue.ue)
            + ',' + js2(DisplayGrades.column.the_id)
            + ',' + js2(DisplayGrades.ue.line_id)
            + ',' + js2('→' + DisplayGrades.column.title) + ')">'
            + (empty
                ? _('MSG_upload_new')
                : _('MSG_upload_change')
            )
            + '</a>');
    }
    if (s.length === 0)
        return _('MSG_no_file_uploaded');

    return s.join('<br>');
}
