#!/usr/bin/env python3
"""
Competences plugin
"""

import os
from TOMUSS.PYTHON_JS import tomuss_python
from TOMUSS import document
from TOMUSS import configuration
from TOMUSS import utilities
from TOMUSS import plugin

def get_catalog():
    """Compute the JSON, the result is cached"""
    catalog = tomuss_python.Catalog()
    try:
        for name in os.listdir(os.path.join(configuration.db, 'Y0', 'SCompetences')):
            #if configuration.regtest ^ (name == 'test_gui.py'):
            #    continue
            table = document.table(0, 'Competences', name[:-3])
            lines = [tuple(cell.value for cell in line)
                     for line in table.lines.values()]
            catalog.parse_lines(lines)
    except FileNotFoundError: # pragma: no cover
        pass

    return catalog
get_catalog = utilities.add_a_cache0(get_catalog, 86400)

configuration.get_catalog = get_catalog

def get_catalog_json():
    """Compute the JSON, the result is cached"""
    return get_catalog().get_json()
get_catalog_json = utilities.add_a_cache0(get_catalog_json, 86400)

configuration.get_catalog_json = get_catalog_json

def competences(server):
    """Return the JSON file defining the competence catalog"""
    server.the_file.write(get_catalog_json())

plugin.Plugin('competences', '/competences', function=competences,
    launch_thread = True, mimetype="application/json; charset=UTF-8")
