#!/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2015 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@univ-lyon1.fr

import json
from .. import plugin
from .. import configuration

def get_competences(server):
    """Return the """
    intitules = {}
    catalog = configuration.get_catalog()
    for key in server.the_path:
        intitules[key] = catalog.vocabulary[key[0]][int(key[1])]
    server.the_file.write(json.dumps(intitules))

# /get_competence/clef1/clef2/clef3/.... -> garder que un seul mot.
plugin.Plugin('get_competences', '/get_competences/{*}',
            function=get_competences,
            group='staff',
            mimetype = 'application/x-javascript; charset=UTF-8',
            unsafe=False,
            launch_thread=True
            )