#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#    TOMUSS: The Online Multi User Simple Spreadsheet
#    Copyright (C) 2008 Thierry EXCOFFIER, Universite Claude Bernard
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr

from .. import plugin
from .. import configuration

def logout(server):
    """User deconnexion from the server."""
    server.ticket.remove()
    server.the_file.write(server._("LABEL_logout")
                          + ' OK'
                          )

def logout_headers(server):
    redirect = configuration.authenticator.logout(server)
    if redirect:
        return ( ('Location', redirect), ) # pragma: no cover
    return ()

plugin.Plugin('logout', '/logout',
              function = logout,
              response=307,
              password_ok = None,
              unsafe=False,
              headers = logout_headers,
              )

