
function DisplayShareButton(_node) {
    return '<button onclick="create_share_popup()">'
        + _("B_create_share_popup") + '</button>';
}

function share_click(event) {
    event = the_event(event);
    var element = event.target;
    if (element.tagName == 'INPUT') {
        if (element.value == _('MSG_shared_comment'))
            element.select();
        element.style.background = '#FFF';
        return;
    }
    if (element.className == 'urlshare') {
        var range = document.createRange();
        range.selectNode(element);
        window.getSelection().removeAllRanges();
        window.getSelection().addRange(range);
        return;
    }
    if (element.tagName != 'BUTTON')
        return;
    var td = element.parentNode;
    var tr = td;
    while (tr.tagName != 'TR')
        tr = tr.parentNode;
    var id = tr.id;
    var action;
    var more = '';
    if (element.className == 'delete_share') {
        delete display_data['ShareButton'][id];
        action = 'del/' + id;
        tr.childNodes[0].style.color = "#888";
        tr.childNodes[2].style.color = "#888";
    }
    else if (element.className == 'create_share') {
        var comment = tr.firstChild.firstChild.value.trim();
        if (comment === '' || comment == _('MSG_shared_comment')) {
            tr.getElementsByTagName('INPUT')[0].style.background = '#FAA';
            return;
        }
        var seeds = JSON.stringify(display_data) + millisec();
        var id = '';
        var letters = "0123456789ABCDEFGHIJKLMOPQRSTUVWXYZ";
        var seed = new Rand(seeds).int();
        var nr = 32, slice = Math.floor(seeds.length / nr);
        for (var i = 0; i < nr; i++) {
            var rand = new Rand(seeds.substr(i * slice, slice) + seed + Math.random());
            id += letters.substr(rand.int() % letters.length, 1);
        }
        var photo = tr.childNodes[1].firstChild.checked ? 1 : 0;
        var upload = tr.childNodes[2].firstChild.checked ? 1 : 0;
        display_data['ShareButton'][id] = {
            'comment': comment,
            'time': millisec() / 1000,
            'photo': photo,
            'upload': upload
        };
        action = 'add/' + id + '/' + photo + '/' + upload + '/' + encode_uri(comment);
        tr.childNodes[0].innerHTML = share_why(display_data['ShareButton'][id]);
        tr.childNodes[1].firstChild.disabled = true;
        tr.childNodes[2].firstChild.disabled = true;
        more = '<div class="urlshare" onclick="share_click(event)">' + url_share + id + '</div>';
        var add = document.createElement('TR');
        add.innerHTML = share_new_line();
        tr.parentNode.appendChild(add);
    }
    if (!action)
        return;
    td.innerHTML = more + '<iframe src="' + add_ticket('share_store/' + action)
        + '"></iframe>';
}

var url_share;

function remove_year_semester(uri) {
    return uri.replace(RegExp('/20../[^/]*$'), '');
}

function share_new_line() {
    return '<td><input value="' + encode_value(_('MSG_shared_comment'))
        + '" onclick="share_click(event)">'
        + '<td><input type="checkbox">'
        + '<td><input type="checkbox">'
        + '<td><button class="create_share" onclick="share_click(event)">'
        + _('B_create_share') + '</button>';
}

function share_why(share) {
    var d = new Date(), d2 = new Date();
    d.setTime(share.time * 1000);
    d2.setTime((share.time + share_duration * 86400) * 1000);
    return '<i>' + html(share.comment) + '</i>'
        + '<div class="share_dates">'
        + d.formate('%Y-%m-%d') + ' → ' + d2.formate('%Y-%m-%d')
        + '</div>';
}

function create_share_popup() {
    url_share = remove_year_semester(url_suivi) + '/shared/' + username + '/';
    var t = ['<style>TABLE.shared TD, TABLE.shared INPUT { padding: 0.5em; position: relative }',
        'TABLE.shared INPUT { box-sizing: border-box; width: 100% }',
        'TABLE.shared DIV.urlshare {',
        ' height: 1em ; white-space: nowrap ; width: 20em; user-select: initial }',
        'TABLE.shared TR DIV.share_dates, TABLE.shared TR BUTTON.delete_share { opacity: 0.3 }',
        'TABLE.shared TR:hover DIV.share_dates, TABLE.shared TR:hover BUTTON.delete_share { opacity: 1 }',
        'TABLE.shared TR:hover I { font-weight: bold }',
        'TABLE.shared TR TH:nth-child(1) { width: 50% }',
        'TABLE.shared TR TH:nth-child(2) { text-align: center; font-size: 80% }',
        'TABLE.shared TR TH:nth-child(3) { text-align: center; font-size: 80% }',
        'TABLE.shared TR TH:nth-child(4) { width: 50% }',
        'TABLE.shared BUTTON.delete_share { font-size: 60% ; float: right ; margin-top: 0.5em}',
        'TABLE.shared IFRAME { width: 14em ; height: 2em ; }',
        '</style>',
        '<table class="shared colored"><tr>',
        '<th>', _("MSG_shared_with"),
        '<th>', _("MSG_shared_photo_ID"),
        '<th>', _("MSG_shared_upload"),
        '<th>', _('MSG_shared_link'),
        '</tr>',
    ];
    var share = display_data['ShareButton'];
    var lines = [];
    for (var key in share) {
        share[key].key = key;
        lines.push(share[key]);
    }
    lines.sort(function (a, b) { return a.time - b.time; });
    for (var i in lines) {
        t.push('<tr id="' + lines[i].key + '"><td>' + share_why(lines[i])
            + '<td><input type="checkbox" disabled'
            + (lines[i].photo ? ' checked' : '')
            + '><td><input type="checkbox" disabled'
            + (lines[i].upload ? ' checked' : '')
            + '><td>'
            + '<div class="urlshare" onclick="share_click(event)">'
            + url_share + lines[i].key + '</div>'
            + '<button class="delete_share" onclick="share_click(event)">'
            + _('B_delete_share') + '</button></tr>');
    }
    t.push('<tr>' + share_new_line() + '</tr>');
    t.push('</table>');

    add_ticket_checker(the_body);

    create_popup('share_popup',
        _('B_create_share_popup') + ' (' + username + ')',
        ''.join(t), '', false);
}

function shared_upload_formatte_suivi() {
    var s = upload_format_suivi();
    s = s.replace(RegExp(url + '/' + year + '/' + semester + '/([^/]*)/upload_get_public/'),
        remove_year_semester(window.location.toString())
        + '/upload/' + year + '/' + semester + '/$1/');
    return s;
}

function copy_shared_data() {
    display_data['Preferences'] = {};
    display_data['Names'] = display_data['ShareNames'];
    display_data['UETree'] = display_data['ShareUETree'];
    display_data['Grades'] = display_data['ShareGrades'];
    display_data['Login'] = display_data['ShareLogin'];
}

function DisplaySharePicture(node) {
    copy_shared_data();
    return DisplayPicture(node);
}
DisplaySharePicture.need_node = ['ShareLogin'];

function DisplayShareNames(node) {
    copy_shared_data();
    return DisplayNames(node);
}

function DisplayShareUETree(node) {
    copy_shared_data();
    return DisplayUETree(node);
}
DisplayShareUETree.need_node = ["ShareUETree", "ShareGrades"];

function DisplayShareGrades(node) {
    type_title_to_type('Upload').formatte_suivi = shared_upload_formatte_suivi;
    copy_shared_data();
    return DisplayGrades(node);
}
DisplayShareGrades.need_node = ['ShareLogin', 'ShareGrades'];

function DisplayShareDelete(_node) {
    var path = window.location.pathname.split('/shared/')[1].split('/');
    return '<a href="' + url + '/shared/' + path[0] + '/' + path[1] + '/del">'
        + _('B_delete_share') + '</a>';
}
DisplayShareDelete.need_node = [];

function DisplayShareSemesters(_node) {
    var t = [];
    var s = display_data['ShareSemesters'];
    var path = window.location.pathname.split('/shared/')[1].split('/');
    path = '/shared/' + path[0] + '/' + path[1];
    for (var key in s) {
        var current = 'display: inline-block; text-align: center; margin-left:2px; background:';
        year_semester = key.split('/');
        var sem = myindex(semesters, year_semester[1]);
        if (year + '/' + semester == key)
            current += '#FF0';
        else
            current += semesters_color[sem];
        t.push('<!-- ' + year_semester[0] + ' ' + sem + ' -->'
            + '<a href="' + remove_year_semester(s[key]) + path + '/' + key
            + '" style="' + current + '">' + key.replace('/', '<br>') + '</a>');
    }
    t.sort();
    t.push('<style>');
    t.push('.ShareTop { font-size: 150% }');
    t.push('.ShareLogin { color: #CCC }');
    t.push('.ShareDelete { font-size: 50% ; color: #F00; float: right; }');
    t.push('</style>');
    return t.join('');
}
DisplayShareSemesters.need_node = ['ShareSemesters', 'ShareLogin'];
