function DisplayUEGradesInit(ue) {
    table_attr = ue;
    line = [];
    for (var i in ue.line) {
        i = ue.line[i];
        line.push(C(i[0], i[1], i[2], i[3]));
    }
    line.line_id = ue.line_id;
    ue.line_real = line;
    columns = [];
    for (var i in ue.columns)
        columns.push(Col(ue.columns[i]));

    for (var data_col in columns) {
        init_column(columns[data_col]);
        columns[data_col].data_col = data_col;
    }
    DisplayGrades.table_attr = ue;
}

function init_suivi_state(ue, line_id, col_id) {
    var grades = display_data["Grades"][0];
    table_attr = undefined;
    for (var i in grades) {
        if (grades[i].ue == ue && grades[i].line_id == line_id) {
            DisplayUEGradesInit(grades[i]);
            if (col_id) {
                var data_col = data_col_from_col_id(col_id);
                DisplayGrades.cell = line[data_col];
                return columns[data_col];
            }
            return;
        }
    }
}

function get_next_div(value) {
    var t = document.getElementsByTagName('DIV');
    var n, min = 1e9;
    for (var i = 0; i < t.length; i++)
        if (t[i].tabIndex > value && t[i].tabIndex < min && t[i].className.indexOf('is_empty') == -1) {
            n = t[i];
            min = t[i].tabIndex;
        }
    if (n)
        return n;
    return get_next_div(999); // wrap
}

/* To send the cell change and feedback */

function send_suivi_request(url_cell, feedback, onload) {
    var xmlhttp = new XMLHttpRequest();
    var formData = new FormData();
    formData.append("content", url_cell);
    xmlhttp.open("POST", url + '/POST', true);
    xmlhttp.onreadystatechange = function () {
        var element = feedback.previousSibling.firstChild;
        if (element && element.getAttribute)
            var cellcode = element.getAttribute('cellcode');
        if (this.readyState === 4 && this.status == 200) {
            feedback.innerHTML = this.responseText;
            if (this.responseText.toString().indexOf('OK!') != -1) {
                feedback.style = 'background: #0F0; color: #000';
                if (element && element.tagName == 'SELECT')
                    good_select_option[cellcode] = element.value;
                if (feedback.focus_next)
                    feedback.focus_next();
                if (onload)
                    onload(this.responseText);
            }
            else {
                if (element && element.tagName == 'SELECT')
                    element.value = good_select_option[cellcode];
                alert(this.responseText);
            }
        }
    }
    xmlhttp.send(formData);
    if (!feedback.previousSibling)
        report_fake_error('send_suivi_request:' + feedback.outerHTML);

}

function _cell(s, url_cell, comment_value, onload) {
    var url_s = url_cell.split('/');
    var column = init_suivi_state(
        url_s[url_s.length - 4], url_s[url_s.length - 1], url_s[url_s.length - 2]);
    var value;
    if (comment_value === undefined) {
        var new_s = column.real_type.cell_test(s.value, column);
        if (new_s !== undefined)
            s.value = new_s;
        value = new_s;
    }
    else {
        value = comment_value;
    }
    value = value.toString().trim();
    var iframe = document.createElement('DIV');
    iframe.className = 'feedback';
    iframe.style = "background: #F00; color: #FFF; position:absolute;";
    iframe.textContent = _("MSG_home_wait");

    add_ticket_checker(s.parentNode);

    if (DisplayGrades.html_object && !comment_value) {
        // The DisplayGrades attributes are initialised by 'display_cellbox_tip'
        DisplayGrades.table_attr.line[DisplayGrades.column.data_col][0] = value;
        var line = DisplayGrades.cellbox;
        var title = DisplayGrades.column.title;
        while (!line.className.match(/UEGrades/))
            line = line.parentNode;
        DisplayGrades.no_hover = false;
        var tabindex = DisplayGrades.tabindex;

        // Recompute the cells after the change
        var data_col = DisplayGrades.column.data_col;
        if (DisplayGrades.ue.line[data_col].length)
            DisplayGrades.ue.line_real[data_col].value = DisplayGrades.ue.line[data_col][0];
        lines = { 'line_id': DisplayGrades.ue.line_real };
        update_line('line_id', data_col);
        for (var data_col = 0; data_col < DisplayGrades.ue.line_real.length; data_col++) {
            DisplayGrades.ue.line[data_col][0] = DisplayGrades.ue.line_real[data_col].value;
        }

        line.innerHTML = display_display(DisplayGrades.ue_node);
        var titles = line.getElementsByTagName('DIV');
        for (var i = 0; i < titles.length; i++)
            if (titles[i].className.match(/CellBox/) && titles[i].title == title) {
                titles[i].appendChild(iframe);
                break;
            }
        var next = get_next_div(tabindex);
        var ds = Number(next.onfocus.toString().replace(/[^0-9]/g, '')); // XXX fragile
        iframe.focus_next = function () {
            next.focus();
            display_cellbox_tip({ target: next }, ds, true);
            display_cellbox_tip.do_not_replace = true;
        };
    }
    else
        s.parentNode.appendChild(iframe);

    send_suivi_request('/' + add_ticket(url_cell, encode_uri(value)), iframe, onload);
    if (!comment_value)
        hide_cellbox_tip();
}

function initialize_suivi_real() {
    lib_init();
    instant_tip_display = true;

    document.getElementById('top').innerHTML = '<div id="cellbox_tip"></div>'
        + (window.devicePixelRatio !== undefined
            ? '<meta name="viewport" content="width=device-width,height=device-height,initial-scale=1">'
            : '')
        + '<div id="display_suivi"></div>'
        ;
    i_am_root = myindex(root, username) != -1;
    my_identity = username;
}

function cell_modifiable_on_suivi() {
    table_attr = DisplayGrades.table_attr;
    if (!DisplayGrades.cell.modifiable(DisplayGrades.ue.line_real,
        DisplayGrades.column))
        return;
    if (!DisplayGrades.column.modifiable)
        return DisplayGrades.column.modifiable; // 0 or false
    if (is_a_teacher && DisplayGrades.column.visibility == 6)
        return false;
    if (DisplayGrades.column.modifiable == 2)
        return true;
    if (is_a_teacher
        && DisplayGrades.column.modifiable == 1) // So modifiable == 1
        return true;
}

function DisplayList(node) {
    return DisplayHorizontal(node, ', ');
}
DisplayList.need_node = [];

function is_inside_rightclip(element) {
    while (element) {
        if (element.id == 'rightclip')
            return true;
        element = element.parentNode;
    }
}

function set_rightclip(classe, event) {
    if (millisec() - set_rightclip.time < 100)
        return;
    set_rightclip.time = millisec();

    var e = document.getElementById("rightclip");
    if (!e)
        return;

    if (event
        && event.button !== undefined
        && e.className.toString().match('hide_rightclip')
        && is_inside_rightclip(the_event(event).target))
        stop_event(event); // Not follow links when clicking on hidden bodyright

    e.className = e.className.toString()
        .replace(/ [^ ]*_rightclip/g, '') + ' ' + classe;

    // XXX Kludge : Hide Bodyright if bodyleft is clicked on touch screen
    e.parentNode.parentNode.onmousedown = function (event) {
        if (is_inside_rightclip(the_event(event).target))
            return;
        hide_rightclip(event);
    };
    return
}
set_rightclip.time = 0;

function show_rightclip(event) {
    set_rightclip('show_rightclip', event);
}

function hide_rightclip(event) {
    set_rightclip('hide_rightclip', event);
}

function rightclip_touch_start(event) {
    rightclip_touch_start.x = the_event(event).x;
    console.log("rightclip_touch_start " + rightclip_touch_start.x);
}

function rightclip_touch_end(event) {
    console.log("rightclip_touch_stop " + the_event(event).x);
    if (the_event(event).x > rightclip_touch_start.x + 8)
        hide_rightclip(event);
    if (the_event(event).x < rightclip_touch_start.x - 8)
        show_rightclip(event);
}

function DisplayRightClip(node) {
    return [DisplayHorizontal(node),
    ['hide_rightclip'],
    [],
    'id="rightclip" '
    + 'ontouchstart="rightclip_touch_start(event)" '
    + 'ontouchmove="rightclip_touch_end(event)" '
    + 'onclick="show_rightclip(event)" '
    + 'onmouseenter="show_rightclip(event)" '
    + 'onmouseleave="hide_rightclip(event)"'];
}
DisplayRightClip.need_node = [];

function DisplayPicture_(login, no_tip) {
    var s = '<img class="small" alt="' + _('ALT_photo_ID') + '" src="'
        + student_picture_icon_url(login)
        + '" style="vertical-align:top">';
    if (no_tip)
        return s;
    // newsrc to load the image only on tip display (lookat 'show_the_tip' function)
    s = hidden_txt(s,
        '<img class="big" alt="' + _('ALT_photo_ID') + '" newsrc="' +
        student_picture_url(login) + '">');
    if (rgpd_link && rgpd_link !== '')
        s = '<a target="_blank" href="' + rgpd_link + '">' + s + '</a>';
    return s;
}

function DisplayPicture(_node) {
    return DisplayPicture_(display_data['Login']);
}
DisplayPicture.need_node = ['Login'];

function DisplayOfficial(_node) {
    var url = bilan_des_notes;
    if (url.indexOf('?') == -1)
        url = add_ticket(bilan_des_notes, display_data['Login']);
    else
        url += display_data['Login']
    return hidden_txt('<a href="' + url + '" target="_blank">'
        + _("MSG_suivi_student_official_bilan") + '</a>',
        _("TIP_suivi_student_official_bilan")
    );
}
DisplayOfficial.need_node = ['Login'];

function DisplayBilan(_node) {
    if (!is_a_teacher)
        return '';
    return hidden_txt('<a href="' + add_ticket('bilan/'
        + display_data['Login']) + '" target="_blank">'
        + _("MSG_suivi_student_TOMUSS_bilan") + '</a>',
        _("TIP_suivi_student_TOMUSS_bilan"));
}
DisplayBilan.need_node = ['Login'];

function displaynames(data, no_tip, subject) {
    var mailto = data[2];
    if (subject)
        mailto = encodeURIComponent(subject) + ' <' + mailto + '>';
    var mail = '<a href="mailto:' + mailto + '">'
        + title_case(data[0] || '?') + ' ' + data[1] + '</a>';
    if (data[3] !== undefined)
        mail = DisplayPicture_(data[3], no_tip) + mail;
    return mail;
}

function DisplayNames(node, no_tip) {
    return displaynames(node.data, no_tip);
}

function DisplayReferent(node) {
    switch (node.data[4]) {
        case false:
            return hidden_txt(_('MSG_suivi_student_no_referent'),
                _('TIP_suivi_student_no_referent_needed'));
        case true:
            return hidden_txt(_('MSG_suivi_student_no_referent'),
                _('TIP_suivi_student_no_referent'));
        default:
            return (
                is_a_teacher
                    ? ''
                    : '<div style="width: 15em">' + _('MSG_suivi_student_your_referent') + '</div>')
                + hidden_txt(DisplayNames(node, true),
                    _('MSG_suivi_student_send_to_referent'));
    }
}

function DisplayMails(node) {
    var ref;
    if (display_data['Referent'][4] !== undefined)
        ref = ',' + _("MSG_suivi_student_referent") + '<'
            + display_data['Referent'][2] + '>';
    else
        ref = '';

    return '<a href="mailto:?to='
        + encodeURIComponent(node.data.join(',') + ref)
        + '&subject=' + encodeURIComponent(display_data['Login'] + ' '
            + display_data['Names'][0]
            + ' ' + display_data['Names'][1])
        + '">'
        + hidden_txt(_("MSG_suivi_student_mail_all"),
            _("TIP_suivi_student_mail_all")) + '</a>';
}
DisplayMails.need_node = ['Mails', 'Login', 'Referent', 'Names'];

function DisplayStudentView(_node) {
    if (!is_a_teacher)
        return '';
    return hidden_txt(
        '<a href="'
        + add_ticket(display_data["Semesters"][get_url_year_semester()],
            ' ' + display_data['Login'])
        + '" target="_blank">' + _("MSG_suivi_student_view") + '</a>',
        _("TIP_suivi_student_view"));
}
DisplayStudentView.need_node = ['Login', 'Semesters'];

function DisplayCharte(node) {
    if (!is_a_teacher)
        return '';
    if (node.data)
        return _("MSG_suivi_student_contract_checked");
    else
        return '<span style="background:red">'
            + _("MSG_suivi_student_contract_unchecked") + '</span>';
}

function DisplaySignature(_node) {
    return '<a href="signatures/' + display_data['Login'] + '">'
        + _("MSG_signatures") + '</a>';
}
DisplaySignature.need_node = ['Login'];

function DisplayReload(_node) {
    if (!is_a_teacher || !display_data['Preferences']
        || !display_data['Preferences']['debug_suivi'])
        return '';
    return '<a href="reload_plugins">' + _("TITLE_reload_plugins") + '</a>';
}
DisplayReload.need_node = [];

function DisplayExplanationPopup() {
    if (popup_classname() == 'explanations_popup') {
        popup_close();
        return;
    }
    create_popup('explanations_popup',
        'TOMUSS <span class="copyright">'
        + display_data['Explanation']
        + '</span>'
        + '<a style="" href="mailto:'
        + maintainer + '?subject='
        + encodeURI(_('MSG_suivi_student_mail_subject')) + '&body='
        + encodeURI(_('MSG_suivi_student_mail_body')).replace(/\n/g,
            '%0A')
        + '">' + _('MSG_suivi_student_mail_link') + '</a>',
        _("MSG_suivi_help"),
        '', false);
}

function DisplayExplanation(_node) {
    return hidden_txt('<a href="javascript:DisplayExplanationPopup()">?</a>',
        _("COL_TITLE_explanations"));
}
// DisplayExplanation.need_node = [] ;

function preference_set(item, value) {
    if (!is_a_teacher && username != display_data['Login']) {
        Alert("ERROR_value_not_modifiable");
        return; // Can't change student preferences
    }
    display_data['Preferences'][item] = value;
    DisplayPreferencesPopup(true);
    DisplayGrades.no_hover = false;
    display_update_real();
    var img = document.createElement('IMG');
    img.src = add_ticket('save_preferences/'
        + item + '=' + display_data['Preferences'][item] + '/' + millisec());
    document.getElementById('preference_' + item).appendChild(img);
}

function preference_toggle(item) {
    preference_set(item, 1 - display_data['Preferences'][item]);
}

function add_share_with() {
    var login = prompt(_('Preference_add_share_with'));
    if (!login || login.length < 2)
        return;
    login = login.trim().toLowerCase();
    var safe = login.replace(/[^-.a-z0-9]/g, '');
    if (login != safe) {
        alert(login + ' ≠ ' + safe);
        return;
    }
    var key = 'share_with_' + safe;
    if (display_data['Preferences'][key] === undefined)
        display_data['Preferences'][key] = 0;
    preference_toggle(key);
}

function DisplayPreferencesPopup(do_no_hide) {
    if (!do_no_hide && popup_classname() == 'preferences_popup') {
        popup_close();
        return;
    }
    var data = display_data['Preferences'];
    var items = [];
    for (var item in data)
        items.push(item);
    function cleanup(x) {
        return x.substr(0, 11) == 'share_with_'
            ? '  ' + x.substr(11)
            : _('Preference_' + x);
    }
    items.sort(function (a, b) {
        a = cleanup(a);
        b = cleanup(b);
        if (a < b)
            return -1;
        if (a > b)
            return 1;
        return 0;
    }
    );

    var s = ['<ul>'], label, _label;

    // Sunburst Preference :
    if (DisplaySunburst.root && DisplaySunburst.root.length > 1) {
        var sun_params_on_click = 'onClick="sunburst_prefs_switch(this.value)"';
        s.push('<fieldset>',
            '<legend>', _("PARAM_sunburst_title"), '</legend>',
            '<div> <label>',
            '<input type="radio" name="sun-param" value=0 ', sun_params_on_click, '/>',
            _("PARAM_sunburst_all"),
            '</label> </div>',
            '<div> <label>',
            '<input type="radio" name="sun-param" value=1 ', sun_params_on_click, '/>',
            _("PARAM_sunburst_normal"),
            '</label> </div>',
            '<div> <label>',
            '<input type="radio" name="sun-param" value=3 ', sun_params_on_click, '/>',
            _("PARAM_sunburst_tiny"),
            '</label> </div>',
            '</fieldset>');
    }

    for (var item in items) {
        item = items[item];
        label = 'Preference_' + item;
        if (item.startsWith('share_with_'))
            _label = _('Preference_share_with_') + ' ' + item.substr(11);
        else if (item.startsWith('working_hours_per_week')) {
            s.push('<li style="margin-left: -3em; color: #040"');
            s.push(' id="preference_' + item + '">')
            s.push(radio_buttons("display_data['Preferences']['working_hours_per_week']",
                [0, 5, 10, 15, 20, 30, '+40'],
                data[item], "preference_set('" + item + "', this.innerText)"));
            s.push(_("Preference_working_hours_per_week") + '</li>');
            continue;
        }
        else if (item.startsWith('commute_time')) {
            s.push('<li style="margin-left: -3em; color: #040"');
            s.push(' id="preference_' + item + '">')
            s.push(radio_buttons("display_data['Preferences']['commute_time']",
                [0, 30, 60, 90, 120, 150, '+180'],
                data[item], "preference_set('" + item + "', this.innerText)"));
            s.push(_("Preference_commute_time") + '</li>');
            continue;
        }
        else
            _label = _(label);

        if (_label != label)
            s.push('<li onclick="preference_toggle(\'' + item + '\')"'
                + ' id="preference_' + item + '"'
                + ' class="selection_' + data[item] + '">'
                + _label + '</li>');
    }
    s.push('<li onclick="add_share_with()">' + _('Preference_add_share') + '</li>');
    s.push('</ul>');
    var content = display_definition['Preferences'].children;
    for (var i in content)
        s.push(display_display(content[i]));
    var preferences = s.join('');
    try { preferences = preferences_hook(preferences); } catch (e) { };
    create_popup('preferences_popup',
        '<small>' + _('LABEL_preferences')
        + '/<a href="' + add_ticket(url_suivi, 'logout') + '">'
        + _("LABEL_logout") + '</a></small><br>'
        + (is_a_teacher ? username : display_data['Login']),
        preferences, '', false);
}

function DisplayPreferences(node) {
    display_do_debug = node.data['debug_suivi'];
    for (var item in node.data) {
        if (node.data[item] === undefined)
            node.data[item] = 0;
        if (node.data[item] == -1) {
            var v;
            if (confirm(_('ask_share').split('\n')[0].replace('{0}', item.substr(11))))
                v = 0;
            else
                v = 1;
            node.data[item] = v;
            preference_toggle(item);
        }
    }
    detect_small_screen();
    return hidden_txt('<a href="javascript:DisplayPreferencesPopup()">≡</a>',
        _("LABEL_preferences"));
}
DisplayPreferences.need_node = ['Preferences', 'Login'];

function DisplayUEToggle_key(ue) {
    return year + '/' + semester + '/' + ue;
}

function DisplayUEToggle_text(ue) {
    try {
        return localStorage[DisplayUEToggle_key(ue)] == "closed" ? '▶' : '▼';
    } catch (e) { return '§'; }
}

function DisplayUEToggle_is_open(ue) {
    try {
        return localStorage[DisplayUEToggle_key(ue)] != 'closed';
    } catch (e) { return true; }
}

function DisplayUEToggle_do(event, ue) {
    var k = DisplayUEToggle_key(ue);
    try {
        localStorage[k] = localStorage[k] == "closed" ? "open" : "closed";
    }
    catch (e) {
        alert('LocalStorage NOT WORKING: ASK HELP\n\n'
            + navigator.userAgent + ':\n\n' + e);
    }
    var t = the_event(event).target;
    t.innerHTML = DisplayUEToggle_text(ue);
    var content = t.parentNode.parentNode.nextSibling;
    if (DisplayUEToggle_is_open(ue))
        content.style.display = "block";
    else
        content.style.display = "none";
    if (content.className.toString().indexOf("UEComment") != -1) {
        content = content.nextSibling;
        if (DisplayUEToggle_is_open(ue))
            content.style.display = "block";
        else
            content.style.display = "none";
    }
}

function DisplayUEToggle(_node) {
    try {
        return '<a class="clickable" onclick="DisplayUEToggle_do(event,'
            + js2(DisplayGrades.ue.ue) + ')">'
            + DisplayUEToggle_text(DisplayGrades.ue.ue)
            + '</a>';
    }
    catch (e) {
        return '';
    }
}
DisplayUEToggle.need_node = [];


function DisplayUETitle(_node) {
    var ue = DisplayGrades.ue;
    var title = html(ue.ue + ' ' + (ue.table_title || ''));
    if (is_a_teacher && ue.semester) {
        title = '<a href="'
            + add_ticket(ue.year + '/' + ue.semester + '/' + ue.ue)
            + '" target="_blank">' + title + '</a>';
        title = hidden_txt(title, _("MSG_cell_full_table"));
        title += hidden_txt(' (<a href="'
            + add_ticket(ue.year + '/' + ue.semester + '/' + ue.ue
                + '/=filters=0_0:'
                + login_to_id(display_data['Login'])
                + '=')
            + '" target="_blank">*</a>)',
            _("MSG_cell_one_line"));
        return '<a name="' + ue.ue + '">' + title + '</a>';
    }
    else
        return '<a tabindex="0" name="' + ue.ue + '">' + title + '</a>';
}
DisplayUETitle.need_node = [];

function DisplayUEMasters(_node) {
    var ue = DisplayGrades.ue;
    var mails = [];
    for (var j in ue.masters)
        mails.push(displaynames(ue.masters[j], false, ue.ue));
    if (mails.length)
        return hidden_txt('<small>' + mails.join(', ') + '</small>',
            _("MSG_abj_master"));
    return '';
}
DisplayUEMasters.need_node = [];

function DisplayUEComment(_node) {
    var ue = DisplayGrades.ue;
    if (ue.comment && ue.comment != '')
        return _("MSG_cell_message")
            + '<em>' + add_link_on_url(html(ue.comment)).replace(/\n/g, '<br>') + '</em>';
    return '';
}
DisplayUEComment.need_node = [];

function hide_fake_ue(ue) {
    if (!ue.fake_ue)
        return false;
    for (var i in DisplayUETree.children[ue.ue])
        if (!hide_fake_ue(DisplayUETree.dict[DisplayUETree.children[ue.ue][i]]))
            return false;
    return true;
}

function DisplayUE(node) {
    if (DisplayGrades.ue.display_saved_nr === undefined)
        DisplayGrades.ue.display_saved_nr = 1000 * DisplayUE.index++;
    var s = DisplayVertical(node);
    var classes = [];
    for (var data_col in columns)
        if (columns[data_col].freezed == "C"
            && line[data_col].value.match(/\bnon\b/)) {
            classes = 'nonInscrit';
            s = s.substr(0, s.length - 6) + '<br>' + _("WARN_unregistered_student") + '</div>';
            break;
        }
    if (DisplayUETree.children && DisplayUETree.children[DisplayGrades.ue.ue]) {
        s = s.substr(0, s.length - 6); // Remove </div>
        var save = DisplayGrades.ue;
        var children = DisplayUETree.children[DisplayGrades.ue.ue];
        if (hide_fake_ue(DisplayGrades.ue))
            return;
        while (children.length == 1 && DisplayUETree.dict[children[0]].fake_ue)
            children = DisplayUETree.children[children[0]];
        s += '<div style="margin-left: 2em">';
        for (var i in children) {
            DisplayGrades.ue = DisplayUETree.dict[children[i]];
            s += display_display(display_definition['UE']);
        }
        s += '</div></div>';
        DisplayGrades.ue = save;
    }
    var id = DisplayGrades.ue.ue + '/' + DisplayGrades.ue.line_id;
    if (DisplayGrades.ue.ue == DisplayGrades.highlight_ue) {
        classes = 'highlight_ue_before';
        setTimeout(function () {
            var e = document.getElementById(id);
            e.scrollIntoView();
            e.className += ' highlight_ue';
        }, 300);
    }
    return [s, classes, [], 'onmouseenter="enter_in_ue(event)" id="' + id + '"'];
}
DisplayUE.need_node = [];
DisplayUE.index = 1;

function remove_prefix(txt) {
    return txt.split('-')[1] || txt;
}

/*REDEFINE
Called before UE tree construction
*/
function DisplayUETreeHook(_node) {
}

function DisplayUETree(node) {
    DisplayUETreeHook(node);
    var ues = display_data["Grades"][0];
    var with_prefix = {};
    DisplayUETree.dict = {};

    ues.sort(compare_ue);
    for (var i in ues) {
        var code = ues[i].ue;
        var trimed = remove_prefix(code);
        if (with_prefix[trimed] === undefined)
            with_prefix[remove_prefix(code)] = code;
        DisplayUETree.dict[code] = ues[i];
    }

    var translated = {};
    for (var i in node.data)
        if (node.data[i] != i)
            translated[with_prefix[i] || i]
                = with_prefix[node.data[i]] || node.data[i];
    node.data = translated;
    for (var k in ues) {
        var c = ues[k].ue.split('__');
        if (c.length > 1)
            for (var i in c) {
                var pere = node.data[c[i]];
                if (pere) {
                    node.data[ues[k].ue] = pere; // A parent for X__Y is found
                    break;
                }
                pere = node.data[remove_prefix(c[i])];
                if (pere) {
                    node.data[ues[k].ue] = pere; // A parent for X__Y is found
                    break;
                }
            }
    }
    for (var i in node.data) {
        var parent = node.data[i];
        if (!DisplayUETree.dict[parent]) { // Parent does not exist, so create a fake one
            ues.push({ ue: parent, table_title: "", fake_ue: true });
            DisplayUETree.dict[parent] = ues[ues.length - 1];
        }
    }
    ues.sort(compare_ue);
    var children = {};
    for (var k in ues)
        children[ues[k].ue] = [];
    for (var k in ues) {
        k = ues[k].ue;
        var parent = node.data[k];
        if (!parent)
            continue;
        children[parent].push(k);
    }

    DisplayUETree.children = children;
    DisplayUETree.parent = node.data;
}
DisplayUETree.need_node = ["UETree", "Grades"];

function DisplayCellAuthor(_node) {
    if (DisplayGrades.cell.author == '')
        return '';
    return '<span class="displaygrey">'
        + _("DisplayCellAuthorBefore") + '</span>&nbsp;'
        + html(DisplayGrades.cell.author);
}
DisplayCellAuthor.need_node = [];

function DisplayCellMTime(_node) {
    if (DisplayGrades.cell.date == '')
        return '';
    return '<span class="displaygrey">' + _("DisplayCellMTimeBefore")
        + '</span>&nbsp;' + date(DisplayGrades.cell.date);
}
DisplayCellMTime.need_node = [];

function DisplayCellComment(_node) {
    if (DisplayGrades.cell.comment == ''
        || DisplayGrades.column.real_type.hide_cell_comment)
        return '';
    return '<span class="displaygrey">' + _("SUIVI_comment") + '</span>&nbsp;'
        + '<span style="font-weight:bold">'
        + html(DisplayGrades.cell.comment).replace(/\n/g, '<br>')
        + '</span>';
}
DisplayCellComment.need_node = [];

function DisplayCellColumn(_node) {
    if (DisplayGrades.column.real_type.hide_column_comment)
        return '';
    // ⏎ for compatibility with old files
    return html(DisplayGrades.column.comment).replace(/[⏎\n]/g, "<br>");
}
DisplayCellColumn.need_node = [];

function DisplayCellGroupMembers(_node) {
    var members = DisplayGrades.cellstats.group_members;
    if (!members)
        return '';
    if (members.length == 0)
        return _('MSG_only_group_member');
    var s = [DisplayGrades.column.groupcolumn + ' : '];
    for (var i in members)
        s.push(members[i][0] + ' ' + members[i][1] + ' ' + members[i][2]);
    return s.join('<br>\n');
}
DisplayCellGroupMembers.need_node = [];

function DisplayCellRank(_node) {
    if (DisplayGrades.cellstats === undefined)
        return ' ';
    if (!DisplayGrades.column.real_weight_add)
        return ' ';

    var s = ' ';
    if (DisplayGrades.cellstats.rank !== undefined)
        s += (DisplayGrades.cellstats.rank + 1)
            + '/' + DisplayGrades.cellstats.nr + ' ';
    if (DisplayGrades.cellstats.rank_grp !== undefined)
        s += (DisplayGrades.cellstats.rank_grp + 1)
            + '/' + DisplayGrades.cellstats.nr_in_grp;
    if (s != ' ')
        s = '<span class="displaygrey">' + _("TH_rank") + '</span>' + s;
    return s;
}
DisplayCellRank.need_node = [];

function DisplayCellAvg(_node) {
    if (DisplayGrades.cellstats === undefined)
        return '';
    if (DisplayGrades.cellstats.average === undefined)
        return '';
    return ' <span class="displaygrey">' + _('Average') + '</span> '
        + DisplayGrades.column.do_rounding(DisplayGrades.cellstats.average)
        + ' <span class="displaygrey">' + _('Mediane') + '</span> '
        + DisplayGrades.cellstats.mediane;
}
DisplayCellAvg.need_node = [];

function DisplayCellDate(_node) {
    var d = DisplayGrades.column.course_dates;
    if (d == '')
        return '';
    d = d.split(/  */);
    var x = '';
    for (var i in d)
        x += get_date_tomuss_short(d[i]) + ' ';

    return '<span class="displaygrey">' + _("SUIVI_course_dates")
        + '</span>' + x;
}
DisplayCellDate.need_node = [];

function DisplayCellType(_node) {
    return '<span class="displaygrey">' + _('B_' + DisplayGrades.column.type)
        + '</span>';
}
DisplayCellType.need_node = [];

function DisplayCellFormula(_node) {
    return DisplayGrades.formula;
}
DisplayCellFormula.need_node = [];

function DisplayCellTitle(_node) {
    var title = html(DisplayGrades.column.title.replace(/_/g, ' '));
    if (cell_modifiable_on_suivi()) {
        var dates = DisplayGrades.column.cell_writable_filter.the_filter.dates(
            DisplayGrades.ue.line_real, DisplayGrades.cell,
            is_a_teacher ? username : display_data['Login'], is_a_teacher);
        if (!dates.forever())
            title += hidden_txt('<span class="limited_time">⏱</span>', dates.__str__().replace(/\n/g, '<br>'));
    }
    if (DisplayGrades.column.is_visible(DisplayGrades.ue.line_real, DisplayGrades.cell)) {
        if (is_a_teacher && DisplayGrades.column.modifiable == 2)
            title = '<div class="modifiable_by_student">' + title + '</div>';
        else if (is_a_teacher && DisplayGrades.column.visibility == 3)
            title = '<div class="public_display">' + title + '</div>';
    }
    else
        title = '<div class="hidden_to_student">' + title
            + (DisplayGrades.column.visibility == 5 ? ' (' + _('unavailable') + ')' : '')
            + '</div>';
    return title;
}
DisplayCellTitle.need_node = [];

function DisplayCellValue(_node) {
    var t = DisplayGrades.column.real_type.formatte_suivi();
    if (!t)
        return '&nbsp;';
    var len;
    if (t.match('>'))
        len = t.split('>')[1].split('<')[0].length;
    else
        len = t.length;
    if (len < 40)
        return t;
    return [t, 'long_text', '', ''];
}
DisplayCellValue.need_node = [];

var display_saved = {};

function enter_in_ue(event) {
    if (popup_classname() === undefined) {
        popup_close();
    }
    var t = document.getElementById("cellbox_tip");
    if (!t || !t.grades)
        return;
    event = the_event(event);
    if (enter_in_ue.ue != event.target) {
        hide_cellbox_tip();
        enter_in_ue.ue = event.target;
    }
}

var select_open;

function hide_cellbox_tip(event) {
    var t = document.getElementById("cellbox_tip");
    if (!t)
        return;
    if (event && select_open) {
        select_open = false;
        return;
    }

    // Tricky: if the cellbox tip has the focus, do not hide it
    var s = document.activeElement;
    while (s) {
        if (s == t) {
            if (document.activeElement.tagName == 'INPUT'
                || document.activeElement.tagName == 'TEXTAREA')
                return true;
        }
        s = s.parentNode;
    }
    t.className = "hidden";
    if (t.grades)
        t.grades.className = t.grades.className.toString()
            .replace(/ tip_displayed/g, "");
}

function display_cellbox_tip(event, nr, focus) {
    if (display_cellbox_tip.do_not_replace) {
        display_cellbox_tip.do_not_replace = false;
        return;
    }
    hide_the_tip_real(true);
    if (hide_cellbox_tip())
        return;
    hide_rightclip();
    var c = the_event(event).target;
    while (c.className.toString().indexOf('CellBox') == -1)
        c = c.parentNode;

    var t = document.getElementById("cellbox_tip");
    if (t.do_not_display) {
        t.do_not_display = false;
        return;
    }
    t.onmouseleave = hide_cellbox_tip;
    t.className = "";
    DisplayGrades.cellbox = c;
    DisplayGrades.column = display_saved[nr][0];
    DisplayGrades.cell = display_saved[nr][1];
    DisplayGrades.html_object = c.getElementsByTagName('FORM')[0]
        || c.getElementsByTagName('INPUT')[0]
        || c.getElementsByTagName('TEXTAREA')[0]
        || c.getElementsByTagName('SELECT')[0]
        || c.getElementsByTagName('BUTTON')[0];
    if (DisplayGrades.html_object && DisplayGrades.html_object.value)
        DisplayGrades.value = DisplayGrades.html_object.value;
    else
        DisplayGrades.value = display_saved[nr][2];
    DisplayGrades.cellstats = display_saved[nr][3];
    DisplayGrades.ue = display_saved[nr][4];
    DisplayGrades.formula = display_saved[nr][5];
    DisplayGrades.table_attr = display_saved[nr][6];
    DisplayGrades.ue_node = display_saved[nr][7];
    DisplayGrades.tabindex = display_saved[nr][8];
    DisplayGrades.display_saved_nr = nr;
    DisplayGrades.no_hover = true;
    t.innerHTML = display_display(display_definition['Cell']);
    if (focus) {
        var elements = ['INPUT', 'TEXTAREA', 'SELECT'];
        for (var i in elements) {
            var input = t.getElementsByTagName(elements[i])[0];
            if (input) {
                input.focus(); // Do not work with SELECT element?
                break;
            }
        }
    }
    DisplayGrades.no_hover = false;
    var h = findPosY(c) - t.childNodes[0].childNodes[0].offsetHeight;
    if (h < 0)
        h = 0;
    t.style.top = h + 'px';
    t.style.left = findPosX(c) + 'px';
    t.display_date = millisec();

    if (t.grades)
        t.grades.className = t.grades.className.toString()
            .replace(/ tip_displayed/g, "");

    t.grades = c;
    while (t.grades.className.toString().indexOf('DisplayUE ') == -1)
        t.grades = t.grades.parentNode;
    t.grades.className += " tip_displayed";
}

function UE_grade_formula() {
    var types = find_ue_grade()[0];
    this.infos = [undefined, [], [], []];
    for (var type = 1; type <= 3; type++) {
        for (var exam in types[type])
            this.infos[type].push(this.analyse(types[type][exam]));
    }
}

UE_grade_formula.prototype.analyse = function (datacols) {
    for (var i = datacols.length - 1; i >= 0; i--) {
        var datacol = datacols[i];
        var value = DisplayGrades.ue.line[datacol][0];
        if (value !== '' && value !== undefined || i == 0) {
            var col = DisplayGrades.ue.columns[datacol];
            var minmax = col.minmax || '[0;20]';
            var min_max = minmax.replace('[', '').replace(']', '').split(';');
            if (value === '' || value === undefined || value.toString() == 'NaN')
                value = '?';
            var course_dates = [];
            if (col.course_dates) {
                var dates = col.course_dates.split(' ');
                for (var i in dates)
                    course_dates.push(get_date_tomuss_short(dates[i]));
            }
            return [
                html(col.title),
                isNaN(value) ? value : do_round(value, col.rounding || 0.01, 0),
                min_max[0],
                min_max[1],
                col.weight || 1,
                course_dates.join(', ')
            ];
        }
    }
};

UE_grade_formula.prototype.html = function () {
    var formula = ['<table class="colored">',
        '<tr><th>', _("B_Moy"),
        '<th>', _("BEFORE_column_attr_columns"),
        '<th>', _("B_Note"),
        '<th>', _("BEFORE_column_attr_weight"),
        '<th>', _("B_Date"),
        '</tr>'];
    for (var type = 1; type <= 3; type++)
        if (this.infos[type].length) {
            formula.push('<tr><th rowspan="' + this.infos[type].length + '">'
                + _("SELECT_column_grade_type_" + type));
            for (var exam in this.infos[type]) {
                var infos = this.infos[type][exam];
                var value = infos[1];
                var min = infos[2];
                var max = infos[3];
                var weight = infos[4];
                if (!isNaN(value))
                    if (min == 0)
                        value += '/' + max;
                    else
                        value += '[' + min + ';' + max + ']';
                if (type === 1)
                    value = 'Max(' + value + ',' + _("SELECT_column_grade_type_3").substr(0, 2) + ')';
                if (exam != 0)
                    formula.push('<tr>');
                formula.push('<td>' + infos[0] + '<td>' + value
                    + '<td>' + weight + '<td>' + infos[5] + '</tr>');
            }
        }
    formula.push('</table>');
    return formula.join('');
};

UE_grade_formula.prototype.full = function () {
    for (var type = 3; type > 0; type--)
        for (var exam in this.infos[type])
            if (this.infos[type][exam][1] === '?')
                return false;
    return true;
};

UE_grade_formula.prototype.formula = function () {
    var formula = ['function _formula_(U) {'];
    for (var type = 3; type > 0; type--) {
        var sum = [];
        var weights = 0;
        for (var exam in this.infos[type]) {
            var infos = this.infos[type][exam];
            var value = infos[1];
            var min = infos[2];
            var max = infos[3];
            var weight = infos[4];
            if (value === '?')
                value = 'U';
            else if (isNaN(value))
                value = 0;
            else
                value = '(' + value + '-' + min + ')/(' + max + '-' + min + ')';
            if (type === 1)
                value = 'Math.max(' + value + ',CT)';
            sum.push(weight + '*' + value);
            weights += Number(weight);
        }
        if (weights > 0) {
            formula.push('var s' + type + '=' + sum.join('+') + ';')
            formula.push('var w' + type + '=' + weights + ';');
        }
        else {
            formula.push('var s' + type + '=0;')
            formula.push('var w' + type + '=1;')
        }
        if (type == 3)
            formula.push('var CT = s3 / w3;')
    }
    formula.push('return (s1+s2+s3)/(w1+w2+w3);');
    formula.push('};_formula_');
    // console.log(formula.join('\n'));
    return eval(formula.join('\n'));
};

function ue_grade_formula() {
    var grade = new UE_grade_formula();
    var fct = grade.formula();
    var message = '';
    if (fct(0) != fct(1)) {
        for (var i = 0; i < 1; i += 0.025)
            if (fct(i) >= 0.5) {
                message = '?=' + (20 * i).toFixed(1) + _("MSG_Ue_Grade");
                break;
            }
    }
    DisplayGrades.column.ue_grade_incomplete = !grade.full();
    return grade.html() + message;
}

function display_tree(column) {
    if (column.type == 'Ue_Grade')
        return ue_grade_formula();
    if (column.average_from.length == 0)
        return '';
    if (!column_modifiable_attr("columns", column))
        return '';
    var s = ['<ul>'];
    var col;
    for (var i in column.average_from) {
        col = columns[data_col_from_col_title(column.average_from[i])];
        if (!col)
            continue;
        s.push('<li>'
            // + '<span class="displaygrey">' + _("B_"+col.type) + '</span> '
            + column.average_from[i]
            + ' <span class="displaygrey">' + _("BEFORE_column_attr_weight")
            + '</span>&nbsp;' + col.weight
            + (display_data['Preferences'].recursive_formula
                ? display_tree(col)
                : '') + '</li>'
        );
    }
    if (column.incomplete)
        s.push('<li>' + _("MSG_suivi_and_hiddens"));
    s.push("</ul>");
    return s.join("");
}

function rank_to_color(rank, nr) {
    var x = Math.floor(511 * rank / nr);
    var b, c = '';
    if (rank > nr / 2) {
        b = '255,' + (511 - x) + ',' + (511 - x);
        if (rank > 3 * nr / 4)
            c = ';color:#FFF';
    }
    else
        b = x + ',255,' + x;

    return 'background: rgb(' + b + ')' + c
}

function grade_to_class(column, grade) {
    if (allowed_grades[grade])
        grade = allowed_grades[grade][0];
    if (grade == abi || grade == abi_short) return 'abinj';
    if (grade == abj || grade == abj_short) return 'abjus';
    if (grade == tnr || grade == tnr_short) return 'tnr';
    if (grade == pre || grade == pre_short) return 'prst';
    if (isNaN(grade)) return '';

    var ci = (grade - column.min) / (column.max - column.min);

    if (ci > 0.8) return 'verygood';
    if (ci > 0.6) return 'good';
    if (ci > 0.4) return 'mean';
    if (ci > 0.2) return 'bad';
    return 'verybad';
}

function get_cell_class_and_style() {
    var classes = ['DisplayType' + DisplayGrades.column.type];
    var styles = [];
    if (display_data['Preferences'] // Turn around bug on multiple suivi student
        && !display_data['Preferences']['black_and_white']
        && !display_data['Preferences']['hide_grade']
    ) {
        if (DisplayGrades.column.red + DisplayGrades.column.green
            + DisplayGrades.column.redtext + DisplayGrades.column.greentext != ''
            && !display_data['Preferences']['no_teacher_color'])
            classes.push(cell_class(DisplayGrades.column,
                DisplayGrades.ue.line_real,
                DisplayGrades.cell));
        else if (DisplayGrades.column.real_weight_add) {
            if (DisplayGrades.cellstats
                && DisplayGrades.cellstats.rank !== undefined
                && DisplayGrades.cellstats.nr >= 10
                && !display_data['Preferences']['color_value']
            )
                styles.push(rank_to_color(DisplayGrades.cellstats.rank,
                    DisplayGrades.cellstats.nr));
            else if ((DisplayGrades.column.type == 'Moy'
                || DisplayGrades.column.type == 'Note'
                || DisplayGrades.column.type == 'Prst'
            )
                && DisplayGrades.cell.value !== ''
                && (
                    display_data['Preferences'].green_prst
                    || DisplayGrades.value != pre
                ))
                classes.push(grade_to_class(DisplayGrades.column,
                    DisplayGrades.value));
        }
    }
    if (DisplayGrades.cell.comment)
        styles.push('font-weight: bold');

    if (DisplayGrades.column.type == 'Ue_Grade' && DisplayGrades.column.ue_grade_incomplete)
        classes.push('Ue_Grade_incomplete');
    classes.push('GT' + DisplayGrades.column.grade_type + 'S' + DisplayGrades.column.grade_session);

    return [classes, styles];
}

function DisplayCellBox(node) {
    if (!is_a_teacher && DisplayGrades.column.title.substr(0, 1) == '.')
        return '';
    var s = DisplayVertical(node);
    var more = '';
    var display_saved_nr = DisplayGrades.display_saved_nr;
    if (display_saved[display_saved_nr] !== undefined)
        DisplayGrades.tabindex = display_saved[display_saved_nr][8]; // Keep old
    else
        DisplayGrades.tabindex = -display_saved_nr; // Temporary number

    if (!DisplayGrades.no_hover) // Stop recursion
    {
        display_saved[display_saved_nr] = [DisplayGrades.column,
        DisplayGrades.cell,
        DisplayGrades.value,
        DisplayGrades.cellstats,
        DisplayGrades.ue,
        display_tree(DisplayGrades.column),
        DisplayGrades.table_attr,
        DisplayGrades.ue_node,
        DisplayGrades.tabindex
        ];
        if (DisplayGrades.column.type == 'Moy') {
            if (DisplayGrades.column.best != 0)
                display_saved[display_saved_nr][5] += _("SUIVI_best_of_before")
                    + DisplayGrades.column.best + _("SUIVI_best_of_after")
                    + '<br>';
            if (DisplayGrades.column.worst != 0)
                display_saved[display_saved_nr][5] += _("SUIVI_mean_of_before")
                    + DisplayGrades.column.worst + _("SUIVI_mean_of_after")
                    + '<br>';
        }
        else if (DisplayGrades.column.type == 'Weighted_Percent'
            || DisplayGrades.column.type == 'Nmbr') {
            display_saved[display_saved_nr][5] = display_saved[display_saved_nr][5]
                .replace("<ul", html(DisplayGrades.column.test_filter) + '<ul');
        }
        more = 'tabindex="' + DisplayGrades.tabindex + '" onfocus="display_cellbox_tip(event,'
            + display_saved_nr + ');" onmousemove="display_cellbox_tip(event,'
            + display_saved_nr + ');" onmouseenter="display_cellbox_tip(event,'
            + display_saved_nr + ');" title="' + encode_value(DisplayGrades.column.title) + '"';
        DisplayGrades.display_saved_nr++;
    }
    else // In the popup box add tabindex in editable content
        s = s.replace(
            /<(input|button|textarea|select)/i,
            '<$1 tabindex="' + (DisplayGrades.tabindex + 1) + '"');
    var class_and_style = get_cell_class_and_style();

    if (DisplayGrades.column.title == DisplayGrades.highlight_column)
        class_and_style[1].push('padding: 1em; border: 6px solid #0F0; border-radius: 1em');

    return [s, class_and_style[0], class_and_style[1], more];
}
DisplayCellBox.need_node = [];

var columns, line;

function create_box_tree(boxes, ordered_columns) {
    for (var data_col in boxes)
        columns[data_col]._tree_done = false;
    do {
        var change = false;
        for (var data_col in boxes) {
            if (boxes[data_col] === '')
                continue;
            var column = columns[data_col];
            if (column._tree_done)
                continue;
            var content = [];
            var possible = true;
            var final = '_final';
            for (var i in column.average_from) {
                if (column.average_from[i].indexOf('/') != -1) {
                    possible = false;
                    break;
                }
                var dc = data_col_from_col_title(column.average_from[i]);
                col = columns[dc];
                if (!col._tree_done) {
                    possible = false;
                    break;
                }
                if (!col)
                    continue;
                if (boxes[dc] === undefined) {
                    // Yet done box must not be focusable by Tab
                    content.push(col._tree_done.replace(/class="Display/, 'class="tree_done Display')
                        .replace(/tabindex="[0-9]*"/, '')
                    );
                    continue;
                }
                content.push(boxes[dc]);
                if (boxes[dc].match(/<div class="tree_node/))
                    final = '';
            }
            if (possible) {
                column._tree_done = boxes[data_col];
                change = true;
            }
            if (possible && content.length) {
                if (content.length == 1)
                    final = '_final';
                boxes[data_col] = ('<div class="tree_node">'
                    + boxes[data_col]
                    + '<span>←</span><div class="tree_leaves' + final + '">'
                    + content.join('') + '</div></div>').replace(/class="is_empty/g, 'class="');
                for (var i in column.average_from)
                    boxes[data_col_from_col_title(column.average_from[i])] = undefined;
                for (var i in ordered_columns)
                    if (ordered_columns[i] == data_col) {
                        ordered_columns.splice(i, 1);
                        ordered_columns.push(data_col);
                    }
            }
        }
    }
    while (change);

    // Create boxes

    function do_merge(base, node) {
        if (Object.keys(node).length == 1 && node[''] !== undefined)
            return node[''];
        var to_merge = [];
        for (var name in node)
            if (name === '')
                to_merge.push(node['']); // data_col
            else
                to_merge.push(do_merge(base + '/' + name, node[name]));

        var display_base = html(base.replace(/_/g, ' '));
        var content = ['<div class="boxed_boxes">',
            '<div class="boxed_boxes_title">',
            display_base,
            '</div>'
        ];
        for (var i in to_merge) {
            if (boxes[to_merge[i]] === undefined) {
                // Yet done box must not be focusable by Tab
                content.push(columns[to_merge[i]]._tree_done.replace(/class="Display/, 'class="tree_done Display')
                    .replace(/tabindex="[0-9]*"/, '')
                );
                continue;
            }
            // The '_' can be converted to space or unsecable space
            content.push(boxes[to_merge[i]].replace(RegExp('>' + protect_regexp(display_base).replace(/ /g, '.') + '/'), '>'));
            boxes[to_merge[i]] = undefined;
        }
        content.push('</div>');
        var first = to_merge[0];
        boxes[first] = content.join('');
        ordered_columns.splice(myindex(ordered_columns, first), 1);
        ordered_columns.push(first);
        return first;
    }
    function add_to_tree(node, data_col, title) {
        var base = title.replace(/\/.*/, '');
        var after = title.replace(base + '/', '');
        if (!isNaN(base.substr(base.length - 1))
            && !isNaN(title.substr(base.length + 1, 1)))
            base = title; // Reject ...[0-9]/[0-9]...
        if (node[base] == undefined)
            node[base] = {};
        if (base === title)
            node[base][''] = data_col;
        else
            add_to_tree(node[base], data_col, after);
    }
    var tree = {};
    for (var i in ordered_columns) {
        var data_col = ordered_columns[i];
        add_to_tree(tree, data_col, columns[data_col].title);
    }
    for (var i in tree)
        do_merge(i, tree[i]);
}

function DisplayUEGrades(node) {
    var ue = DisplayGrades.ue;
    DisplayUEGradesInit(ue);
    DisplayGrades.ue_node = node;
    DisplayGrades.display_saved_nr = ue.display_saved_nr;

    var one_cell_to_display = false;
    var ordered_columns = column_list_all();
    var boxes = {};
    for (var data_col in ordered_columns) {
        data_col = ordered_columns[data_col];
        if (data_col < 3)
            continue;
        if (columns[data_col].freezed == "C")
            continue;
        DisplayGrades.cell = line[data_col];
        DisplayGrades.column = columns[data_col];
        DisplayGrades.value = line[data_col].value;
        if (DisplayGrades.value === '')
            DisplayGrades.value = DisplayGrades.column.empty_is;
        else
            if (DisplayGrades.value.toString() !== 'NaN')
                one_cell_to_display = true;
        one_cell_to_display = one_cell_to_display || cell_modifiable_on_suivi();
        DisplayGrades.cellstats = DisplayGrades.ue.stats[DisplayGrades.column.the_id] || {};
        var ss = display_display(display_definition['CellBox']);
        if ((DisplayGrades.value === '' || DisplayGrades.value.toString() == 'NaN')
            && !cell_modifiable_on_suivi()
            && DisplayGrades.column.type != 'MCQ'
            && !DisplayGrades.column.grade_type)
            ss = ss.replace('class="', 'class="is_empty ');
        boxes[data_col] = ss;
    }
    if (!one_cell_to_display && !ue.fake_ue
        && DisplayUETree.children
        && DisplayUETree.children[ue.ue]
        && DisplayUETree.children[ue.ue].length == 0)
        return [' ', '', "display:none"];

    if (!display_data['Preferences'].compact_suivi)
        create_box_tree(boxes, ordered_columns);
    var s = [' ']; // Not empty in order to generate a <div>
    for (var data_col in ordered_columns) {
        data_col = ordered_columns[data_col];
        if (boxes[data_col])
            s.push(boxes[data_col]);
    }
    s = s.join('');
    var tabindex = DisplayGrades.ue.display_saved_nr;
    function update_tabindex(x) {
        var i = Number(x.split('"')[1]);
        if (i >= 0)
            return x;
        display_saved[-i][8] = (tabindex += 2);
        return ' tabindex="' + display_saved[-i][8] + '" ';
    }
    // XXX Does not work if the displayed content contains «tabindex="..."»
    s = s.replace(/ tabindex="-[1-9][0-9]*" /g, update_tabindex);

    if (ue.ue != DisplayGrades.highlight_ue && !DisplayUEToggle_is_open(ue.ue))
        return [s, "", "display:none"];
    return s;
}
DisplayUEGrades.need_node = [];


function get_nr_real_values_in_the_line(ue) {
    var n = 0;
    for (var i in ue.line)
        if (ue.line[i][1] && ue.line[i][1].length > 1) // Not a fake cell author
            n++;
    return n;
}

/*REDEFINE
 This function allow to sort the table on the suivi page
 in the wanted order.
 By default the UE code and the line content if equality.
*/
function get_ue_priority(ue) {
    if (ue.cached_priority)
        return ue.cached_priority;
    var txt = [ue.ue.replace(/-[1-9]*$/, '')];
    if (txt[0] != ue.ue)
        txt.push(99999 - get_nr_real_values_in_the_line(ue));
    else
        txt.push(90000); // Priority to the table without extension
    for (var i in ue.line)
        txt.push(ue.line[i][0]);
    ue.cached_priority = txt.join('\001');
    return ue.cached_priority;
}

function compare_ue(a, b) {
    if (get_ue_priority(b) < get_ue_priority(a))
        return 1;
    if (get_ue_priority(b) > get_ue_priority(a))
        return -1;
    return 0;
}

function DisplayGrades(node) {
    if (node.data === undefined)
        return '<span style="background:#FF0">' + _("MSG_suivi_student_wait")
            + '</span>';

    node.data[0].sort(compare_ue);
    var s = '';
    var highlight = window.location.pathname.replace(/.*\//, '').split(':');
    DisplayGrades.highlight_ue = highlight[0];
    DisplayGrades.highlight_column = highlight[1] || '';
    for (var i in node.data[0]) {
        DisplayGrades.ue = node.data[0][i];
        if (DisplayUETree.parent
            && DisplayUETree.parent[DisplayGrades.ue.ue] !== undefined
            && DisplayUETree.dict[DisplayUETree.parent[DisplayGrades.ue.ue]]
            !== undefined
        )
            continue;
        try {
            s += display_display(display_definition['UE']);
        }
        catch (e) {
            console.log(e);
            s += '<h1>' + DisplayGrades.ue.ue + ': BUG</h1>' + html(e.toString());
        }
    }
    var before = _("MSG_suivi_student_not_in_TOMUSS_before");
    if (before == "MSG_suivi_student_not_in_TOMUSS_before")
        before = '';
    else
        before += ' ';
    for (var i in node.data[1]) {
        var t = node.data[1][i][0] + ' ' + node.data[1][i][1];
        if (is_a_teacher)
            s += '<p class="title">' + _("MSG_suivi_student_registered") + t + '</p>';
        else
            s += '<div class="UE UETitle">'
                + before
                + t + '</div><div class="UEComment">'
                + _("MSG_suivi_student_not_in_TOMUSS_after")
                + '</div>';
    }
    return '<hr>' + s;
}
DisplayGrades.need_node = ['Login', 'Grades', 'Preferences'];

function goto_cellbox(o) {
    goto_cellbox.old = document.getElementById(o.getAttribute('ue'));
    goto_cellbox.old.className = goto_cellbox.old.className.replace("not_yellow",
        "") + " yellow";
    goto_cellbox.oldo = o;
    o.className = o.className.replace("not_yellow", "") + " yellow";
}

function ungoto_cellbox() {
    if (goto_cellbox.old) {
        goto_cellbox.old.className = goto_cellbox.old.className.replace("yellow",
            'not_yellow');
        goto_cellbox.oldo.className = goto_cellbox.oldo.className.replace("yellow",
            'not_yellow');
    }
}

function cell_visibility_date(cell, column) {
    if (cell[2] === undefined)
        return new Date(0);
    var modif_time = get_date_tomuss(cell[2]);
    if (column.visibility_date === '' || column.visibility_date === undefined)
        return modif_time;
    var column_visible_date = get_date_tomuss(column.visibility_date);
    if (column_visible_date < modif_time || isNaN(column_visible_date.getTime()))
        return modif_time;
    else
        return column_visible_date;
}

function DisplayLastGradesList(time_limit) {
    var grades = display_data['Grades'][0];
    var s = [];

    for (var ue in grades) {
        ue = grades[ue];
        for (var data_col in ue.line) {
            var cell = ue.line[data_col];
            if (cell[0] === '' || cell[0] === undefined)
                continue;
            if (cell[1] === undefined || cell[1].length < 2)
                continue; // System value
            var time = cell_visibility_date(cell, ue.columns[data_col]);
            time.setHours(0);
            time.setMinutes(0);
            time.setSeconds(0);
            time = time.getTime();
            if (time < time_limit)
                continue;
            s.push([ue, data_col, time]);
        }
    }
    s.sort(function (a, b) { return b[2] - a[2]; });
    return s;
}

function DisplayLastGrades(_node) {
    if (is_a_teacher)
        return '';
    var one_week = millisec() - 7 * 24 * 3600000;
    var s = DisplayLastGradesList(one_week);
    if (s.length == 0)
        return '';
    var t = [];
    var today = new Date();
    today.setHours(0);
    today.setMinutes(0);
    today.setSeconds(0);
    today = today.getTime();
    var daynames = [_("LABEL_Day0"), _("LABEL_Day1"), _("LABEL_Day2")];
    var lastday;
    for (var i in s) {
        var ue = s[i][0];
        var data_col = s[i][1];
        var quand = s[i][2];
        var column = ue.columns[data_col];
        var nb_days = Math.round((today - quand) / 86400000);
        var day = daynames[nb_days];
        if (day === undefined)
            day = _("LABEL_ThisWeek");
        if (day != lastday) {
            if (lastday !== undefined)
                t.push("<br>");
            t.push('<div class="Display day">' + day + '</div>');
            lastday = day;
        }
        DisplayUEGradesInit(ue);
        DisplayGrades.ue = ue;
        DisplayGrades.cell = line[data_col];
        DisplayGrades.value = DisplayGrades.cell.value;
        DisplayGrades.column = columns[data_col];
        DisplayGrades.cellstats = ue.stats[DisplayGrades.column.the_id] || {};
        DisplayGrades.column.modifiable_backup = DisplayGrades.column.modifiable;
        DisplayGrades.column.modifiable = false;
        t.push('<div tabindex="0" onmouseover="goto_cellbox(this)"'
            + ' ue="' + ue.ue + '/' + ue.line_id + '"'
            + ' onmouseout="ungoto_cellbox()" class="Display a_grade">'
            + ue.ue
            + '<br>' + html(column.title || '???')
            + '<br><div class="the_grade">'
            + DisplayGrades.column.real_type.formatte_suivi()
            + "</div></div>");
        DisplayGrades.column.modifiable = DisplayGrades.column.modifiable_backup;
    }
    return '<hr>' + t.join('');
}
DisplayLastGrades.need_node = ['Grades'];

function DisplayLogoPopup(_node) {
    if (popup_classname() == 'logo_popup') {
        popup_close();
        return;
    }
    create_popup('logo_popup', _('MSG_suivi_student_logo'),
        DisplayLogo.popup_content, '', false);
}

function DisplayLogo(node) {
    if (node.data === '' || node.data == 'http://xxx.yyy.zzz/logo.png')
        return '';
    var s = [];
    for (var i in node.children)
        s.append(display_display(node.children[i]));
    DisplayLogo.popup_content = s.join("<br>");

    var img = '<img'
        + (node.children.length
            ? ' onclick="DisplayLogoPopup()"'
            : '')
        + ' alt="' + _("MSG_suivi_student_logo") + '"'
        + ' src="' + node.data + '">';

    if (s.length != 0)
        img = hidden_txt(img, _("MSG_suivi_student_logo"));

    return img;
}

function DisplayYearSemester(_node) {
    return '<span class="Display">' + year + '<br>' + semester + '</span>';
}
DisplayYearSemester.need_node = [];

function DisplayGoHome(node) {
    if (!is_a_teacher && node.data)
        return ['<a href="' + add_ticket('') + '">'
            + _("MSG_signature_done") + '</a>',
        [],
        ['width:10em; text-align:center; white-space:normal; font-size:80%']
        ];
}

function DisplaySemesters(node, textual) {
    var y = '9999';
    for (var ys in node.data)
        if (ys < y)
            y = ys;
    y = y.split('/')[0]; // Older year
    var s = semesters[0]; // First semester of the real year

    var t = [], highlight;
    do {
        if (textual) {
            if (node.data[y + '/' + s])
                t.push('<p><a href="' + add_ticket(node.data[y + '/' + s],
                    display_data['Login'] + '/*')
                    + '">' + y + ' ' + s + '</a>'
                );
        }
        else {
            if (s == semesters[0])
                t.push('</tr><tr><td>' + y + '</td>');
            if (y == year && s == semester)
                highlight = ' style="background: #FF0"';
            else
                highlight = '';

            if (is_a_teacher)
                icone = '<img class="icone" src="'
                    + add_ticket(node.data[y + '/' + s], '_' + display_data['Login'])
                    + '">';
            else
                icone = '';
            if (node.data[y + '/' + s])
                t.push('<td' + highlight + '><a href="'
                    + add_ticket(node.data[y + '/' + s], display_data['Login'])
                    + '">' + icone + s + '</a></td>');
            else
                t.push('<td>&nbsp;</td>');
        }

        ys = next_year_semester(y, s);
        y = ys[0];
        s = ys[1];
    }
    while (node.data[y + '/' + s] || s != semesters[0]);
    if (textual)
        return t.join('');
    return '<table class="tomuss_links colored">'
        + '<tr><th colspan="3">'
        + hidden_txt(_("MSG_suivi_student_semesters"),
            _("TIP_suivi_student_semesters"))
        + t.join('\n') + '</tr></table>';
}
DisplaySemesters.need_node = ['Semesters', 'Login'];

function DisplayCivilite(node) {
    if (!display_data['Preferences']['hide_civilite']) {
        if (node.data == 'M.')
            return '♂';
        if (node.data == 'MME')
            return '♀';
    }
    return '';
}
DisplayCivilite.need_node = ['Civilite', 'Preferences'];

function DisplayGetStudent(_node) {
    if (!is_a_teacher)
        return '';
    if (display_data['Referent'][3] == username)
        return ''; // I am yet its referent

    return hidden_txt('<img onclick="catch_this_student('
        + js2(display_data['Login']) + ')" '
        + 'alt="' + _("MSG_home_become_referent") + '" '
        + 'src="' + url_files
        + '/butterflynet.png">', _('MSG_bilan_take_student'));
}
DisplayGetStudent.need_node = ['Referent', 'Login'];

function DisplayUserInfo(_node) {
    if (i_am_root)
        return '<a class="emoji" target="_blank" href="'
            + add_ticket('users/' + display_data['Login']) + '">🔍</a>';
    return '';
}
DisplayUserInfo.need_node = ['Login'];

function DisplayIsPrivate(node) {
    var s = _("MSG_suivi_student_private");
    if (node.data[0])
        s += '<p>' + _("MSG_suivi_student_private_referent")
            + ' ' + DisplayNames(node);
    s += '<hr><a href="' + add_ticket('ask_share/' + display_data['Login']) + '">'
        + _('share_with_me') + '</a>';
    return s;
}

function DisplayPreamble(_node) {
    if (is_a_teacher)
        return '';
    return '<title>TOMUSS</title>' + _("MSG_suivi_student_important");
}
DisplayPreamble.need_node = [];

function DisplayMessages(_node) {
    var m = [];
    var abjs = display_data['Abjs'];
    for (var i in abjs)
        if (abjs[i][2].substr(0, 13) == '{{{MESSAGE}}}')
            m.push(parse_date(abjs[i][0]).formate('%d/%m/%Y')
                + ' : ' + abjs[i][2].replace('{{{MESSAGE}}}', ''));
    return m.join('<br>');
}
DisplayMessages.need_node = ['Abjs'];

function DisplayNewSignature(_node) {
    if (!is_a_teacher)
        return '';
    return hidden_txt('<a href="javascript:signature_new(\''
        + display_data['Login'] + '\')">'
        + _("LABEL_signature_new") + '</a>',
        _("TIP_signature_new"));
}
DisplayNewSignature.need_node = ['Login'];

function sign(t, message_id) {
    if (!confirm(unescape(t.textContent || t.innerHTML)))
        return;
    t.parentNode.style.opacity = 0.5;
    var img = document.createElement('IMG');
    img.src = add_ticket('signature/' + message_id
        + '/' + encode_uri(t.textContent));
    img.style.width = '20px';
    img.style.height = '20px';
    t.parentNode.insertBefore(img, t);
    var b = t.parentNode.getElementsByTagName('BUTTON');
    for (var i = 0; i < b.length; i++)
        b[i].disabled = true;

    var b = document.getElementsByTagName('BUTTON');
    for (var i = 0; i < b.length; i++)
        if (b[i].id != "signature_done" && !b[i].disabled)
            return;
    document.getElementById("signature_done").style.display = 'block';
}

function DisplayAskQuestion(node) {
    return '<h2>' + hidden_txt(_('TITLE_signature')) + '</h2>'
        + node.data.join('') + '<hr>'
        + '<button id="signature_done" style="display:none" onclick="location.reload()">'
        + _('MSG_signature_done') + '</button>';
}

function DisplayAbjs(node) {
    if (node.data.length == 0)
        return '';
    var t = [];
    for (var i in node.data)
        if (node.data[i][2].substr(0, 13) != '{{{MESSAGE}}}') {
            var start = node.data[i][0].split('/');
            var start_day = two_digits(start[0]);
            var start_month = two_digits(start[1]);
            var sort_key = start[2].substr(0, 4) + start_month + start_day;
            var stop = node.data[i][1].split('/');
            var stop_day = two_digits(stop[0]);
            var stop_month = two_digits(stop[1]);
            t.push('<TR><!--' + sort_key
                + '--><TD>' + start_day + '/' + start_month + '/' + start[2]
                + '</TD><TD>' + stop_day + '/' + stop_month + '/' + stop[2]
                + '</TD><TD>' + html(node.data[i][2])
                + '</TD></TR>');
        }
    if (t.length == 0)
        return ''; // Only message and no ABJ
    t.sort();
    return '<TABLE class="display_abjs colored"><tr>'
        + '<th>' + _("MSG_abjtt_from_before")
        + '<th>' + _("TH_until")
        + '<th>' + _("TH_comment")
        + t.join('')
        + '</table>';
}

function display_first_line(txt) {
    txt = html(txt);
    if (txt.indexOf('\n') == -1)
        return txt;
    var t = txt.split('\n');
    return t[0] + hidden_txt('<br><b>' + _("MSG_see_more") + '</b>',
        t.slice(1, t.length).join(''));
}

function DisplayDA(node) {
    if (node.data.length == 0)
        return '';

    var t = [];
    for (var i in node.data)
        t.push('<TR><TD>' + node.data[i][0] + '</TD><TD>' + node.data[i][1]
            + '</TD><TD>' + display_first_line(node.data[i][2])
            + '</TD></TR>');

    return '<TABLE class="display_abjs colored"><tr>'
        + '<th>' + _("TH_da_for_ue")
        + '<th>' + _("MSG_abj_tt_from")
        + '<th>' + _("TH_comment")
        + t.join('')
        + '</table>';
}

function DisplayRSS(node) {
    if (node.data === false)
        return '<iframe src="' + add_ticket('rsskey') + '"></iframe>';

    return hidden_txt('<a href="' + url_suivi + '/rss/' + node.data + '">'
        + _("MSG_suivi_student_RSS")
        + '<img src="' + url_files
        + '/feed.png" alt="' + _("TIP_suivi_student_RSS")
        + '" style="border:0px"></a>',
        _("TIP_suivi_student_RSS"))
        + '<link href="' + url_suivi + '/rss/' + node.data
        + '" rel="alternate" title="TOMUSS" type="application/rss+xml">';
}

function DisplayLinksTable(node) {
    if (node.children.length == 0)
        return '';
    var t = ['<table class="colored"><tr><th colspan="2">'
        + _('SUIVI_linkstable') + '</tr>'];
    var i = 0;
    for (var ii in node.children) {
        if (i % 2 == 0) {
            if (i != 0)
                t.push('</tr>');
            t.push('<tr>');
        }
        var c = display_display(node.children[ii]);
        if (display_data['Preferences']['debug_suivi']) {
            t.push('<td>' + (c || ('<span class="displaygrey">'
                + node.children[ii].name + '</span>')));
            i++;
        }
        else {
            if (c !== '') {
                t.push('<td>' + c);
                i++;
            }
        }
    }
    if (i % 2 == 1)
        t.push('<td>&nbsp;');
    t.push('</tr></table>');
    return t.join('');
}
DisplayLinksTable.need_node = ['Preferences'];

function DisplayTT(node) {
    return '<TABLE class="colored"><tr><th>' + _("MSG_suivi_student_tt") + '</tr>'
        + '<tr><td>' + html(node.data).replace(/\n/g, '<br>') + '</tr></table>';
}

function get_monday(date) {
    date = new Date(date.getTime() - (date.getDay() - 1) * 86400000);
    return date.formate('%d/%m/%Y');
}

function DisplayP_template(node) {
    if (node.data.length == 0)
        return '';
    var t = ['<style>',
        '.P TD { font-family: emoji ;font-size: 50%; vertical-align:top; cursor:pointer }',
        'DIV.ptip { font-size: 200%; padding: 1em; white-space: nowrap }',
        '</style><table class="colored P"><tr><th>',
        '<span style="color:#080">', pre.toLowerCase(), '</span>/',
        '<span style="color:#F00">', abi.toLowerCase(), '</span>/',
        '<span style="color:#00F">', abj.toLowerCase(), '</span>'
    ];
    var day_names = eval(_("MSG_days_full"));
    for (var i = 1; i < 6; i++)
        t.push("<th>" + day_names[i].substr(0, 3));
    var week = ''; // Monday date
    var wday; // Day of the week
    var morning, ok, infos;
    for (var i in node.data) {
        var d = node.data[i][0];
        var year = Number(d.substr(0, 4));
        var month = Number(d.substr(5, 2)) - 1;
        var date = Number(d.substr(8, 2));
        var hour = Number(d.substr(11, 2));
        var minute = Number(d.substr(14, 2));
        d = new Date(year, month, date, hour, minute);
        var monday = get_monday(d);
        if (monday != week) {
            t.push('</tr><tr><th>' + monday + '<td>');
            week = monday;
            wday = 1;
            morning = true;
        }
        for (var j = d.getDay() - wday; j > 0; j--) {
            t.push('<td>');
            morning = true;
        }
        wday = d.getDay();
        if (hour > 12 && morning) {
            morning = false;
            t.push("<BR>");
        }
        ok = node.data[i][1][0].replace('@', '');
        if (ok == pre)
            ok = '🟢';
        else if (ok == abj)
            ok = '🔵';
        else
            ok = '🔴';
        infos = node.data[i][1][1].split(' ')
        t.push(hidden_txt(ok, '<div class="ptip">'
            + two_digits(hour) + ':' + two_digits(minute) + '<br>'
            + infos[0] + '<br>' + infos[1] + '</div>'));
    }
    t.push('</tr></table>');
    return t.join('');
}


function memberof_tree(lines, line, column, max, need_tr) {
    var i;
    for (i = line + 1; i < max; i++) {
        if (lines[i][column] !== lines[i - 1][column])
            break;
    }
    var nb = i - line;
    var s = '';
    if (need_tr)
        s += '<tr>';
    s += '<td rowspan="' + nb + '">' + lines[line][column];
    if (lines[line][column + 1] === undefined)
        return { 'html': s + '</tr>', 'nb': 1 };
    i = line;
    need_tr = false;
    while (i < line + nb) {
        var r = memberof_tree(lines, i, column + 1, line + nb, need_tr);
        s += r['html'];
        i += r['nb'];
        need_tr = true;
    }
    return { 'html': s, 'nb': nb };
}

function DisplayMemberOf(node) {
    if (!is_a_teacher)
        return '';
    var grp, reversed = [];
    for (var i in node.data[0]) {
        grp = node.data[0][i].split(',');
        grp.reverse();
        reversed.push(grp);
    }
    reversed.sort();

    // The 'overflow' indicates to the tip framework to not hide the tip
    var mo = '<div style="overflow:scroll; height:20em;overflow-x: hidden">'
        + '<table class="memberof">';
    for (var i = 0; i < reversed.length;) {
        var r = memberof_tree(reversed, i, 0, reversed.length, true);
        mo += r['html'];
        i += r['nb'];
    }
    mo += '</table></div>';

    var etapes = '';
    for (var i in node.data[1])
        etapes += ' ' + hidden_txt(node.data[1][i][0], html(node.data[1][i][1]));

    return hidden_txt(_("MSG_suivi_student_memberof"), mo)
        .replace('<div class="text">', '<div class="text" instanttip="1">') + etapes;
}

function DisplayACLS(node) {
    if (node.data === undefined || !is_a_teacher)
        return '';
    var groups = [];
    for (var i in node.data)
        groups.push(i);
    groups.sort();
    var s = [];
    for (var i in groups) {
        i = groups[i];
        s.push(node.data[i] ? i : '<span style="color: #888">' + i + '</span>');
    }
    return '<div style="font-size: 80%">ACLS: ' + s.join(", ") + '</div>';
}

function DisplayStudents(node) {
    var s = _("MSG_suivi_student_contact_for") + '<table class="colored">';
    for (var i in node.data) {
        s += '<tr>';
        for (var j in node.data[i])
            s += '<td>' + html(node.data[i][j] || '');
        s += '</tr>';
    }
    return s + '</table>';
}

function DisplayTables(node) {
    var s = [];
    if (node.data.length == 0)
        return '';
    node.data.sort();
    s.push('<hr>' + _("MSG_suivi_student_ue_changes"));
    for (var year = node.data[0][0]; year <= node.data[node.data.length - 1][0]; year++) {
        for (var sem = 0; sem < semesters.length; sem++) {
            var semester = semesters[sem];
            var ss = [];
            for (var i in node.data)
                if (node.data[i][0] == year && node.data[i][1] == semester)
                    ss.push('<a target="_blank" href="'
                        + add_ticket(year
                            + '/' + semester + '/' + node.data[i][2]
                            + '/=full_filter=@' + display_data['Login']) + '">'
                        + node.data[i][2] + '</a><sup>'
                        + hidden_txt(node.data[i][3],
                            _("TH_suivi_student_nr_grades"))
                        + '</sup> ');
            if (ss.length)
                s.push('<tr><td>' + year + '&nbsp;' + semester + '<td>'
                    + ss.join('') + '</tr>');
        }
    }
    return '<table class="colored">' + s.join('') + '</table>';
}
DisplayTables.need_node = ['Tables', 'Login'];

function DisplayMoreOnSuivi(node) {
    return node.data;
}


function tomuss_plusone() {
    gapi.plusone.render('tomuss_plusone',
        {
            'href': "http://perso.univ-lyon1.fr/thierry.excoffier/TOMUSS/home.html",
            'size': 'medium'
        }
    );

    function facebook(d, s, id) {
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) return;
        js = d.createElement(s); js.id = id;
        js.src = "https://connect.facebook.net/en_US/sdk.js#xfbml=1&appId=527673290646131&version=v2.0";
        fjs.parentNode.insertBefore(js, fjs);
    };
    facebook(document, 'script', 'facebook-jssdk');
}

function DisplayAdvertising(node) {
    if (node.data == false)
        return '';
    if (!tomuss_plusone.done) {
        setTimeout(tomuss_plusone, 1000);
        tomuss_plusone.done = true;

        var po = document.createElement('script');
        po.type = 'text/javascript';
        po.async = true;
        po.defer = true;
        po.src = 'https://apis.google.com/js/platform.js';
        the_body.appendChild(po);
    }

    return '<div id="fb-root"></div><div style="margin-top:1em;"><small>' + _("DisplayAdvertising")
        + '&nbsp;:</small><br><div id="tomuss_plusone"></div><br>'
        + '<div class="fb-like" data-href="http://perso.univ-lyon1.fr/thierry.excoffier/TOMUSS/home.html" data-layout="button_count" data-action="like" data-show-faces="false" data-share="false"></div>';
}
DisplayAdvertising.need_node = [];


function DisplaySetReferentDo(student, t) {
    var answer = prompt(_("MSG_suivi_student_set_referent_name"));
    if (answer !== null && answer !== '') {
        t.parentNode.innerHTML +=
            '<br><IFRAME style="width:100%;height:5em" src="'
            + add_ticket('referent_set_force/' + answer + '/' + student)
            + '"></IFRAME>';
    }
}


function DisplaySetReferent(_node) {
    if (!is_a_teacher)
        return '';
    return '<div id="DisplaySetReferent"><a onclick="DisplaySetReferentDo(\''
        + display_data['Login'] + '\',this)">'
        + _("MSG_suivi_student_set_referent") + '</a></div>';
}
DisplayAdvertising.need_node = ['SetReferent', 'Login'];


function DisplayGrpMessages(node) {
    var s = '';
    for (var i in node.data)
        s += '<div>' + node.data[i] + '</div>';
    return s;
}

function DisplayToTextual(_node) {
    var today = new Date();
    var img = special_days[today.getDate() + '/' + (today.getMonth() + 1)] || "●";

    return '<a href="' + add_ticket(display_data['Login'], '*') + '"'
        + (img == "●" ? '' : ' style="font-size:200%"') + '>'
        + img + '<span style="color: #FFF;font-size: 2px; opacity: 0.1">'
        + _("MSG_T_to_textual") + '</span></a>';
}
DisplayToTextual.need_node = ['Login'];

function DisplayT_Title(_node) {
    the_body.className = 'textual';
    return '<title>TOMUSS</title>' + year + ' ' + semester + ', '
        + display_data['T_Names'][0] + ' '
        + display_data['T_Names'][1] + ', '
        + display_data['Login'] + ', '
        + display_data['T_Names'][2] + '<br>'
        + _("MSG_suivi_student_important");
}
DisplayT_Title.need_node = ['T_Names', 'Login'];

function DisplayT_Message(node) {
    return '<section><h2>' + html(node.data) + '</h2></section>';
}

function DisplayT_Messages(node) {
    var m = DisplayMessages(node);
    var s = '';
    s += '<p>' + m + '</p>';
    for (var i in node.data)
        s += '<p>' + node.data[i] + '</p>';
    if (s === '')
        return "";
    return '<section><h2>' + _("MSG_T_Messages") + '</h2>' + s + '</section>';
}
DisplayT_Messages.need_node = ['Abjs'];


function DisplayT_Grades_Lasts(_node) {
    display_data['Grades'] = display_data['T_Grades']; // Compatibility
    var one_month = millisec() - 30 * 24 * 3600000;
    var s = DisplayLastGradesList(one_month);
    var t = [];
    for (var i in s) {
        DisplayUEGradesInit(s[i][0]);
        DisplayGrades.ue = s[i][0];
        DisplayGrades.column = columns[s[i][1]];
        DisplayGrades.column.modifiable_backup = DisplayGrades.column.modifiable;
        DisplayGrades.column.modifiable = false;
        t.push(DisplayT_Grades_Cell(true));
        DisplayGrades.column.modifiable = DisplayGrades.column.modifiable_backup;
    }
    return '<section><h2>' + _("MSG_T_last_grades") + '</h2>' + t.join("")
        + '</section>';
}
DisplayT_Grades_Lasts.need_node = ['T_Grades'];

var translated_acronyms = ["abi", "abj", "pre", "tnr", "ppn"];

function DisplayT_Grades_Cell(display_ue) {
    var column = DisplayGrades.column;
    DisplayGrades.cell = line[column.data_col];
    DisplayGrades.value = DisplayGrades.cell.value;
    if (DisplayGrades.value === '')
        DisplayGrades.value = column.empty_is;
    if (DisplayGrades.value === '' && !cell_modifiable_on_suivi())
        return '';
    DisplayGrades.cellstats = DisplayGrades.ue.stats[column.the_id] || {};
    var sep = '<p>';
    var formula = '';
    var cellstats = DisplayGrades.cellstats;
    var cell = DisplayGrades.cell;
    if (column.average_from && column.average_from.length) {
        formula = [];
        for (var i in column.average_columns) {
            var col = columns[column.average_columns[i]];
            var s = html(col.title).replace(/[-_]/g, " ");
            if (column.type == 'Moy')
                s += ' ' + _("MSG_T_weight") + ' ' + col.weight;
            formula.push(s);
        }
        formula = sep + _('B_' + column.type)
            + (column.type == 'Weighted_Percent' || column.type == 'Nmbr'
                ? " '" + html(column.test_filter) + "'"
                : '')
            + ' : ' + formula.join(', ');
    }
    var formatted = column.real_type.formatte_suivi()
        .replace(RegExp('>/([0-9])'), '>' + _('MSG_T_on') + '$1')
        .replace(/0*<small/g, '<small')
        .replace(/[.]<small/g, '<small');
    var column_comment = html(column.comment);
    if (DisplayGrades.column.real_type.hide_column_comment)
        column_comment = '';
    var comment = html(cell.comment);
    if (DisplayGrades.column.real_type.hide_cell_comment)
        comment = '';
    if (!cell_modifiable_on_suivi()) {
        //  PRST → Present
        for (var i in translated_acronyms)
            formatted = formatted.replace(RegExp(_(translated_acronyms[i])),
                _('MSG_T_' + translated_acronyms[i]).toLowerCase());
        if (column.type == 'Notation') {
            // The only case is the Notation column type
            var tip = formatted.replace(/.*(<table.*<.table>).*/, "$1");
            comment = tip.replace("<table", '<table style="width:auto"');
        }
    }
    return '<section><h4>'
        + (display_ue ? html(DisplayGrades.ue.ue)
            + ' ' + html(DisplayGrades.ue.table_title || '') + ', ' : '')
        + html(column.title.replace(/[-_]/g, ' '))
        + ' : ' + formatted
        + ((column.grade_type || 0) > 0
            ? '. ' + _('SELECT_column_grade_type_' + column.grade_type).substr(4)
            + '. '
            + _('SELECT_column_grade_session_' + column.grade_session).substr(4).split(' (')[0]
            : '')
        + '</h4>'
        + (column_comment
            ? sep + _('MSG_T_column_comment') + ' ' + column_comment
            : '')
        + (comment
            ? sep + _('MSG_T_cell_comment') + ' ' + comment
            : '')
        + (cell.author.length > 1
            ? sep + _('MSG_T_cell_author') + ' ' + html(cell.author.replace(/[.]/, ' '))
            : '')
        + (cell.author.length > 1
            ? sep + _('MSG_T_cell_date') + ' ' + date_full(cell.date)
            : '')
        + formula
        + (cellstats && column.real_weight_add && cellstats.rank !== undefined
            ? sep + _('MSG_T_rank_global') + ' ' + (cellstats.rank + 1)
            + _('MSG_T_on') + DisplayGrades.cellstats.nr
            : '')
        + (cellstats && column.real_weight_add && cellstats.rank_grp !== undefined
            && cellstats.nr_in_grp != cellstats.nr
            ? sep + _('MSG_T_rank_group')
            + ' ' + (cellstats.rank_grp + 1)
            + _('MSG_T_on') + cellstats.nr_in_grp
            : '')
        + (cellstats && cellstats.average !== undefined
            ? sep + _('MSG_T_average') + ' ' + cellstats.average.toFixed(2)
            + sep + _('MSG_T_mediane') + ' ' + cellstats.mediane.toFixed(2)
            : '')
        + (column.type == 'Ue_Grade'
            ? ue_grade_formula()
            : '')
        + '</section>'
        ;
}


function DisplayT_Grades(_node) {
    display_data['Grades'] = display_data['T_Grades']; // Compatibility
    var grades = display_data['T_Grades'][0];
    var u = [];
    for (var ue in grades) {
        ue = grades[ue];
        DisplayGrades.ue = ue;
        DisplayUEGradesInit(ue);
        var ordered_columns = column_list_all();
        var g = [];
        for (var data_col in ordered_columns) {
            data_col = ordered_columns[data_col];
            if (data_col < 3)
                continue;
            if (columns[data_col].freezed == "C")
                continue;
            DisplayGrades.column = columns[data_col];
            g.push(DisplayT_Grades_Cell());
        }
        u.push('<section><h3>' + ue.ue + ' ' + html(ue.table_title || '')
            + ((ue.masters && ue.masters.length != 0)
                ? ', ' + _("MSG_T_masters") + ' ' + DisplayUEMasters()
                : '')
            + '</h3>'
            + (ue.comment && ue.comment !== '' ? _('MSG_cell_message')
                + add_link_on_url(html(ue.comment)) : '')
            + '<a name="' + ue.ue + '">' + g.join('') + '</a></section>');
    }
    u.sort();

    return '<section><h2>' + _("MSG_T_UEs") + '</h2>' + u.join("") + '</section>';
}
DisplayT_Grades.need_node = ['T_Grades', 'Login'];

function DisplayT_Abjs(node) {
    display_data['Abjs'] = display_data['T_Abjs']; // Compatibility
    var m = DisplayAbjs(node);
    if (m)
        return '<section><h2>' + _("MSG_T_Abjs") + '</h2>' + m + '</section>';
    else
        return '';
}

function DisplayT_DA(node) {
    display_data['DA'] = display_data['T_DA']; // Compatibility
    var m = DisplayDA(node);
    if (m)
        return '<section><h2>' + _("TITLE_abjtt_da") + '</h2>' + m + '</section>';
    else
        return '';
}

function DisplayT_TT(node) {
    display_data['TT'] = display_data['T_TT']; // Compatibility
    var m = DisplayTT(node);
    if (m)
        return '<section><h2>' + _("MSG_suivi_student_tt") + '</h2>'
            + m + '</section>';
    else
        return '';
}

function DisplayT_Semesters(node) {
    display_data['Semesters'] = display_data['T_Semesters']; // Compatibility
    var m = DisplaySemesters(node, true);
    if (m)
        return '<section><h2>' + _("MSG_suivi_student_semesters")
            + '</h2>' + m + '</section>';
    else
        return '';
}
DisplayT_Semesters.need_node = ['T_Semesters', 'Login'];

function DisplayT_LinksTable(node) {
    var s = [];
    var content = node.children[0].children;
    s.push('<ul>')
    for (var i in content) {
        c = display_display(content[i]);
        if (c !== '') {
            c = c.replace(/<div class=.(tipped|help|text)[^>]*>/g, '<div >');
            c = c.replace(/<\/?p>/g, '');
            if (c.indexOf('<div >') != -1) {
                var t = c.split('<div >');
                c = t[0] + t[3].split(/<\/?div>/)[0] + ' : '
                    + t[2].split(/<\/?div>/)[0] + '</div>';
            }
            s.push('<li>' + c);
        }
    }
    s.push('</ul>');
    return '<section><h2>' + _("MSG_T_informations") + '</h2>'
        + s.join("\n") + '</section>';
}
DisplayT_LinksTable.need_node = [];


function DisplayRSSStream(node) {
    var html = [];
    for (var stream in node.data) {
        html.push('<table class="colored">'
            + '<tr><th><div style="text-align:center">'
            + node.data[stream][1] + '</div></tr>');
        for (var i in node.data[stream][2]) {
            var news = node.data[stream][2][i];
            var titre = news[0];
            var description = news[1];
            var link = news[2];
            html.push('<tr><td><a target="_blank" href="' + link + '">')
            if (description !== '')
                titre = hidden_txt(titre, description);
            html.push(titre);
            html.push('</a></tr></td>')
        }
        html.push('</table>')
    }
    return html.join('');
}







//////////////////////// Display Sunburst functions ///////////////////////////////////////////////
// ----- Root -----------------------------------
function build_root_with_grades() {
    // Create sunburst.root with student_catalog and display_grades
    // students_catalog is defined in TMP/0/COMPETENCES/INF.js
    var keys = [];
    var grades = display_data["Grades"][0];
    for (var i in grades) {
        var sss = grades[i];
        if (!sss.fake_ue) {
            var line = sss["line"];
            for (var j in sss["columns"])
                if (sss["columns"][j]["type"] == "Competences" && line[j] && line[j][0])
                    keys = keys.concat(line[j][0].split(' '));
        }
    }

    // Add ungraded competences of the formation :
    if (keys.length > 0) {
        var formation = key_split(keys[0])[0];
        keys = keys.concat(student_catalog.get_formation_vocabs(formation));
    }

    DisplaySunburst.root = make_array_tree(get_tree_of(keys));
}
function tree_depth(tree, is_root = true) {
    var depth = 0;
    var head = 1;
    if (is_root) head = 0;

    for (i in tree) {
        if (i > head)
            depth = Math.max(depth, tree_depth(tree[i], false));
    }
    return depth + 1;
}
function grade_tree_simplify(target_tree, tot_depth, layer, is_root = true) {
    var tree = target_tree.slice();
    var head = is_root ? 0 : 1;
    if (layer + 1 >= tot_depth)
        for (var i = tree.length - 1; i > head; i--)
            if (tree[i][1] == 0)
                tree.splice(i, 1);

    for (var i = tree.length - 1; i > head; i--) {
        if (tree[i][0].indexOf('+') !== -1)
            tree.splice(i, 1);
        else if (tree[i][1] == 0)
            tree[i] = [tree[i][0], 0];
        else
            tree[i] = grade_tree_simplify(tree[i], tot_depth, layer + 1, false);
    }

    // Delete useless layers
    if (is_root)
        while (tree.length == 2) {
            tree = tree[1];
            tree.splice(0, 1);
        }
    return tree;
}

// ----- Draw -----------------------------------
function slice_path(ctx, layer, button_height, size, gap) {
    var distance = (1 + layer) * button_height;
    ctx.beginPath();
    ctx.arc(0, 0, distance, gap, gap + size, false);
    ctx.arc(0, 0, button_height + distance, gap + size, gap, true);
    ctx.closePath();
}
function sun_button(ctx, observation, layer, button_height, size, gap, comp, x, y) {
    ctx.fillStyle = observation_color(observation);
    slice_path(ctx, layer, button_height, size, gap);
    var inside = x && ctx.isPointInPath(x, y);
    if (inside) {
        update_comp_infos(comp, observation);
        inside = [observation_color(observation), layer, button_height, size, gap];
    } else {
        ctx.lineWidth = 0.005;
        ctx.fill();
        ctx.stroke();
    }
    return inside;
}
function draw_branch(ctx, root, size, global_gap, depth, button_height, x, y) {
    var focused;
    var leaves = 0
    if (root.length > 2) {
        for (competence in root.slice(2)) {
            var gap = global_gap + size * leaves;
            var branch = draw_branch(ctx, root[Number(competence) + 2], size, gap, depth + 1, button_height, x, y)
            leaves += branch[0];
            if (!focused)
                focused = branch[1];
        }
    } else
        leaves = 1;

    var total_size = size * leaves;
    var mouse_on = sun_button(ctx, root[1] || 0, depth, button_height, total_size, global_gap, root[0], x, y);
    return [leaves, focused || mouse_on];
}
function draw_sunburst(button_height, x, y, clicked = false) {
    var root = DisplaySunburst.tree;
    var canvas = document.getElementById("sunburst");
    // Base
    var ctx = sunburst_init.ctx;
    var focused = false;
    ctx.beginPath();
    ctx.clearRect(-2, -2, 4, 4);
    ctx.arc(0, 0, button_height, 0, Math.PI * 2);
    ctx.fillStyle = observation_color(root[0]);
    ctx.fill();
    // Sun tree
    var size = Math.PI * 2 / get_arr_tree_leaves(root, false).length;
    var gap = 0;

    for (comp in root.slice(1)) {
        var branch = draw_branch(ctx, root[Number(comp) + 1], size, gap, 0, button_height, x, y)
        if (!focused)
            focused = branch[1];
        gap += branch[0] * size;
    }
    // Cursor
    if (focused && focused != 0) {
        slice_path(ctx, focused[1], focused[2], focused[3], focused[4]);
        ctx.fillStyle = focused[0];
        ctx.fill();
        ctx.fillStyle = "rgba(50, 50, 50, 0.35)";
        ctx.fill();
        ctx.lineWidth = 0.01;
        ctx.strokeStyle = "#222222";
        ctx.stroke();

        canvas.style.cursor = 'pointer';
        if (clicked)
            update_graphics_with_infos();
    } else {
        canvas.style.cursor = 'auto';
        update_comp_infos();
    }
}

// ----- Update ---------------------------------
function update_comp_infos(comp, observation) {
    var infos = document.getElementById("sunburst-infos").childNodes;

    if (comp) {
        var comp_grades = DisplaySunburst.grades[comp];
        infos[0].innerText = comp_grades && comp_grades[observation] ?
            comp_grades[observation] : student_catalog.vocabulary['o'][observation];
        infos[1].style.backgroundColor = observation_color(observation);
        infos[2].innerText = student_catalog.vocabulary[comp[0]][Number(comp[1])];
    } else {
        infos[0].innerText = _('TITLE_competences');
        infos[1].style.backgroundColor = observation_color(0);
        infos[2].innerText = _("MSG_comp_description");
    }
}
function update_graphics_with_infos() {
    var graphics = document.getElementById("competence-graphics");
    var infos = document.getElementById("sunburst-infos");
    if (graphics)
        graphics.innerText = infos.innerText;
}
function sunburst_update() {
    DisplaySunburst.tree = grade_tree_simplify(
        DisplaySunburst.root,
        tree_depth(DisplaySunburst.root),
        display_data['Preferences'].sunburst_hide_layers
    );

    var button_height = Math.min(1 / tree_depth(DisplaySunburst.tree), 0.2);
    draw_sunburst(button_height, 0, 0);
    return button_height;
}
function sunburst_prefs_switch(value) {
    console.log("oui !")
    display_data['Preferences'].sunburst_hide_layers = Number(value);
    sunburst_update();
}

// ----- Init -----------------------------------
function sunburst_init() {
    var depth = tree_depth(DisplaySunburst.root);
    document.getElementById("DisplaySunburst").innerHTML = [
        '<canvas id="sunburst" width="400" height="', Math.min(depth * 80, 400), '" style="width: 330px"></canvas>',
        '<div id="sunburst-infos" style="border:1px solid #999; margin:0; width:100%; text-align:center; font-size: 0.9em">',
        '<p style="min-height:1em; background-color:#E8E8E8"></p>',
        '<div style="border:1px solid #303030; height:0.5em; width:100%; background-color: #CCC"></div>',
        '<p style="padding: 0 0.5em 0 0.5em; min-height: 5em"></p>',
        '</div>'].join("");

    var canvas = document.getElementById("sunburst");
    if (!canvas.getContext)
        return;
    var ctx = canvas.getContext("2d");
    sunburst_init.ctx = ctx;
    ctx.translate(canvas.width / 2, canvas.height / 2);
    ctx.scale(canvas.width * 0.48, canvas.width * 0.48);

    var scale = canvas.height / canvas.getBoundingClientRect().height;
    var button_height = sunburst_update();

    canvas.addEventListener("mousemove", (event) => {
        var x = Math.round(event.offsetX * scale);
        var y = Math.round(event.offsetY * scale);
        draw_sunburst(button_height, x, y);
    }, false);
    canvas.addEventListener("click", (event) => {
        var x = Math.round(event.offsetX * scale);
        var y = Math.round(event.offsetY * scale);
        draw_sunburst(button_height, x, y, true);
    }, false);
}
function try_sunburst_init() {
    if (!document.getElementById("DisplaySunburst"))
        setTimeout(try_sunburst_init, 100);
    else {
        build_root_with_grades();
        if (DisplaySunburst.root.length > 1)
            sunburst_init();
    }
}
// ----- Main -----------------------------------
function DisplaySunburst(_node) {
    DisplaySunburst.root = undefined;
    DisplaySunburst.grades = {}; // JSON.parse(table_attr.competence).grades_vocab;
    try_sunburst_init();
    return '<div id="DisplaySunburst"/>';
}
DisplaySunburst.need_node = ["Grades", "Preferences"];

function DisplaySkillsTable(_node) {
    return '';/* XXX in building
    '<div id="competence_table" style=" background-color: #DDD;'
        + 'padding: 20px; width: 100%;  min-height: 3cm;">Contenu Table des Compétences</div>'*/
}
DisplaySkillsTable.need_node = null;