#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2021 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

"""
"""

def normalize_regtest(use_selector):
    """Test without selectors"""
    average_columns = [1]
    if use_selector:
        average_columns.append(0)
    columns_set([Column(),
                 Column(),
                 Column({"average_columns":average_columns}),
                 Column({"average_columns":average_columns}),
                 Column({"average_columns":[]}),
                ])
    columns[1].table.lines = {
        i: line
        for i, line in enumerate([
        [Cell('A'), Cell(1.), CE(8.), CE(-10.), CE('')],
        [Cell('A'), Cell(2.), CE(9.), CE(0.), CE('')],
        [Cell('A'), Cell(3.), CE(10.), CE(10.), CE('')],
        [Cell('A'), Cell(4.), CE(11.), CE(20.), CE('')],
        [Cell('A'), Cell(5.), CE(12.), CE(30.), CE('')],
        [Cell('A'), Cell(abi), CE(abi), CE(abi), CE('')],
        [Cell('A'), Cell(''), CE(''), CE(''), CE('')],
        ])}
    columns[2].normalize = "10 1.4142135623730951"
    columns[3].normalize = "10 14.142135623730951"
    lines = columns[1].table.lines
    if use_selector:
        lines['B'] = [Cell('B'), Cell(10.),
                      CE(nan), CE(nan), CE('')]
        lines['C1'] = [Cell('C'), Cell(9.),
                       CE(8.585786437626904), CE(-4.142135623730951), CE('')]
        lines['C2'] = [Cell('C'), Cell(11.),
                       CE(11.414213562373096), CE(24.14213562373095), CE('')]
    for line_id in lines:
        check_result(lines[line_id], 2, compute_normalize)
        check_result(lines[line_id], 3, compute_normalize)
        check_result(lines[line_id], 4, compute_normalize)

normalize_regtest(False)
normalize_regtest(True)
