#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2024 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

"""
"""

def rank_regtest():
    """Test"""
    columns_set([Column(),
                 Column({"average_columns":[0]}),
                ])
    columns[0].table.lines = {
        i: line
        for i, line in enumerate([
        [Cell('2'), CE(2)],
        [Cell('1'), CE(4)],
        [Cell('5'), CE(1)],
        [Cell(2), CE(2)],
        [Cell('') , CE('')],
        [Cell(abi), CE('')],
        [Cell(0), CE(6)],
        [Cell('0'), CE(6)],
        [Cell(-0.5), CE(8)],
        [Cell(-1), CE(9)],
        [Cell('0.5'), CE(5)],
        ])}
    lines = columns[1].table.lines
    for line_id in lines:
        check_result(lines[line_id], 1, compute_rank)

    columns_set([Column(),
                 Column({"average_columns":[]}),
                ])
    columns[0].table.lines = {
        i: line
        for i, line in enumerate([
        [Cell('2'), CE('')],
        [Cell('0.5'), CE('')],
        ])}
    lines = columns[1].table.lines
    for line_id in lines:
        check_result(lines[line_id], 1, compute_rank)


rank_regtest()
print('Rank test is fine')
