#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2022 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

"""
"""

def parse_replacements(txt):
    replacements = []
    for replace in txt.split('●'):
        left_right = replace.split('🡆')
        if len(left_right) == 2:
            left, right = left_right
            replacements.append([Filter(left, 'Text', columns), right.strip()])
    return replacements

def compute_replace(data_col, line, username):
    column = columns[data_col]
    if len(column.average_columns) == 0:
        return line[data_col].value
    if not column.replacements:
        column.replacements = parse_replacements(column.replace)
    from_data_col = column.average_columns[0]
    cell = line[from_data_col]
    for test, value in column.replacements:
        if test.evaluate(line, cell, username, False):
            return value
    return cell.get_value(column)
