#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2022 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

def replace_regtest():
    line = [Cell(5), CE('five')]
    for filters in [
            '5 🡆 five ● <5 🡆 <five ● >5 🡆 >five',
            '5 🡆 five ● <5 🡆 <five ● >5 🡆 >five ●',
            '<5 🡆 <five ● >5 🡆 >five ● 5 🡆 five',
            '5 🡆 five'
            ]:
        columns_set([Column({"title": "A"}),
                     Column({"title": "B", "replace": filters, "average_columns": [0]}),
                    ])
        check_result(line, 1, compute_replace)

    line = [Cell(5), CE(5)]
    columns_set([Column({"title": "A"}),
                 Column({"title": "B", "replace": '', "average_columns": [0]}),
                ])
    check_result(line, 1, compute_replace)
    columns_set([Column({"title": "A"}),
                 Column({"title": "B", "replace": '5 🡆 five ● <5 🡆 <five ● >5 🡆 >five',
                         "average_columns": []}),
                ])
    check_result(line, 1, compute_replace)
        
    print('Replace regtest are fine')

replace_regtest()
