#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2022 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

def ue_grade_regtest():
    line = [Cell(0), Cell(0), CE('')]
    columns_set([
        Column({'grade_type': 1, 'grade_session': 0}),
        Column({'grade_type': 2, 'grade_session': 1}),
        Column(),
    ])
    check_result(line, 2, compute_ue_grade)
    columns_set([
        Column({'grade_type': 1, 'grade_session': 0}),
        Column({'grade_type': 1, 'grade_session': 2}),
        Column(),
    ])
    check_result(line, 2, compute_ue_grade)
    columns_set([
        Column({'grade_type': 1, 'grade_session': 0, 'real_weight': 1}),
        Column({'grade_type': 1, 'grade_session': 1, 'real_weight': 2}),
        Column(),
    ])
    check_result(line, 2, compute_ue_grade)
    columns_set([
        Column({'grade_type': 1, 'grade_session': 0, 'real_weight_add': False}),
        Column({'grade_type': 1, 'grade_session': 1}),
        Column(),
    ])
    check_result(line, 2, compute_ue_grade)

    columns_set([
        Column({'grade_type': 1, 'grade_session': 0}),
        Column({'grade_type': 1, 'grade_session': 1}),
        Column({'grade_type': 2, 'grade_session': 0}),
        Column({'grade_type': 2, 'grade_session': 1}),
        Column({'grade_type': 3, 'grade_session': 0}),
        Column({'grade_type': 3, 'grade_session': 1}),
        Column(),
        Column({'abi_is': 1}),
        ])

    lines = [
        # CC S1     CC S2     CI S1     CI S2     CT S1     CT S2    UE Grade
        [Cell(4), Cell(''), Cell(10), Cell(''), Cell(16), Cell(''), CE(14), CE(14)],
        [Cell(16), Cell(''), Cell(10), Cell(''), Cell( 4), Cell(''), CE(10), CE(10)],
        [Cell( 6), Cell(16), Cell( 7), Cell(10), Cell( 2), Cell( 4), CE(10), CE(10)],
        [Cell('X'),Cell(''), Cell(10), Cell(''), Cell(16), Cell(''), CE(14), CE(14)],
        [Cell( 4), Cell(''), Cell('X'),Cell(''), Cell(18), Cell(''), CE(12), CE('DEF')],
        [Cell( 5), Cell(''), Cell(10), Cell(''), Cell('X'),Cell(''), CE( 5), CE('DEF')],
        [Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), CE(''), CE('')],
        [Cell(16), Cell(''), Cell(10), Cell(''), Cell(''), Cell(''), CE(13), CE(13)],
        [Cell( 0), Cell(''), Cell(10), Cell(''), Cell(''), Cell(''), CE( 5), CE( 5)],
        [Cell(''), Cell(''), Cell(10), Cell(''), Cell(''), Cell(''), CE(10), CE(10)],
        [Cell(16), Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), CE(16), CE(16)],
        [Cell('X'),Cell(16), Cell('X'),Cell(10), Cell('X'),Cell( 4), CE(10), CE(10)],
        [Cell(16), Cell(''), Cell(nan), Cell(''), Cell(nan), Cell(''), CE(16), CE(16)],
        [Cell(abi),Cell(16), Cell(abj),Cell(10), Cell(abi),Cell( 4), CE(10), CE(10)],
        [Cell(abi),Cell(''), Cell(abj),Cell(10), Cell(abi),Cell(16), CE(14), CE(14)],
        [Cell(abi),Cell(''), Cell(abj),Cell(abi), Cell(abi),Cell(15), CE(10), CE('DEF')],
        [Cell(abi),Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), CE(0), CE(0)],
        [Cell(abj),Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), CE(0), CE(0)],
        [Cell(ppn),Cell(''), Cell(''), Cell(''), Cell(''), Cell(''), CE(0), CE(0)],
        [Cell(''),Cell(''), Cell(10), Cell(''), Cell(10), Cell(''), CE(10), CE(10)],
        [Cell(''),Cell(''), Cell(10), Cell(''), Cell(10), Cell(abi), CE(5), CE('DEF')],
        [Cell(''),Cell(''), Cell(10), Cell(''), Cell(10), Cell(abj), CE(5), CE('DEF')],
        [Cell(''),Cell(''), Cell(12), Cell(8), Cell(12), Cell(8), CE(8), CE(8)],
        [Cell('X'),Cell('X'),Cell(12),Cell(''), Cell(12), Cell(abj), CE(4), CE('DEF')],
    ]
    for line in lines:
        check_result(line, 6, compute_ue_grade)
        check_result(line, 7, compute_ue_grade)

    print('UE grade regtest are fine')

ue_grade_regtest()
