#!/usr/bin/python3
# -*- coding: utf-8 -*-
# TOMUSS: The Online Multi User Simple Spreadsheet
# Copyright (C) 2022 Thierry EXCOFFIER, Universite Claude Bernard
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Contact: Thierry.EXCOFFIER@univ-lyon1.fr

def visibility_regtest():
    """Compute result of operation on emptyied cells"""
    for fct, expected_py, expected_js, column_attr in [
            ('compute_average'  ,nan, 2, {'average_columns': [0, 1],}),
            ('compute_if_else'  , '', 1, {'average_columns': [0, 1], 'test_if': '!=NEVER'}),
            ('compute_if_else'  , '', 3, {'average_columns': [0, 1], 'test_if': '=NEVER'}),
            ('compute_if_else'  , '', 1, {'average_columns': [0], 'test_if': '!=NEVER'}),
            ('compute_if_else'  , -1,-1, {'average_columns': [0], 'test_if': '=NEVER'}),
            ('compute_nmbr'     ,  1, 2, {'average_columns': [0, 1, 2], 'max': 3, 'test_filter': '>1'}),
            ('compute_max_real' ,nan, 3, {'average_columns': [0, 1, 2]}),
            ('compute_product'  ,nan, 6, {'average_columns': [0, 1, 2]}),
            ('compute_cow'      , '', 3, {'average_columns': [1]}),
            ('compute_normalize', '',10, {'average_columns': [0]}),
            ('compute_ue_grade' , '', 1, {}),
    ]:
        columns_set([Column({'visibility': 5, 'grade_type': 1, 'grade_session': 0}),
                     Column({'visibility': 5}),
                     Column(),
                     Column(column_attr)])
        if python_mode:
            expected = expected_py
        else:
            expected = expected_js
        line = [Cell(1), Cell(3), Cell(2), CE(expected)]
        if fct == 'compute_normalize':
            columns[3].table.lines = {i: [Cell(i), Cell(3), Cell(2), CE(expected)]
                                      for i in range(3)}
            columns[3].normalize = "10 1"
        print(fct)
        check_result(line, 3, eval(fct)) # pylint: disable=eval-used
        if python_mode:
            if fct in ('compute_normalize', 'compute_ue_grade'):
                continue
            line = [Cell(1), Cell(3), Cell(2), CE(expected_js)]
            columns[0].empty_is = 1
            columns[1].empty_is = 3
            check_result(line, 3, eval(fct)) # pylint: disable=eval-used
    print('→ Visibility regtest are fine')

visibility_regtest()
