requests = "";
alerts = "";
localStorage = {};

function restore_unsaved() { }
function head_html() { }
function insert_middle() { }
function wait_scripts() { return true; }
function table_init() { }
function update_line_menu() { }
function update_column_menu() { }
function update_popup_on_red_line() { }
function update_vertical_scrollbar_real() { }
function update_horizontal_scrollbar() { }
function change_option() { }
function line_fill() { }
function column_update_option() { }
function set_message() { }
function append_image(_td, text, _force) { requests += text + "\n"; }
function alert(x) { alerts += x + "\n"; }

Current.prototype.jump = function () { };
Current.prototype.update_table_headers = function () { };

tests_are_fine = true;

function check_requests(t) {
    if (t != requests.trim()) {
        console.log("ERROR requests");
        console.log("Expected: " + t);
        console.log("Computed: " + requests);
        tests_are_fine = false;
    }
    requests = "";
}

function check_alerts(t) {
    if (t != alerts.trim()) {
        console.log("ERROR alerts");
        console.log("Expected: " + t);
        console.log("Computed: " + alerts);
        tests_are_fine = false;
    }
    alerts = "";
}

function hide_dates(t) {
    return t.replace(/"20[0-9]{12}"/g, '"DATE"').replace(/\n/g, "");
}

function check_lines(t) {
    if (hide_dates(lines_in_javascript()) != t) {
        console.log("ERROR");
        console.log("Expected:");
        console.log(t);
        console.log("Computed:");
        console.log(hide_dates(lines_in_javascript()));
        tests_are_fine = false;
    }
}

function change_identity(login) {
    my_identity = login;
    initialise_columns(); // To recompile filters
}

function error(v) {
    var err = new Error();
    console.log("ERROR: " + v + '\n' + err.stack);
    tests_are_fine = false;
}
preferences.invert_grpseq = no;
initialize();
add_empty_column();

if (i_am_the_teacher)
    error(i_am_the_teacher);

// Create first line and cell

add_a_new_line("lin_0");
cell_set_value_real("lin_0", 0, "k01");
check_requests('cell_change/0_0/lin_0/k01');
check_lines('[[C("k01","tt.master","DATE",""),C("","","",""),C("","","",""),C("","","",""),C("","","",""),C("","","","")]]')
if (columns[0].type != 'Text')
    error(columns[0].type);

// Change value

cell_set_value_real("lin_0", 0, "k02");
check_requests('cell_change/0_0/lin_0/k02');
check_lines('[[C("k02","tt.master","DATE",""),C("","","",""),C("","","",""),C("","","",""),C("","","",""),C("","","","")]]')

// Failing to change a value

change_identity("test");
line = lines['lin_0'];
cell = line[0];
column = columns[0];

if (cell.is_mine())
    error();
if (column.cell_writable_filter(line, cell, 'nobody'))
    error();
if (cell.changeable(line, columns[0]) === true)
    error();

cell_set_value_real("lin_0", 0, "k03");
check_lines('[[C("k02","tt.master","DATE",""),C("","","",""),C("","","",""),C("","","",""),C("","","",""),C("","","","")]]')
check_requests('');


// Try to change column ID

change_identity("tt.master");
column_attr_set(column, "title", "A");
check_requests('');
check_alerts(_("ERROR_value_not_modifiable") + ' [ID.title=A]\n'
    + _("ERROR_value_system_defined"));


// Create a new column

column = columns[6];
column_attr_set(column, "title", "A");
check_requests('column_attr_title/1_0/A');
column_attr_set(column, "cell_writable", "[A]= | @[]=test");
check_requests('column_attr_cell_writable/1_0/%5BA%5D=%20%7C%20$40%5B%5D=test');
if (column.type != 'Note')
    error(column.type);

// Is the cell content writable

c = lines['lin_0'][6].changeable(lines['lin_0'], column)
if (c !== true)
    error("Cell not changeable: " + c);

// Set bad value in the new column

cell_set_value_real("lin_0", 6, "x");

if (lines['lin_0'][6].value !== '')
    error("Cell changed!");

check_requests('');
check_alerts('«x»' + _("ALERT_bad_grade") + "[0;20]\n"
    + "UNJLEAVE (U) : UNJustified LEAVE\n"
    + "JUSLEAVE (J) : JUStified LEAVE\n"
    + "CANTGRADE (C) : CAN'T GRADE\n"
    + "WNGIVEN (W) : Work Not GIVEN\n"
    + "DIS : _dis_\n"
    + "ABS : _abs_"
)

// Set comment on the value

comment_change('lin_0', 6, "comment");
check_requests('comment_change/1_0/lin_0/comment');

// Set value in the new column

cell_set_value_real("lin_0", 6, "12.34");
check_requests('cell_change/1_0/lin_0/12$2E34');
cell_set_value_real("lin_0", 6, "13");
check_requests(''); // Impossible to change

// But 'test' user can

change_identity("test");
cell_set_value_real("lin_0", 6, "13");
check_requests('cell_change/1_0/lin_0/13');

// Filtering columns

set_columns_filter('A');
if (column_list_all() != "0,2,1,6")
    error(column_list_all());

set_columns_filter('@=*');
if (column_list_all() != "0,2,1,3,4")
    error(column_list_all());

set_columns_filter('@=@[]');
if (column_list_all() != "0,2,1")
    error(column_list_all());

set_columns_filter('');
if (column_list_all() != "0,2,1,3,4,6")
    error(column_list_all());

// Full filter

full_filter_change({ value: "@" });
if (column_list_all() != "0,2,1,6")
    error(column_list_all());
update_filtered_lines();
if (filtered_lines.length != 1)
    error(filtered_lines.length);

full_filter_change({ value: "not" });
if (column_list_all() != "0,2,1")
    error(column_list_all());
update_filtered_lines();
if (filtered_lines.length != 0)
    error(column_list_all());

full_filter_change({ value: "" });
if (column_list_all() != "0,2,1,3,4,6")
    error(column_list_all());
update_filtered_lines();
if (filtered_lines.length != 1)
    error(filtered_lines.length);

// line filter

line_filter_change_value = { value: "no" };
line_filter_change_real();
update_filtered_lines();
if (filtered_lines.length != 0)
    error(filtered_lines.length);

line_filter_change_value = { value: "no | k" };
line_filter_change_real();
update_filtered_lines();
if (filtered_lines.length != 1)
    error(filtered_lines.length);

line_filter_change_value = { value: "k @=tt.master ?<0.001j" };
line_filter_change_real();
update_filtered_lines();
if (filtered_lines.length != 1)
    error(filtered_lines.length);

line_filter_change_value = {
    value: "=13 >=13 >12 <=13 <14 @=test @[ID]=tt.master @[A]=test !@[ID]=@[A] ?<0.001j :~12.34 :[A]~12.34 :[A]comment #=comment #~com #[A]=comment #[A]~com"
};
line_filter_change_real();
update_filtered_lines();
if (filtered_lines.length != 1)
    error(filtered_lines.length);

// Create an average

add_empty_column();
column = columns[7];
column_attr_set(column, "title", "Average");
column_attr_set(column, "type", "Moy");
column_attr_set(column, "columns", "A");
column_attr_set(column, "minmax", "[0;40]");
if (column.type != 'Moy')
    error(column.type);
if (column_list_all() != "0,2,1,3,4,6,7")
    error(column_list_all());
update_line("lin_0", 7);

if (26 - lines["lin_0"][7].value > 1e-9)
    error(lines["lin_0"][7].value);
if (lines["lin_0"][7].author != "*")
    error(lines["lin_0"][7].author);

check_requests('column_attr_title/1_1/Average\n'
    + 'column_attr_columns/1_1/A\n'
    + 'column_attr_minmax/1_1/%5B0;40%5D');

// Modify an average

cell_set_value_real("lin_0", 7, "12");

check_alerts(""); // No alert because it is impossible
if (26 - lines["lin_0"][7].value > 1e-9)
    error(lines["lin_0"][7].value);

check_requests('');

// Create a COW

add_empty_column();
column = columns[8];
column_attr_set(column, "title", "Cow");
column_attr_set(column, "type", "COW");
column_attr_set(column, "columns", "Average");
if (column.type != 'COW')
    error(column.type);
if (column_list_all() != "0,2,1,3,4,6,7,8")
    error(column_list_all());
update_line("lin_0", 8);

if (26 - lines["lin_0"][8].value > 1e-9)
    error(lines["lin_0"][8].value);
if (lines["lin_0"][8].author != "?")
    error(lines["lin_0"][8].author);

check_requests('column_attr_title/1_2/Cow\n'
    + 'column_attr_columns/1_2/Average');

// Change value

cell_set_value_real("lin_0", 6, "3");
update_line("lin_0", 6);

if (6 - lines["lin_0"][8].value > 1e-9)
    error(lines["lin_0"][8].value);

check_requests('cell_change/1_0/lin_0/3');

// I set myself as table master

table_attr_set("masters", "test");
check_requests('table_attr_masters/test');

// Change COW

cell_set_value_real("lin_0", 8, "5");
if (lines["lin_0"][8].value != "5")
    error(lines["lin_0"][8].value);
if (lines["lin_0"][8].author != "test")
    error(lines["lin_0"][8].author);

check_requests('cell_change/1_2/lin_0/5');
check_alerts("");


// Create a Nmbr without columns.
// Do it like it was a page loading and not user creation

columns.push(Col({ "the_id": "Nmbr", "title": "Nmbr", "type": "Nmbr" }));
column = columns[9];
init_column(column);
column_attr_set(column, "title", "Nmbr");
column_attr_set(column, "type", "Nmbr");
column_attr_set(column, "columns", "");
check_requests('');
check_alerts("");

if (column.max != 1 || column.minmax != "[0;1]")
    error(column.minmax);

column_attr_set(column, "columns", "Average Cow", "interactif");
if (column.max != 2 || column.minmax != "[0;2]")
    error(column.minmax);

// Check the #[] filter
columns.push(Col({
    "the_id": "is-a-teacher", "title": "is-a-teacher",
    "cell_writable": "#[]"
}));
column = columns[columns.length - 1];
init_column(column);
is_a_teacher = 1;
if (column.cell_writable_filter(lines["lin_0"], lines["lin_0"][0],
    "nobody") != true)
    error('cell_writable: 1');
is_a_teacher = 0
if (column.cell_writable_filter(lines["lin_0"], lines["lin_0"][0],
    "nobody") != false)
    error('cell_writable: true');

// Test MCQ

function test_choices() {
    return {
        "c0": ["c0:4pt", {}],
        "c1": ["c1:default pt", {}],
        "c2": ["c2 seul: 3pt", {}],
        "c3": ["c3+c2:2.5pt  c3-c4:-2", {}],
        "c4": ["nothing", {}]
    };
}
function test_grades() {
    return [
        [["c0"], [], 4],
        [["c1"], [], null],
        [["c2"], ["c3", "c4"], 3],
        [["c3", "c2"], [], 2.5],
        [["c3"], ["c4"], -2],
        [["c3"], [], -0.5]
    ];
}
function test_grades2() {
    return [
        [["c0", "c1", "c2"], ["c3", "c4"], null]
    ];
}
mcq = new MCQ([
    {
        "q1": ["q1", test_choices(), { 'grade': test_grades() }],
        "q2": ["q2", test_choices(), {
            'grade': test_grades(),
            "good_answer": 2,
            "bad_answer": -3,
            "no_answer": -4
        }],
        "q3": ["q3", test_choices(), {
            'grade': test_grades(),
            "good_answer": 2,
            "bad_answer": "-1/(x-1)",
        }],
        "q4": ["q4", test_choices(), {
            'grade': test_grades2(),
            "progressive": "progressive",
            "good_answer": 3
        }],
        "q5": ["q5", test_choices(), {
            'grade': test_grades2(),
            "progressive": "no"
        }]
    },
    {
        "radio": 1,
        "gui": "expert",
        "shuffle_questions": 0,
        "shuffle_choices": 0,
        "no_answer": 0,
        "stats": 1,
        "bad_answer": -1,
        "show_answers": 0,
        "good_answer": 1
    }
]);
answers = [
    ['', -4],
    ['q1=c0', 0],
    ['q1=c1', -3],
    ['q1=c2', -1],
    ['q1=c2&q1=c3', -1.5],
    ['q1=c2&q1=c4', -5],
    ['q1=c3&q1=c2', -1.5],
    ['q1=c3', -6],
    ['q1=c3&q1=c4', -4.5],
    ['q2=c0', 4],
    ['q2=c1', 2],
    ['q2=c2', 3],
    ['q2=c2&q2=c3', 2.5],
    ['q2=c2&q2=c4', -3],
    ['q2=c3&q2=c2', 2.5],
    ['q2=c3', -2],
    ['q2=c3&q2=c4', -0.5],
    ['q3=c1', -2],
    ['q3=c4', -4.5],
    ['q4=c0&q4=c3', -5],
    ['q4=c0', -3],
    ['q4=c0&q4=c2', -2],
    ['q5=c0&q5=c3', -5],
    ['q5=c0', -4],
    ['q5=c0&q5=c2', -4]

];
mcq.column = { comment: 'test_mcq_comment', the_id: 'fake_id', visibility: 0 };
for (var i in answers)
    if (mcq.grade(answers[i][0]) != answers[i][1])
        error('MCQ(' + answers[i][0] + ')→' + mcq.grade(answers[i][0]) + ' expect:' + answers[i][1])

mcq = new MCQ([
    {
        "q1": ["q1", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]], 'group': 'A' }],
        "q2": ["q2", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]], 'group': 'A' }],
        "q3": ["q3", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]], 'group': 'A' }],
        "q4": ["q4", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]] }],
        "q5": ["q5", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]] }],
        "q6": ["q6", { 'c0': ['c0', {}], 'c1': ['c1', {}] }, { 'grade': [[['c0'], [], 1]] }]
    },
    {
        "radio": 1,
        "gui": "expert",
        "shuffle_questions": 1,
        "shuffle_choices": 1,
        "no_answer": -10,
        "stats": 1,
        "bad_answer": -1,
        "show_answers": 0,
        "good_answer": 1,
        "nr_question_in_group": { 'A': 1 }
    }
]);
mcq.column = { comment: 'test_mcq_comment', the_id: 'fake_id', visibility: 0 };
mcq.update_stat_group();
test_q = mcq.student_questions(new Rand('foobar3'));
q_names = [];
for (var i in test_q)
    q_names.push(test_q[i].key);
if (q_names.join('') != 'q5q6q4q2')
    error("Bad choosen questions");

answers = [
    ['', -40],
    ['q2=c0&q4=c0&q5=c0&q6=c0', 4],
    ['q1=c0&q4=c0&q5=c0&q6=c0', -7]
];

for (var i in answers)
    if (mcq.grade(answers[i][0], new Rand('foobar3')) != answers[i][1])
        error('MCQ(' + answers[i][0] + ')→' + mcq.grade(answers[i][0]) + ' expect:' + answers[i][1])

the_current_cell.line = [{ value: '12345670' }];
function popup_column() {
    return mcq.column;
}
mcq.modifiable = true;
mcq.year = year
mcq.semester = semester
mcq.ue = ue
if (mcq.html_student(true).replace(/.*name/g, '') !=
    '<div id="undefined" style="font-weight: normal" onclick="mcq_from_element(this).click_student(event)">\n'
    + '<p>test_mcq_comment</p>\n'
    + 'Global scoring:\n'
    + '<ul>\n'
    + '<li>Points : MSG_mcq_good_answer_1\n'
    + '<li>No answer : MSG_mcq_no_answer_-10\n'
    + '<li>Bad answer : -1\n'
    + "<li>Notation choice : it is a bad answer if you don't tick all expected choices\n"
    + '</ul><br>\n'
    + '="undefined\001q5" value="c1"><td style="">c1</td></table></label>\n'
    + '="undefined\001q5" value="c0" checked><td style="">c0</td></table></label>\n'
    + '</section>\n'
    + '\n'
    + '="undefined\001q4" value="c1"><td style="">c1</td></table></label>\n'
    + '="undefined\001q4" value="c0" checked><td style="">c0</td></table></label>\n'
    + '</section>\n'
    + '\n'
    + '="undefined\001q6" value="c0" checked><td style="">c0</td></table></label>\n'
    + '="undefined\001q6" value="c1"><td style="">c1</td></table></label>\n'
    + '</section>\n'
    + '\n'
    + '="undefined\001q1" value="c0" checked><td style="">c0</td></table></label>\n'
    + '="undefined\001q1" value="c1"><td style="">c1</td></table></label>\n'
    + '</section>\n'
    + '\n'
    + '</div>') {
    console.log(mcq.html_student(true).replace(/.*name/g, ''));
    error('Bad student page');
}

mcq = new MCQ([
    {
        "q6": ["q6", test_choices(), {
            'grade': test_grades2(),
            "progressive": "±", "bad_answer": 0, "no_answer": -5
        }]
    },
    {
        "radio": 1,
        "gui": "expert",
        "shuffle_questions": 0,
        "shuffle_choices": 0,
        "no_answer": -10,
        "stats": 1,
        "bad_answer": -100,
        "show_answers": 0,
        "good_answer": 3
    }
]);
answers = [
    ['', -5],
    ['q6=c0', 1],
    ['q6=c0&q6=c1', 2],
    ['q6=c0&q6=c1&q6=c2', 3],
    ['q6=c0&q6=c1&q6=c2&q6=c3', 1.5],
    ['q6=c0&q6=c1&q6=c3', 0.5],
    ['q6=c0&q6=c3', -0.5],
    ['q6=c0&q6=c1&q6=c2&q6=c3&q6=c4', 0],
    ['q6=c0&q6=c1&q6=c3&q6=c4', -1],
    ['q6=c0&q6=c3&q6=c4', -2],
    ['q6=c3&q6=c4', -3]
];
mcq.column = { comment: 'test_mcq_comment', the_id: 'fake_id', visibility: 0 };

for (var i in answers)
    if (Math.abs(mcq.grade(answers[i][0]) - answers[i][1]) > 1e-6)
        error('MCQ(' + answers[i][0] + ')→' + mcq.grade(answers[i][0]) + ' expect:' + answers[i][1])

for (var i in mcq.question_options)
    if (mcq.question_options[i][0] == 'progressive')
        to_test = mcq.question_options[i][1];

for (var tester = 0; tester < 2; tester++) {
    answers = ['..........', 'X.........', 'XX........', 'XXX.......', 'XXXX......',
        '..X.......', '..XX......', '..XXXXXXXX', 'XXXXXXXXXX'
    ];
    answers_html = [];
    for (var i in answers)
        answers_html.push('<tr><td>' + answers[i].replace(/X/g, '☑').replace(/\./g, '☐'));
    for (var i in to_test) {
        var some_choices = {};
        for (var j = 0; j < 10; j++)
            some_choices['c' + j] = ['c' + j, {}];
        mcq = new MCQ([
            {
                "q": ["q", some_choices, {
                    'grade':
                        tester == 0
                            ? [[['c0', 'c1'], ['c2', 'c3', 'c4', 'c5', 'c6', 'c7', 'c8', 'c9'], 1]]
                            : [[['c0'], ['c1', 'c2', 'c3', 'c4', 'c5', 'c6', 'c7', 'c8', 'c9'], 1]]
                    ,
                    "progressive": to_test[i]
                }]
            },
            {
                "radio": 1, "gui": "expert", "shuffle_questions": 0, "shuffle_choices": 0,
                "no_answer": -10, "stats": 1, "bad_answer": -100, "show_answers": 0,
                "good_answer": 1
            }
        ]);
        mcq.column = { comment: 'test_mcq_comment', the_id: 'fake_id', visibility: 0 };
        for (j in answers) {
            var a = [];
            for (k = 0; k < 10; k++)
                if (answers[j].substr(k, 1) != '.')
                    a.push('q=c' + k);
            answers_html[j] += '<td>' + mcq.grade(a.join('&'));
        }
    }
    if (tester == 0)
        s = '<tr><th>XX........';
    else
        s = '<tr><th>X.........';
    for (var i in to_test)
        s += '<th>' + _('MSG_mcq_progressive_' + to_test[i]);
    console.log(s + '</tr>');
    for (var i in answers)
        console.log(answers_html[i] + '</tr>');
}

mcq = new MCQ([
    {
        "qA1": ["qA1", {}, { 'priority': 0, 'group': 'A' }],
        "qA2": ["qA2", {}, { 'priority': 1, 'group': 'A' }],
        "qB1": ["qB1", {}, { 'priority': 2, 'group': 'B' }],
        "qB2": ["qB2", {}, { 'priority': 3, 'group': 'B' }],
        "qC1": ["qC1", {}, { 'priority': 4, 'group': 'C' }],
        "qC2": ["qC2", {}, { 'priority': 5, 'group': 'C' }],
        "qD1": ["qD1", {}, { 'priority': 6, 'group': 'D' }],
        "qD2": ["qD2", {}, { 'priority': 7, 'group': 'D' }],
        "qE1": ["qE1", {}, { 'priority': 8, 'group': 'E' }],
        "qE2": ["qE2", {}, { 'priority': 9, 'group': 'E' }]
    },
    {
        "radio": 1,
        "gui": "expert",
        "shuffle_questions": 1,
        "shuffle_choices": 1,
        "no_answer": -10,
        "stats": 1,
        "bad_answer": -1,
        "show_answers": 0,
        "good_answer": 1,
        "nr_question_in_group": { 'A': 1, 'B': 1, 'C': 1, 'D': 1, 'E': 1 }
    }
]);
mcq.column = { comment: 'test_mcq_comment', the_id: 'fake_id', visibility: 0 };
mcq.year = year
mcq.semester = semester
mcq.ue = ue
mcq.key = 'ultraverylongfake1!'
if (!mcq.html_student().replace(/\n/g, '').match(/qE2.*qB2.*qA2.*qC2.*qD1/))
    error('shuffle_question 1, same_questions 0 v1 :' + mcq.html_student());
mcq.key = 'ultra very long fake1!'
if (!mcq.html_student().replace(/\n/g, '').match(/qC2.*qD1.*qA2.*qB2.*qE1/))
    error('shuffle_question 1, same_questions 0 v2 :' + mcq.html_student());
mcq.key = 'ultra very long fake! 12345678'
if (!mcq.html_student().replace(/\n/g, '').match(/qC2.*qE1.*qA2.*qD1.*qB2/))
    error('shuffle_question 1, same_questions 0 v3 :' + mcq.html_student());
mcq.key = 'ultra very long fake 11!'
if (!mcq.html_student().replace(/\n/g, '').match(/qD1.*qE1.*qB2.*qA1.*qC2/))
    error('shuffle_question 1, same_questions 0 v4 :' + mcq.html_student());

mcq.options.shuffle_questions = 0
mcq.options.same_questions = 1
if (!mcq.html_student().replace(/\n/g, '').match(/qA2.*qB1.*qC1.*qD1.*qE1/))
    error('shuffle_question 0, same_questions 1 :' + mcq.html_student());

mcq.options.shuffle_questions = 1
mcq.options.same_questions = 1
if (!mcq.html_student().replace(/\n/g, '').match(/qD1.*qE1.*qB1.*qC1.*qA2/))
    error('shuffle_question 1, same_questions 1 v1 :' + mcq.html_student());
mcq.key = 'verylongfake1!';
if (!mcq.html_student().replace(/\n/g, '').match(/qB1.*qD1.*qC1.*qA2.*qE1/))
    error('shuffle_question 1, same_questions 1 v2 :' + mcq.html_student());
mcq.key = 'verylongfake3!';
if (!mcq.html_student().replace(/\n/g, '').match(/qA2.*qE1.*qC1.*qB1.*qD1/))
    error('shuffle_question 1, same_questions 1 v3 :' + mcq.html_student());
mcq.key = 'verylongfake4!';
if (!mcq.html_student().replace(/\n/g, '').match(/qE1.*qC1.*qD1.*qB1.*qA2/))
    error('shuffle_question 1, same_questions 1 v4 :' + mcq.html_student());

mcq.options.shuffle_questions = 0
mcq.options.same_questions = 0
if (!mcq.html_student().replace(/\n/g, '').match(/qA1.*qB2.*qC1.*qD2.*qE2/))
    error('shuffle_question 0, same_questions 0 v1 :' + mcq.html_student());
mcq.key = 'fdhggverylongfake10!';
if (!mcq.html_student().replace(/\n/g, '').match(/qA1.*qB2.*qC2.*qD1.*qE2/))
    error('shuffle_question 0, same_questions 0 v2 :' + mcq.html_student());
mcq.key = 'fdhggverylongfake120!';
if (!mcq.html_student().replace(/\n/g, '').match(/qA2.*qB1.*qC2.*qD2.*qE2/))
    error('shuffle_question 0, same_questions 0 v3 :' + mcq.html_student());

// Notation tests

the_current_cell.column = {
    'comment': '["1_0 2Q2 Q1","1_1 2C1 C1"]',
    'data_col': 1
};
Notation.init(the_current_cell.column);
Notation.init_cell([C('UserID'), C('', '', '', '{"1_0":"1/2 c{{{1_1}}}"}')]);
var q = Notation.questions['1_0'];
if (q.grade_and_comment() !== '    1.0/2 cC1')
    error('notation1');
q.set_comment('2/3 AC1A');
if (q.grade_and_comment() !== '  1.333/2 AC1A')
    error('notation2');
if (q.grade.toJSON() !== '2/3 A{{{1_1}}}A')
    error('notation3');
q.set_comment('Comment');
if (q.grade.toJSON() !== '2/3 Comment')
    error('notation4');
if (q.grade_and_comment() !== '  1.333/2 Comment')
    error('notation2');
q.set_comment('1');
if (q.grade_and_comment() !== '  0.667/2 Comment')
    error('notation4');

// Dispatcher tests

function dispatch_check(msg, expected) {
    var result = dispatch_do_real(student_lines);
    if (result[0] != expected[0])
        error(msg + '(0) ' + result[0] + '!=' + expected[0]);
    for (var i in expected[1])
        if (result[1][i].badness != expected[1][i])
            error(msg + '(1) ' + result[1][i].badness + ' != ' + expected[1][i]);
    for (var i in expected[2])
        if (result[1][i].results.toString() != expected[2][i].toString())
            error(msg + '(2) ' + result[1][i].results + ' != ' + expected[2][i]);
    if (expected[3] !== undefined)
        if (JSON.stringify(dispatch_do.reject) != JSON.stringify(expected[3]))
            error(msg + '(3) ' + JSON.stringify(dispatch_do.reject) + ' != ' + JSON.stringify(expected[3]));
}

mcq = { column: { data_col: 4, average_columns: [1, 2, 3] } };
dispatch_do.config = {
    columns: [
        [[1, "A0"], [1, "A1"], [1, "A2"], [1, "B0"], [1, "B1"], [1, "B2"], [1, "C0"], [1, "C1"], [1, "C2"]],
        [[1, "A0"], [1, "A1"], [1, "A2"], [1, "B0"], [1, "B1"], [1, "B2"], [1, "C0"], [1, "C1"], [1, "C2"]],
        [[1, "A0"], [1, "A1"], [1, "A2"], [1, "B0"], [1, "B1"], [1, "B2"], [1, "C0"], [1, "C1"], [1, "C2"]],
    ],
    choices: [
        { title: "1", values: ["A", "B", "C"], repetition: 1, "for_columns": { 0: 1, 1: 1, 2: 1 } },
        { title: "2", values: ["0", "1", "2"], repetition: 1, "for_columns": { 0: 1, 1: 1, 2: 1 } },
    ]
};
dispatch_do.reject = {};
student_lines = [];
for (var i = 0; i < 3; i++)
    student_lines.push([{ value: 'p' + i }, { value: '' }, { value: '' }, { value: '' }, { value: 'A B C\n0 1 2' }]);
dispatch_check('3 students',
    ['0,3,0,1000000,0,1000000', ['0,0,0,0,0,0', '0,1,0,0,0,1000000', '0,2,0,1000000,0,0'],
        [['A0', 'B1', 'C2'], ['A1', 'B0', 'C1'], ['A2', 'B2', 'C0']]]);

dispatch_do.reject = {};
student_lines = [];
for (var i = 0; i < 4; i++)
    student_lines.push([{ value: 'p' + i }, { value: '' }, { value: '' }, { value: '' }, { value: 'A B C\n0 1 2' }]);
dispatch_check('4 students',
    ['1,3,0,1000000,1000000,1000000', ['0,0,0,0,0,0', '0,1,0,0,0,1000000', '0,2,0,1000000,0,0', '1,0,0,0,1000000,0'],
        [['A0', 'B1', 'C2'], ['A1', 'B0', 'C1'], ['A2', 'B2', 'C0'], ['B0', 'A1', 'B2']]
    ]);
dispatch_check('4 students second',
    ['1,4,0,1,1000000,0', ['0,0,0,0,0,0', '0,2,0,0,0,0', '0,1,0,1,0,0', '1,1,0,0,1000000,0'],
        [['A0', 'B1', 'C2'], ['A2', 'B0', 'C1'], ['A1', 'B2', 'C0'], ['B1', 'A0', 'B2']],
        {"p2 0 A2":true,"p1 0 A1":true,"p3 0 B0":true,"p3 0 B1":true}
    ]);
dispatch_check('4 students third',
    ['1,5,0,1,1000000,0', ['0,0,0,0,0,0', '0,2,0,0,0,0', '0,1,0,1,0,0', '1,2,0,0,1000000,0'],
        [['A0', 'B1', 'C2'], ['A2', 'B0', 'C1'], ['A1', 'B2', 'C0'], ['B2', 'A0', 'B1']],
    ]);
dispatch_check('4 students fourth',
    ['2,3,0,1,0,0', ['0,0,0,0,0,0', '0,2,0,0,0,0', '0,1,0,1,0,0', '2,0,0,0,0,0'],
        [['A0', 'B1', 'C2'], ['A2', 'B0', 'C1'], ['A1', 'B2', 'C0'], ['C0', 'A1', 'B2']],
        {"p2 0 A2":true,"p1 0 A1":true,"p3 0 B0":true,"p3 0 B1":true,"p3 0 B2":true}
    ]);
ok = false;
for (var i = 0; i < 100; i++) {
    for (var k in dispatch_do.reject)
        if (Math.random() < 0.1)
            delete dispatch_do.reject[k];
    badness_and_students = dispatch_do_real(student_lines)
    if (badness_and_students[0].toString().indexOf('000000') == -1) {
        ok = true;
        break;
    }
}
if (!ok)
    error("Can't find the perfect dispatch with 4 students in less than 100 tries");

dispatch_do.reject = {};
student_lines = [];
for (var i = 0; i < 8; i++)
    student_lines.push([{ value: 'p' + i }, { value: '' }, { value: '' }, { value: '' }, { value: 'A B C\n0 1 2' }]);
    ok = false;
    for (var i = 0; i < 100000; i++) {
        for (var k in dispatch_do.reject)
            if (Math.random() < 0.1)
                delete dispatch_do.reject[k];
        badness_and_students = dispatch_do_real(student_lines);
        // if(badness_and_students[0].toString().indexOf('000') == -1 && badness_and_students[0][0][0] <= 7)
        //     console.log(i + badness_and_students[0]);
        if (badness_and_students[0].toString() == '7,8,3,2,0,0') {
            console.log(badness_and_students[0]);
            console.log("Found perfect dispatch for 8 students in " + (i+1) + " tries");
            for (var i in badness_and_students[1])
                console.log(badness_and_students[1][i].results);
            ok = true;
            break;
        }
    }
    if (!ok)
        error("Can't find the perfect dispatch with 9 students in less than 100000 tries");

// All is done

if (tests_are_fine)
    console.log("tests are fine");
