"""For regression tests"""

# The creation order will be the display order

nval01 = STUDENTS.add_competence('Answer Nval01 somewhere', 1)
nval = STUDENTS.add_competence('Answer Nval somewhere', 1)
nb0 = STUDENTS.add_competence('Number of 0 in answers', 10)
upload_ok = STUDENTS.add_competence('Upload is fine', 1)
upload_tar = STUDENTS.add_competence('Upload is tar', 1, True)
upload_zip = STUDENTS.add_competence('Upload is zip', 1)
archive_content = STUDENTS.add_competence('Archive content', 1)
upload_xlsx = STUDENTS.add_competence('XLSX', 3)
upload_new_is_old = STUDENTS.add_competence('New upload is the same than old', 1)

for student in STUDENTS:
    nbr = 0
    for cell in student:
        if cell.new.value == 'Nval01':
            student.grade(nval01, 1, 'Fine')
            student.message_green('green')
        if 'Nval' in cell.new.value:
            student.grade(nval, 0.25)
            student.message_red('red')
        nbr += cell.new.value.count('0')
        if not cell.new.with_upload():
            continue
        if cell.new.get_upload_content() == b'FileContent':
            student.grade(upload_ok, 1)
        if (cell.old.with_upload()
                and cell.new.get_upload_content() == cell.old.get_upload_content()
           ):
            student.grade(upload_new_is_old, 1)
        if cell.new.upload_is_zip():
            student.grade(upload_zip, 1)
        if cell.new.upload_is_tar():
            student.grade(upload_tar, 1)
        if not cell.new.upload_is_an_archive():
            continue
        if 'xl/workbook.xml' in cell.new.upload_filelist():
            student.grade(upload_xlsx, 1)
            if b'<c r="A1" t="s"><v>0</v></c>' in \
                    cell.new.archive_content('xl/worksheets/sheet1.xml'):
                student.grade(upload_xlsx, 1)
            if b'<si><t>topleft</t></si>' in cell.new.archive_content('xl/sharedStrings.xml'):
                student.grade(upload_xlsx, 1)
        if 'dir1/file3' in cell.new.upload_filelist():
            student.grade(archive_content, 1, cell.new.value)
            if cell.new.archive_size('dir1/file3') == 8:
                student.grade(archive_content, 0.1)
            if cell.new.archive_content('dir1/file3') == b'content3':
                student.grade(archive_content, 0.01)
    student.grade(nb0, nbr, 'Nice' if nbr > 2 else '')
