#!/usr/bin/python3

"""
The standard input must be a GUI_record file :

SCRIPTS/display_gui_record.py <LOGS/GUI_record/thierry.excoffier

Use 'absolute-time' to display absolute time

"""

import sys
import ast
import time
import datetime

for line in sys.stdin:
    line = ast.literal_eval(line.replace('R', '', 1))
    print(line[0], line[1])
    if 'absolute-time' in sys.argv:
        start = time.strptime(line[1], '%Y%m%d%H%M%S')
        start = datetime.datetime(*start[:6])
        for v in line[2]:
            t, name, val = (v + [""])[:3]
            current = start + datetime.timedelta(milliseconds=t)
            print('%s %30s %s' % (current.strftime('%Y-%m-%d %H:%M:%S'), name, val))
    else:
        last = 0
        for v in line[2]:
            t, name, val = (v + [""])[:3]
            print('%10d %30s %s' % (t-last, name, val))
            last = t
