"""
Index scanner

The computed dict is : Student → List[ue]

Store in LOGINS/.../index
"""

import collections
from TOMUSS.SCRIPTS import scanner_plugin
from TOMUSS import configuration

class Index(scanner_plugin.Plugin):
    """The UE were the student is registered"""
    only_real_file = False # Must appear in Automn/Spring
    students = None # type: Dict[str, List[str]]

    def start(self):
        self.students = collections.defaultdict(list)
    def stop(self):
        self.students = None
    def table(self, table):
        for login in table.the_keys():
            self.students[login].append(table.ue)
    def record(self):
        return self.students.items()
    def merge(self, data):
        table = []
        login = '' # To please pylint
        for (login, ues), year, semester, _ in data:
            year = int(year)
            for code_ue in ues:
                table.append(repr((int(year), semester, code_ue)) + ',')
        table.sort()
        table.insert(0, '[')
        table.append(']')
        table = '\n'.join(table)
        if len(login) < 3 or len(login) > 64:
            return
        user = configuration.User(login)
        if user.valid_ID_:
            print('\r' + login, end='         ')
            user.manage_key('index', content=table)
        user.forget() # To not eat memory (not reused)
