"""
Empty student ID scanner.

The computed list is : [table, nr_input]

Store results in: MP/SCANNER/YEAR/SEMESTER/NoID

To display results in CSV:


python3 -c '
import sys
import csv
w = csv.writer(sys.stdout)
for i in sys.stdin:
    w.writerow(eval(i))
' <TMP/SCANNER/Y2022/SAutomne/NoID


"""

from TOMUSS.SCRIPTS import scanner_plugin

class NoID(scanner_plugin.Plugin):
    """Statistics on the grades entered by the teachers"""
    only_official_ue = False    # Not invisible tables
    only_suivi_semester = False # Not table not on the suivi page
    merge_manually = True
    lines = None

    def start(self):
        self.lines = []

    def stop(self):
        self.lines = []

    def table(self, table):
        code_ue = table.ue
        lines = self.lines
        for line in table.lines.values():
            if line[0].value or len(line) < 3:
                continue
            if not line[1].value or not line[2].value:
                continue
            if line[1].value == 'Inconnu' or line[2].value == 'Inconnu':
                continue # pragma: no cover
            values = [code_ue]
            values.extend(str(cell.value) for cell in line[1:])
            while values[-1] == '':
                values.pop() # pragma: no cover
            lines.append(values)

    def record(self):
        self.lines.sort()
        yield from self.lines
