#!/usr/bin/env python3
from TOMUSS import utilities
from TOMUSS import configuration

def create(table):
    """Creates the columns of the competence catalog"""
    rw_page = table.get_a_root_page()
    table.update_columns(
        {
            '0': {'type': 'Text',
                  'freezed': 'F',
                  'title': 'Code',
                  'width': 3,
                  },
            '1': {'type': 'Text',
                  'freezed': 'F',
                  'title': 'Description',
                  'width': 25,
                  'red': '[Code]~b ![Code]~c',
                  'green': '[Code]~b [Code]~c ![Code]~e ![Code]~f ![Code]~s',
                  },
            '2': {'type': 'Text',
                  'title': 'Formation',
                  'width': 3,
                  'red': '[Code]~b ![Code]~c',
                  'green': '[Code]~b [Code]~c ![Code]~e ![Code]~f ![Code]~s',
                  },
            '3': {'type': 'Text',
                  'title': 'UE',
                  'width': 3,
                  'red': '[Code]~b ![Code]~c',
                  'green': '[Code]~b [Code]~c ![Code]~e ![Code]~f ![Code]~s',
                  },
            '4': {'type': 'Text',
                  'title': 'Aggregate',
                  'width': 1,
                  'red': '[Code]~b ![Code]~c',
                  'green': '[Code]~b [Code]~c ![Code]~e ![Code]~f ![Code]~s',
                  },
            '5': {'type': 'Text',
                  'title': 'Observation',
                  'width': 1,
                  'red': '[Code]~b ![Code]~c',
                  'green': '[Code]~b [Code]~c ![Code]~e ![Code]~f ![Code]~s',
                  },
            },
        rw_page # Change to ro_user if you wan these values not modifiable.
        )
    # Define table attributes :
    table.table_attr(rw_page, 'default_nr_columns', 6)

def init(table):
    table.contains_users = 0

def create_catalog():
    utilities.mkpath('TMP/0/COMPETENCES')
    file_name = 'INF.js'
    with open('TMP/0/COMPETENCES/' + file_name, mode='w', encoding='utf-8') as f:
        configuration.get_catalog_json.cache = ('', 0)
        configuration.get_catalog.cache = ('', 0)
        f.write(f'''
        let student_catalog = new Catalog();
        student_catalog.parse_dict({configuration.get_catalog_json()});
        ''')

def cell_change(_table, _page, _col, _lin, _value, _date):
    """Clear the JSON catalog cache"""
    if configuration.regtest:
        create_catalog()
    else:
        utilities.start_job(create_catalog, 2)
