var data_col_mail = 4, data_col_mail_adm = 5, data_col_status = 3; // Defined by P.py
var P_options = {};
var P_tip;
var P_opts = 'subject header item footer duration abi_content abi_cc to1 to2 to3 mail_from student_rule to1_rule to2_rule to3_rule pc_abi'.split(' ');

function send_invitation() {
}

function template_init() {
    if (table_attr.masters.join('') === '') {
        table_attr_set("masters", my_identity);
        the_current_cell.update_table_headers();
    }

    var ues = document.createElement('SCRIPT');
    ues.src = '_FILES_/all_ues.js';
    the_body.appendChild(ues);

    var infos = document.getElementById('content_' + _("TAB_table_info"));
    if (i_am_the_teacher)
        infos.innerHTML =
            _("Attendance_help")
                .replace('{0}', 'javascript:manage_abi()')
                .replace('{1}', 'javascript:P_manage_message()')
                .replace('{2}', add_ticket('P_reporting/' + year + '/' + ue)
                    + '" target="_blank');
    else
        infos.innerHTML = _('P_not_allowed').replace('{}', table_attr.masters.join(', '));

    select_tab("table", _("TAB_table_info"));

    // Parse options
    try {
        P_options = JSON.parse(columns[data_col_mail].comment);
    }
    catch (error) {
    }
    // Add missing options
    for (var i in P_opts) {
        var opt = P_opts[i];
        if (P_options[opt] === undefined) {
            var key = 'P_' + opt + '_default';
            P_options[opt] = _(key) != key ? _(key) : '';
        }
    }
    if (P_options.duration === '')
        P_options.duration = '30';
    allowed_grades[abi + '@'] = [abi, abi + _("MSG_abj_sent")];
    allowed_grades[abj + '@'] = [abj, abj + _("MSG_abj_sent")];
}

function Item(value, data) {
    this.value = value;
    this.data = data;
    this.content = [];
}

Item.prototype.html = function (texts, hide_tr) {
    if (!hide_tr)
        texts.push('<tr>');
    texts.push('<td id="', this.id(),
        '" onclick="P_toggle(this)" onmouseenter="P_enter(this)" onmouseout="P_out(this)" rowspan="',
        this.nr_lines(), '">',
        html(this.value).replace(/\n/g, '<br>'));
    for (var i in this.content)
        this.content[i].html(texts, true);
    if (this.content.length == 0) {
        var what = this.abi_or_abj()
        texts.push(
            '<td><select onchange="P_toggle()">'
            + '<option' + (what == abi ? ' selected' : '') + '>' + abi
            + '</option><option' + (what == abj ? ' selected' : '') + '>' + abj
            + '</option><option>' + pre
            + '</option><option>' + _("COL_TITLE_empty")
            + '</option><option>' + abi + '@'
            + '</option><option>' + abj + '@'
            + '</option><select></tr>');
    }
};

// For leave, data=line_id and parent.parent.data=column
Item.prototype.abi_or_abj = function () {
    return lines[this.data][this.parent.parent.data.data_col].value;
};

Item.prototype.current_abi_or_abj = function () {
    var item = document.getElementById(this.id());
    var select = item.nextSibling.getElementsByTagName('SELECT')[0];
    var value = select.value;
    select.style.background = value != this.abi_or_abj() ? '#F88' : '';
    return value;
};

Item.prototype.toggle = function () {
    if (this.state == 'P_send') {
        this.state = 'P_not_send';
        return;
    }
    if (this.content.length == 0) {
        var value = this.current_abi_or_abj();
        if (value != abi && value != abj)
            return;
    }
    this.state = 'P_send';
};

Item.prototype.nr_lines = function () {
    if (this.content.length == 0)
        return 1;
    var sum = 0;
    for (var i in this.content)
        sum += this.content[i].nr_lines();
    return sum;
};

Item.prototype.search = function (value) {
    for (var i in this.content)
        if (this.content[i].value == value)
            return this.content[i];
    return this.push(new Item(value));
};

Item.prototype.push = function (item) {
    item.index = this.content.length;
    this.content.push(item);
    item.parent = this;
    return item;
};

Item.prototype.id = function () {
    if (this.parent)
        return this.parent.id() + '/' + this.index;
    return 'PATH';
};

Item.prototype.item_from_id = function (path) {
    path = path.replace('PATH/', '').split('/');
    var item = this;
    for (var i in path)
        item = item.content[Number(path[i])];
    return item;
};

Item.prototype.apply = function (fct) {
    for (var i in this.content)
        this.content[i].apply(fct);
    if (this.parent)
        fct(this);
};

Item.prototype.get_mails = function () {
    var line = lines[this.data];
    var data_col = this.parent.parent.data.data_col;
    var value = this.current_abi_or_abj();
    if (this.state != 'P_send')
        return [];
    var mails = [];
    if (line[data_col_status].value.match(P_options.student_rule)) {
        if (P_send_to_contact && line[data_col_mail].value)
            mails.push(line[data_col_mail].value.trim() + '@@CC@@' + table_attr.mails[line[0].value]);
        if (P_send_to_adm && line[data_col_mail_adm].value.toString().indexOf('@') != -1)
            mails.push(line[data_col_mail_adm].value.trim() + '@@CC@@' + table_attr.mails[line[0].value]);
    }
    for (var i = 1; i <= 3; i++)
        if (line[data_col_status].value.match(P_options['to' + i + '_rule']))
            mails.push(P_options['to' + i].trim());
    return mails;
};

function is_a_date_column(column) {
    return column.title.match(/^[-0-9:h _]*$/);
}

var P_abis;

function manage_abi() {
    // Create tree
    P_abis = new Item('');
    for (var data_col in columns) {
        var column = columns[data_col];
        if (!is_a_date_column(column))
            continue;
        var day = new Item(column.title, column);
        for (var i in filtered_lines) {
            var line = filtered_lines[i];
            if (line[0].value === '')
                continue;
            var comment = line[data_col].comment.split('#')[0].split(' ');
            var qrcode = day.search(comment.join(', '));
            var cell = line[data_col];
            var date = cell.history.length ? cell.history[0][1] : cell.date;
            if (qrcode.min === undefined)
                qrcode.max = qrcode.min = date;
            else if (date < qrcode.min)
                qrcode.min = date;
            else if (date > qrcode.max)
                qrcode.max = date;
            if (comment[4] !== undefined)
                qrcode.duration = Number(comment[4]);
            if (line[data_col].value != abi && line[data_col].value != abj)
                continue;
            var status = line[data_col_status].value;
            if (!status.match(P_options.student_rule)
                && !status.match(P_options.to1_rule)
                && !status.match(P_options.to2_rule)
                && !status.match(P_options.to3_rule))
                continue; // No mails, so skip this student

            var mail = table_attr.mails[line[0].value];
            // Keep double space for parsing
            qrcode.push(new Item(
                line[0].value + '  ' + line[1].value.toUpperCase() + '  ' + title_case(line[2].value)
                + '  ' + (mail || ''),
                line.line_id))
        }
        // Remove days without ABI nor ABJ
        var content = [];
        for (var i in day.content)
            if (day.content[i].content.length) {
                day.content[i].index = content.length;
                content.push(day.content[i]);
            }
        day.content = content;
        if (day.content.length)
            P_abis.push(day);
    }
    var html = ['<style>',
        'DIV.import_div { left: 5%; right: 5%; top: 5%; bottom: 5% }',
        '.manage_abi > DIV { height: calc(100% - 2em); overflow: auto; }',
        '.manage_abi TD, .manage_abi { border: 1px solid #BBB}',
        '.manage_abi TD:hover { border-color: #000}',
        '.manage_abi TD { vertical-align: top; padding: 0.1em }',
        'DIV.import_export TABLE.manage_abi { border-spacing: 0px; width: auto;}',
        'TD { transition: background 1s }',
        '.P_not_send { }',
        '.P_send { background: #FF8 }',
        '#P_button { font-size: 70%; vertical-align: top; margin-bottom: 1em }',
        '#P_tip { position: absolute; background: #FFF; z-index: 1 }',
        '.manage_abi SELECT { float: right }',
        '.send_to { display: inline-block; font-weight: normal; font-size: 70% }',
        '.send_to LABEL:hover { background: #FFF }',
        '.send_to INPUT:checked + SPAN { background: #FF0 }',
        '</style>',
        '<div>',
        '<table class="manage_abi">'
    ];
    for (var i in P_abis.content)
        P_abis.content[i].html(html);
    html.push('</table></div><pre id="P_tip"></pre>');
    var choice = '';
    if (year >= 2022 || data_col_from_col_title(_("TITLE_student_contact_adm")))
        choice = '<div class="send_to" onclick="P_update_send_to()"><label><input type="radio" checked name="send_to" value="1"><span>'
            + _("TITLE_student_contact").replace(/_/g, ' ')
            + '</span></label><label><input type="radio" name="send_to" value="2"><span>'
            + _("TITLE_student_contact_adm").replace(/_/g, ' ')
            + '</span></label><label><input type="radio" name="send_to" value="3"><span>'
            + _("TITLE_student_contact").replace(/_/g, ' ') + " + "
            + _("TITLE_student_contact_adm").replace(/_/g, ' ')
            + '</span></label></div>';
    create_popup('import_div',
        '<button id="P_button" onclick="P_button()" disabled>'
        + _("Attendance_button").replace('{0}', 0).replace('{1}', '')
        + '</button>' + choice,
        html.join(''), '', false);
    P_abis.apply(function (item) {
        item.state = 'P_not_send';
        item.element = document.getElementById(item.id());
    });
    P_tip = document.getElementById('P_tip');
}

function P_toggle(element) {
    if (element) {
        var item = P_abis.item_from_id(element.id);
        item.apply(function (item) {
            item.toggle();
        });
        P_enter(item.element); // update opacity
    }
    var counters = {}, to_send = 0;
    P_abis.apply(function (item) {
        if (item.content.length) {
            item.state = item.content[0].state;
            for (var i in item.content)
                if (item.content[i].state != item.state) {
                    item.state = 'P_not_send';
                    break;
                }
        }
        else {
            var old_val = item.abi_or_abj();
            var new_val = item.current_abi_or_abj();
            if (old_val != new_val) {
                var key = old_val + '→' + new_val;
                if (counters[key])
                    counters[key] += 1;
                else
                    counters[key] = 1;
            }
            if (new_val != abi && new_val != abj)
                item.state = 'P_not_send';
            if (item.state == 'P_send')
                to_send += 1;
        }
        item.element.className = item.state;
    });
    var txt = '';
    for (key in counters)
        txt += ' ' + counters[key] + ':' + key;
    document.getElementById('P_button').innerHTML = _("Attendance_button")
        .replace('{0}', to_send).replace('{1}', txt);
    document.getElementById('P_button').disabled = (txt === '' && to_send == 0);
}

function P_enter(element) {
    var item = P_abis.item_from_id(element.id);
    if (item.content.length)
        return;
    var tip = P_message('[ue_title]\n[start] → [end]\n[duration_in_hours] h', item);
    switch (item.state) {
        case 'P_send':
            tip = '<span class="P_send">';
            var mails = item.get_mails();
            for (var i in mails)
                tip += _('Mail') + ' → ' + mails[i].replace('@@CC@@', ' CC:') + '\n';
            tip += '</span>'
                + P_options.header + "\n\n" + P_message(P_options.item, item)
                + "\n\n" + P_options.footer;
            break;
        case 'P_not_send':
            tip = '';
            break;
    }
    var table = element;
    while (table.tagName != 'TABLE')
        table = table.parentNode;
    P_tip.innerHTML = tip;
    P_tip.style.left = element.offsetLeft + element.offsetWidth + 'px';
    P_tip.style.top = table.offsetTop + element.offsetTop + 'px';
}

function P_out(_element) {
    P_tip.innerHTML = '';
}


ue_title = {};
function UE(name, _responsable, intitule, _parcours, _code, _login,
    _nr_students_ue, _nr_students_ec, _planning, _tt, _credit, _old_names) {
    ue_title[name] = intitule;
}

function get_ue_title(code) {
    return ue_title[code] || ue_title[code.replace(/^[^-]*-/, '')] || '???';
}

function P_message(format, item) {
    var comment = item.parent.value.split(/, /);

    if (comment.length < 4)
        comment = ['', '', '', ''];

    var infos = item.value.split(/  /);
    var delta = Number(P_options.duration);
    var round = 60 * delta; // seconds
    // Full course duration, not student attendance duration.
    var min = get_date_tomuss(item.parent.min);
    var max = get_date_tomuss(item.parent.max);
    var duration = Math.round((max.getTime() - min.getTime()) / 1000 / round) * round;
    if (item.parent.duration)
        duration = 60 * item.parent.duration;
    min.setMinutes(Math.round(min.getMinutes() / delta) * delta);
    max.setMinutes(Math.round(max.getMinutes() / delta) * delta);

    return format
        .replace('[student_id]', infos[0])
        .replace('[student_surname]', infos[1])
        .replace('[student_firstname]', infos[2])
        .replace('[student_mail]', infos[3])
        .replace('[ue_code]', comment[0])
        .replace('[ue_title]', comment[0] ? get_ue_title(comment[0]) : '')
        .replace('[teacher]', comment[1].split('@')[0])
        .replace('[td]', comment[2].split('#')[0])
        .replace('[start]', min.formate('%A %d %B %H:%M'))
        .replace('[end]', max.formate('%A %d %B %H:%M'))
        .replace('[day]', max.formate('%A %P %d %B'))
        .replace('[duration_in_hours]', duration / 3600);
}

var P_send_to_contact = 1
var P_send_to_adm = 0;

function P_update_send_to() {
    var radioButtons = document.getElementsByName('send_to');
    if (radioButtons)
        for (var i in radioButtons) {
            if (radioButtons[i].checked) {
                P_send_to_contact = radioButtons[i].value & 1;
                P_send_to_adm = radioButtons[i].value & 2;
                break;
            }
        }
}

function P_button() {
    var content_per_mail = {};
    var subject_per_mail = {};
    P_abis.apply(function (item) {
        if (item.content.length)
            return;
        var line_id = item.data;
        var line = lines[line_id];
        var data_col = item.parent.parent.data.data_col;
        var value = item.current_abi_or_abj();
        if (item.state == 'P_send') {
            var mails = item.get_mails();
            for (var i in mails) {
                var mail = mails[i].split('@@CC@@')[0].trim();
                if (content_per_mail[mail] === undefined) {
                    content_per_mail[mail] = [];
                    subject_per_mail[mail] = [];
                }
                var msg = P_message(P_options.item, item);
                if (myindex(content_per_mail[mail], msg) >= 0)
                    return; // Duplicate message (2 ABI on the same half day)
                content_per_mail[mail].push(msg);
                var name = P_message('[student_firstname] [student_surname]', item);
                if (myindex(subject_per_mail[mail], name) < 0)
                    subject_per_mail[mail].push(name);
            }
            cell_set_value_real(line_id, data_col, value + "@");
        }
        else
            if (value != item.abi_or_abj()) {
                if (value == _("COL_TITLE_empty"))
                    value = '';
                cell_set_value_real(line_id, data_col, value);
            }
    });
    table_fill(true, false, true);
    popup_close();

    var mails = [];
    var cc = [];
    for (var mail in content_per_mail) {
        if (mail === '')
            continue;
        var to_and_cc = mail.split('@@CC@@');
        var student_cc = to_and_cc.length > 1 ? ' ' + to_and_cc[1] : '';
        mails.push(to_and_cc[0]
            + '\002' + subject_per_mail[mail].join(', ')
            + '\002' + content_per_mail[mail].join('\n\n')
        );
        cc.push(table_attr.mails[my_identity] + student_cc);
    }
    if (mails.length == 0)
        return;
    var d = {
        'subject': P_options.subject,
        'message': P_options.header + "\n\n[Content]\n\n" + P_options.footer,
        'recipients': mails.join("\001"),
        'titles': 'NameList\001Content',
        'archive': 'None',
        'cc': cc.join('\001')
    };
    if (P_options.mail_from.trim() !== '')
        d.reply = P_options.mail_from;

    do_post_data(d, add_ticket('send_mail'));
}

function P_manage_message() {
    var texts = ['<div class="scroll">'];
    var template = "<table>"
        + "<tr><td>{subject}<br>{header}<br>{item}<br>{footer}"
        + "<table>"
        + "<tr><td>{to1}<td>{to1_rule}</tr>"
        + "<tr><td>{to2}<td>{to2_rule}</tr>"
        + "<tr><td>{to3}<td>{to3_rule}</tr>"
        + "</table>"
        + "{mail_from}"
        + "<td>{abi_content}<br>{student_rule}<br>{abi_cc}"
        + "<td>{duration}<br>{pc_abi}</tr></table>";
    for (var i in P_opts) {
        var opt = P_opts[i];
        rows = opt.substr(0, 2) == 'to'
            ? 1
            : (P_options[opt].replace(/[^\n]+/g, '').length * 2);
        template = template.replace('{' + opt + '}',
            '<p>' + _('P_' + opt) + '</p>'
            + '<textarea class="_' + opt + '" rows="' + rows + '">'
            + html(P_options[opt]) + '</textarea>');
    }
    texts.push(template);
    texts.push('</div>')
    create_popup('import_div',
        '<style>DIV.import_export { top: 10% ; bottom: 10%; z-index: 31 }'
        + 'DIV.import_export DIV.scroll { height: calc(100% - 4em); overflow: auto }'
        + 'BUTTON { font-size: 100%; margin-bottom: 1em; }'
        + 'TABLE TD { vertical-align: top }'
        + 'DIV.import_export TEXTAREA { width: calc(100% - 1em) }</style>'
        + _('Configuration')
        + ' <button onclick="P_record_messages()">' + _("LABEL_save") + '</button>',
        texts.join(''), '', false);
}

function P_record_messages() {
    var texts = popup_get_element().getElementsByTagName('TEXTAREA');
    for (var i = 0; i < texts.length; i++)
        P_options[texts[i].className.substr(1)] = texts[i].value;
    column_attr_set(columns[data_col_mail], "comment", JSON.stringify(P_options));
    popup_close();
}

column_attributes['type'].default_value = 'Prst';

function P_author_courses_list() {
    // Spaces for JS string sort
    var infos = [{}, {}, {}, {}, { ' 60': true, ' 90': true, '120': true, '180': true }];
    var qrcode_id = -1;
    for (var data_col in columns) {
        var column = columns[data_col];
        if (column.type != 'Prst')
            continue;
        for (var line_id in lines) {
            var cell = lines[line_id][data_col];
            if (!cell.comment)
                continue;
            var comment = cell.comment.split('#')[0].split(/ /);
            for (var i = 0; i < 5; i++)
                if (comment[i] !== undefined)
                    infos[i][comment[i]] = true;
            if (cell.comment.indexOf('#') != -1)
                qrcode_id = Math.min(qrcode_id, Number(cell.comment.replace(/.*#/, '')))
        }
    }
    var sorted = [];
    for (var i in infos) {
        var values = [];
        for (var value in infos[i])
            values.push(value);
        values.sort();
        sorted.push(values);
    }
    sorted.push(qrcode_id);
    return sorted;
}

function P_create_completion(sorted, value) {
    var table = [];
    for (var i in sorted)
        if (sorted[i].toLowerCase().substr(0, value.length) == value.toLowerCase())
            table.push([sorted[i], '', '', '', sorted[i]]);
    return table;
}

function teacher_complete(input) {
    return P_create_completion(P_author_courses_list()[1], input.value);
}

function duration_complete(input) {
    return P_create_completion(P_author_courses_list()[4], input.value);
}

function P_last_week() {
    var date = new Date();
    var dates = [];
    for (var i = -6; i <= 0; i++) {
        var d = new Date();
        d.setTime(date.getTime() + i * 86400000);
        dates.push(d);
    }
    return dates;
}

function date_complete(input) {
    var dates = [];
    var possibles = P_last_week();
    var value = input.value;
    for (var i in possibles) {
        var date = possibles[i].formate('%A %d/%m/%Y');
        if (date.toLowerCase().substr(0, value.length) == value.toLowerCase())
            dates.push([date, '', '', '', date]);
    }
    return dates;
}

function P_course_list() {
    var infos = P_author_courses_list();
    var courses = [];
    for (var i in infos[0]) {
        var code = infos[0][i];
        var title = ue_title[code] || ue_title[code.replace(/[^-]*-/, '')] || '?';
        courses.push(title + ' ' + code);
    }
    return courses;
}

function course_complete(input) {
    var courses = [];
    var possibles = P_course_list();
    var value = input.value;
    for (var i in possibles) {
        var course = possibles[i];
        if (course.toLowerCase().substr(0, value.length) == value.toLowerCase())
            courses.push([course, '', '', '', course]);
    }
    return courses;
}

var P_attributes = [
    ["date",
        function (v) { return v.replace(/.* /, ''); },
        function (values) {
            var formated_date = get_date(values[0]);
            if (formated_date === false)
                return _("ALERT_invalid_value") + values[0];
            formated_date = formated_date.formate('%Y-%m-%d');
            var title = formated_date + '_' + values[1] + ':' + values[2];
            if (data_col_from_col_title(title) !== undefined)
                return _("P_new_slot_yet") + ' : ' + title;
        }
    ],
    ["hour",
        function (v) { return v < 10 ? '0' + Number(v) : v; },
        function (values) {
            return values[1] >= 0 && values[1] <= 23 ? '' : _("ALERT_invalid_value") + values[1];
        }
    ],
    ["minute",
        function (v) { return v < 10 ? '0' + Number(v) : v; },
        function (values) {
            return values[2] >= 0 && values[2] <= 59 ? '' : _("ALERT_invalid_value") + values[2];
        }
    ],
    ["duration",
        function (v) { return v; },
        function (values) {
            return values[3] >= 5 && values[3] <= 600 ? '' : _("ALERT_invalid_value") + values[3];
        }
    ],
    ["course",
        function (v) { return v.replace(/.* /, ''); }
    ],
    ["teacher",
        test_nothing,
        function (values) {
            return values[5].indexOf(' ') == -1 ? '' : _("ALERT_invalid_value") + values[5];
        }
    ]
];

var P_need_update;
var P_current_values;

function P_analyse() {
    var cells = document.getElementById('P_inputs');
    if (!cells)
        return false;
    if (!P_need_update)
        return true;
    P_need_update = false;
    var color = 'initial';
    cells = cells.cells;
    var error = '', i_error = 999, values = [];
    for (var i in P_attributes) {
        var input = cells[i].firstChild;
        var value = input.value;
        if (value === '' && error === '') {
            i_error = i;
            error = _('P_new_slot_' + P_attributes[i][0] + '_');
            color = '#FF8';
        }
        values.push(P_attributes[i][1](value));
        input.style.background = '#FFF';
    }
    for (var i in P_attributes)
        if (i < i_error && P_attributes[i][2]) {
            var err = P_attributes[i][2](values);
            if (err && err !== '') {
                error = err;
                i_error = i;
                color = '#F88';
            }
        }
    if (error !== '')
        cells[i_error].firstChild.style.background = color;

    var feedback = document.getElementById('P_feedback');
    feedback.innerHTML = error;
    feedback.style.background = error !== '' ? '#F44' : 'initial';
    document.getElementById('P_button').disabled = error !== '';
    P_current_values = values;

    return true;
}

function P_create_column() {
    P_analyse();
    var date = get_date(P_current_values[0]).formate('%Y-%m-%d')
    var hour = P_current_values[1] + ':' + P_current_values[2];
    var title = date + '_' + hour;
    var column = popup_column();
    column_attr_set(column, 'title', title);
    column['type'] = 'Note';
    column_attr_set(column, 'type', 'Prst', undefined, true);
    var cls = column_list_all();
    for (var i in cls)
        if (columns[cls[i]].type == 'Prst' && columns[cls[i]].title > title) {
            column_attr_set(column, 'position',
                (columns[cls[i - 1]].position + columns[cls[i]].position) / 2);
            Alert('P_new_slot_order');
            break;
        }
    comment_change(popup_get_element().line_id, column.data_col,
        P_current_values[4] + ' ' + P_current_values[5] + ' ? ? ' + P_current_values[3]
        + '#' + (P_author_courses_list()[5] - 1)
    );
    the_current_cell.do_update_column_headers = true;
    the_current_cell.update_headers();
    table_fill(false, true, true, true);
    popup_close();
}

function P_button_input(button) {
    var cells = document.getElementById('P_inputs').cells;
    cells[button.parentNode.parentNode.cellIndex].firstChild.value = button.innerText;
}

function modification_allowed_on_this_line(line_id, data_col, value) {
    if (value === '')
        return true;
    var column = columns[data_col];
    if (column_empty_of_user_cells(data_col)
        && (value == pre || value == abi || value == abj)) {
        var infos = P_author_courses_list();
        var authors = [];
        for (var i in infos[1])
            authors.push('<button tabindex="-1" onclick="P_button_input(this)">' + html(infos[1][i]) + '</button>');
        var courses = [];
        var possibles = P_course_list();
        for (var i in possibles)
            courses.push('<button tabindex="-1" onclick="P_button_input(this)">'
                + html(possibles[i]) + '</button>');

        var durations = [];
        for (var i in infos[4])
            durations.push('<button tabindex="-1" onclick="P_button_input(this)">' + html(infos[4][i]) + '</button>');
        var hours = [];
        for (var i = 7; i < 21; i++) {
            hours.push('<button tabindex="-1" onclick="P_button_input(this)"'
                + (i == 8 || i == 14 ? ' style="font-weight: bold"' : '')
                + '>' + (i < 10 ? '0' + i : i) + '</button>');
        }
        var minutes = [];
        for (var i = 0; i < 60; i += 5) {
            minutes.push('<button tabindex="-1" onclick="P_button_input(this)"'
                + (i % 15 ? '' : ' style="font-weight: bold"')
                + '>' + (i < 10 ? '0' + i : i) + '</button>');
        }
        var possibles = P_last_week();
        var dates = [];
        for (var i in possibles) {
            var date = possibles[i];
            dates.push(
                '<button tabindex="-1" onclick="P_button_input(this)"'
                + (date.getDay() == 0 || date.getDay() == 6 ? '' : ' style="font-weight: bold"')
                + '>'
                + date.formate('%A %d/%m/%Y')
                + '</button>')
        }
        create_popup('import_div P_div', _('P_new_slot'),
            '<style>'
            + 'DIV.import_export.P_div { left: 5% ; top: 5%; right: auto; max-height:80%; padding-bottom: 2.5em; }'
            + 'DIV.import_export.P_div BUTTON { font-size: 100%; overflow: hidden }'
            + 'DIV.import_export TABLE.P_new_slot { width: 70em; table-layout: fixed }'
            + 'TABLE.P_new_slot TD { vertical-align: top ; padding: 1px }'
            + 'TABLE.P_new_slot TR.P_lists TD P {'
            + '    overflow: auto; line-height: 1.8em; height: 60vh; max-height: 26em;}'
            + 'TABLE.P_new_slot TD * { text-align: left; width: 100% }'
            + 'TABLE.P_new_slot TD:nth-child(1) * { text-align: right }'
            + 'TABLE.P_new_slot TD:nth-child(1) * { text-align: right }'
            + 'TABLE.P_new_slot TD:nth-child(2) * { text-align: right }'
            + 'TABLE.P_new_slot TD:nth-child(3) * { text-align: left }'
            + 'TABLE.P_new_slot TD:nth-child(4) * { text-align: right }'
            // + 'TABLE.P_new_slot TD:nth-child(5) * { text-align: right }'
            + 'TABLE.P_new_slot TD BUTTON { text-align: left; white-space: nowrap }'
            + 'TABLE.P_new_slot INPUT { padding-left: 0.2em ; padding-right: 0.2em; }'
            + '</style>'
            + '<table class="P_new_slot" onkeyup="P_need_update=true" onmouseup="P_need_update=true">'
            + '<colgroup>'
            + '<col width="8em">'
            + '<col width="2em">'
            + '<col width="1.5em">'
            + '<col width="2em">'
            + '<col width="20em">'
            + '<col width="8em">'
            + '</colgroup>'
            + '<tr>'
            + '<th>' + _('P_new_slot_date')
            + '<th>' + _('P_new_slot_hour')
            + '<th>' + _('P_new_slot_minute')
            + '<th>' + _('P_new_slot_duration')
            + '<th>' + _('P_new_slot_course')
            + '<th>' + _('P_new_slot_teacher')
            + '</tr><tr id="P_inputs">'
            + '<td><input get_completion_list="date_complete">'
            + '<td><input>'
            + '<td><input>'
            + '<td><input get_completion_list="duration_complete">'
            + '<td><input get_completion_list="course_complete">'
            + '<td><input get_completion_list="teacher_complete">'
            + '</tr><tr class="P_lists">'
            + '<td><p tabindex="-1">' + dates.join('<br>')
            + '<td><p tabindex="-1">' + hours.join('<br>')
            + '<td><p tabindex="-1">' + minutes.join('<br>')
            + '<td><p tabindex="-1">' + durations.join('<br>')
            + '<td><p tabindex="-1">' + courses.join('<br>')
            + '<td><p tabindex="-1">' + authors.join('<br>')
            + '</tr></table>'
            + '<button id="P_button" onclick="P_create_column()" style="position:absolute; right: 0.3em; bottom: 0.2em; z-index:1">'
            + _('P_new_slot_create') + '</button>'
            + '<p id="P_feedback" style="color:#FFF;position: absolute; bottom: 0px;left: 0px; right: 0px; padding: 0.5em"></p>'
            , '', false);
        popup_get_element().line_id = the_current_cell.line_id;
        periodic_work_add(P_analyse);
        setTimeout(function () { document.getElementById('P_inputs').firstChild.firstChild.focus(); },
            200);
        P_need_update = true;
        return true;
    }

    if (!is_a_date_column(column))
        return true;
    if (lines[line_id][data_col].comment !== '')
        return true;
    var comments = [];
    for (var i in lines) {
        var comment = lines[i][data_col].comment;
        if (comment === '')
            continue;
        if (comments.indexOf(comment) == -1)
            comments.push(comment);
    }
    if (comments.length == 0)
        return false;
    if (comments.length == 1) {
        the_current_cell.cell.comment = comments[0];
        append_image(the_current_cell.td, 'comment_change/' + column.the_id + '/'
            + line_id + "/" + encode_uri(comments[0]));
        return true;
    }
    comments.sort();
    var t = '';
    for (var i in comments)
        t += '(' + (Number(i) + 1) + ') ' + comments[i] + '\n';

    i = prompt(t + _("COL_TITLE_your_choice") + ' : 1, 2, …');
    if (isNaN(i) || i < 1 || i > comments.length)
        return false;

    the_current_cell.cell.comment = comments[i - 1];
    append_image(the_current_cell.td, 'comment_change/' + column.the_id + '/'
        + line_id + "/" + encode_uri(comments[i - 1]));
    return true;
}